      subroutine alias

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  alias    Updated     2005 April 5 17:45.
c               alias    Originated  1994 May 11 16:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display and create alias pairs.
c
c     Logic:    Entry points:  alias.
c alias         Called by:  helpall, main, synonym.
c
c alias         Calls:  alout, aptchap, aptchfp, aptchfs, aptchmv, aptsubr,
c               incrsubs, namechk, symbout, synout, alias.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.

      character*1  adel               ! Character ' or ".
      character*1  adel1              ! Character '.
      character*1  adel2              ! Character ".
      character*80 awordx             ! Word 2, possibly with subscript.

c=======================================================================********

c.... Input line:  alias [help]

 8110 format ('  Command "alias":  acceptable input lines include:' /
     &  '  "alias [help]" Display this message.' /
     &  '  "alias all"    Display all alias pairs.' /
     &  '  "alias list [ANAME1 ANAME2 ANAME3 ...]"' /
     &  '     Display the alias pairs for all listed aliases' /
     &  '     (the default is all aliases).' /
     &  '  "alias ANAME"' /
     &  '     Display the alias pair for alias ANAME.' //
     &  '  "alias ANAME = '' ''"' /
     &  '     Remove alias ANAME.' //
     &  '  "alias ANAME = ''STRING''"' /
     &  '     In subsequent input lines, replace all first-word',
     &  ' occurrences' /
     &  '     of alias ANAME by the entire string STRING.' )

 8112 format (/
     &  '  Note:  use +/- for ANAME to incr/decr the last alias',
     &  ' name:  ',a //
     &  '  Synonyms:  [", '' (in pairs)], [alias, al, a], [help, h].' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        write (   6, 8112) alias1s
        write (iout, 8112) alias1s
        go to 999
      endif

c=======================================================================********

c.... Input line:  alias all
c.... Input line:  alias list

 8120 format (/ 'Number of aliases = ',i5)

      if (((aword(2) .eq. 'all')   .or.
     &     (aword(2) .eq. 'list')) .and.
     &     (nword .eq. 2))         then
        naliasx = 0
        call alout (1, nalias)
        do 120 n = 1, nalias
          if (alias1(n) .eq. ' ') go to 120
          naliasx = naliasx + 1
  120   continue
        write (   6, 8120) naliasx
        write (iout, 8120) naliasx
        go to 999
      endif

c=======================================================================********

c.... Input line:  alias list ANAME1 ANAME2 ANAME3 ...

 8130 format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Named alias does not exist:  ',a)

      if (aword(2) .eq. 'list') then
        do 140 nw = 3, nword
          nfind = 0
          do 130 n = 1, nalias
            call aptsubr (alias1(n), 1, 24, 80, astem, lstem,
     &                    asub, lsub, nerra)
            if ((aword(nw) .eq. alias1(n)) .or.
     &          (aword(nw) .eq. astem))    then
              nfind = nfind + 1
              call alout (n, n)
            endif
  130     continue
          if (nfind .eq. 0) then
            write (   6, 8130) ainput, ninput, aword(nw)
            write (iout, 8130) ainput, ninput, aword(nw)
          endif

  140   continue
        go to 999
      endif

c=======================================================================********

c.... Input line:  alias ANAME

      if (nword .eq. 2) then
        do 150 n = 1, nalias
          if (aword(2) .eq. alias1(n)) then
            call alout (n, n)
            go to 999
          endif
  150   continue
        write (   6, 8130) ainput, ninput, aword(2)
        write (iout, 8130) ainput, ninput, aword(2)
        go to 999
      endif

c=======================================================================********

c.... Test input for validity.

 8150 format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of alias not from 1 to 24 characters:  ',a)

      if ((lword(2) .lt. 1) .or. (lword(2) .gt. 24)) then
        write (   6, 8150) ainput, ninput, aword(2)
        write (iout, 8150) ainput, ninput, aword(2)
        go to 999
      endif

c=======================================================================********

c.... See if last alias name should be incremented and used.

 8128 format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of last alias can not be incremented:  ',a)

      if (aword(2) .eq. '+') then
        aword(2) = alias1s
        lword(2) = lalias1s
        call incrsubs (1, aword(2), 1, lword(2), nerra)
        if (nerra .ne. 0) then
          write (   6, 8128) ainput, ninput, alias1s
          write (iout, 8128) ainput, ninput, alias1s
          go to 999
        endif
      endif

 8129 format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of last alias can not be decremented:  ',a)

      if (aword(2) .eq. '-') then
        aword(2) = alias1s
        lword(2) = lalias1s
        call incrsubs (-1, aword(2), 1, lword(2), nerra)
        if (nerra .ne. 0) then
          write (   6, 8129) ainput, ninput, alias1s
          write (iout, 8129) ainput, ninput, alias1s
          go to 999
        endif
      endif

 8905 format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of alias too dangerous to use:  ',a)

      call namechk (aword(2), lword(2), nerrchk)

      if (nerrchk .ne. 0) then
        write (   6, 8905) ainput, ninput, aword(2)
        write (iout, 8905) ainput, ninput, aword(2)
        go to 999
      endif

c===============================================================================

c.... See if alias exists.

 8160 format ('  WARNING:  replacing existing alias:  ',a)

      nrep = 0                        ! Flag, 1 if replacing existing alias.

      do 160 n = 1, nalias
        if (aword(2) .eq. alias1(n)) then
          nrep = 1
          write (   6, 8160) alias1(n)
          write (iout, 8160) alias1(n)
          call alout (n, n)
          go to 180
        endif
  160 continue

      do 170 n = 1, nalias
        if (alias1(n) .eq. ' ') go to 180
  170 continue

      nalias = nalias + 1

 8170 format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of aliases exceeds limit ',i5)

      if (nalias .gt. naliasm) then
        nalias = naliasm
        write (   6, 8170) ainput, ninput, naliasm
        write (iout, 8170) ainput, ninput, naliasm
        go to 999
      endif

      n = nalias

c=======================================================================********

c.... Input line:  alias ANAME = ''
c.... Input line:  alias ANAME = 'STRING'

c.... Find the alias of this string.

  180 if (aword(3) .eq. '=') then

        nerr  = 0

c....   Find the first word in the input line (alias, al or a).

        call aptchfs (achar, 80, 1, 80, aword(1), lwords(1),
     &    isym, nerra)

c....   Find the second word in the input line (the aliased word).

        isrce  = isym + lword(1) + 1
        nchar2 = 81 - isrce

        awordx = aword(2)
        lwordx = lword(2)

        call aptchfs (achar, 80, isrce, nchar2, aword(2), lwords(2),
     &                isym, nerra)

        if (aword(2) .eq. '+') then
          aword(2) = alias1s
          lword(2) = lalias1s
          call incrsubs (1, aword(2), 1, lword(2), nerra)
        endif

        if (aword(2) .eq. '-') then
          aword(2) = alias1s
          lword(2) = lalias1s
          call incrsubs (-1, aword(2), 1, lword(2), nerra)
        endif

c....   Find the third word in the input line (the character "=").

        isrce  = isym + lword(2) + 1
        nchar3 = 81 - isrce

        call aptchfs (achar, 80, isrce, nchar3, aword(3), lword(3),
     &                isym, nerra)

c....   Find the first ' or " following word 3 in the input line.

        adel1  = ''''
        adel2  = '"'

        isrce  = isym + lword(3) + 1
        nchar3 = 81 - isrce

        call aptchfp (achar, isrce, nchar3, adel1, 1, ipat11, nerra)
        call aptchfp (achar, isrce, nchar3, adel2, 1, ipat12, nerra)

 8180   format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Right side of alias missing first ',a1,' or ',a1,'.')

        if ((ipat11 .gt. 0)  .and.
     &      (ipat12 .gt. 0)) then
          if( ipat11 .lt. ipat12) then
            ipat1 = ipat11
            adel  = adel1
          else
            ipat1 = ipat12
            adel  = adel2
          endif
        elseif (ipat11 .gt. 0) then
          ipat1 = ipat11
          adel  = adel1
        elseif (ipat12 .gt. 0) then
          ipat1 = ipat12
          adel  = adel2
        else
          ipat1 = 0
          adel  = adel1
          write (   6, 8180) ainput, ninput, adel1, adel2
          write (iout, 8180) ainput, ninput, adel1, adel2
          nerr = 1
        endif

c....   Test for extra words or characters before first bracketing ' or ".

 8182   format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Extra words or characters before first bracketing ',a1,'.')

        isrce = ipat1 - 1

        call aptchap (achar, 1, isrce, nwordm, afd,
     &                iamax, idmax, iemax, aword, iword, fword,
     &                mtype, lword, nword, nerra)

        if (aword(2) .eq. '+') then
          aword(2) = alias1s
          lword(2) = lalias1s
          call incrsubs (1, aword(2), 1, lword(2), nerra)
        endif

        if (aword(2) .eq. '-') then
          aword(2) = alias1s
          lword(2) = lalias1s
          call incrsubs (-1, aword(2), 1, lword(2), nerra)
        endif

        if (nword .gt. 3) then
          write (   6, 8182) ainput, ninput, adel
          write (iout, 8182) ainput, ninput, adel
          nerr = 1
        endif

c....   Find the second unduplicated ' or " in the input line.

 8184   format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Right side of alias missing second ',a1,'.')

        ipat2 = 0                     ! Character position of second ' or ".
        if (ipat1 .ne. 0) then

          isrce  = ipat1 + 1
          nchar2 = 80 - ipat1

  182     call aptchfp (achar, isrce, nchar2, adel, 1, ipat2, nerra)

          if (ipat2 .eq. 0) then
            write (   6, 8184) ainput, ninput, adel
            write (iout, 8184) ainput, ninput, adel
            nerr = 1
          elseif ((ipat2 .lt. 80)             .and.
     &            (achar(ipat2+1) .eq. adel)) then
            do 184 nc = ipat2, 79
              achar(nc) = achar(nc+1)
  184       continue
            achar(80) = ' '
            isrce = ipat2 + 1
            nchar2 = 81 - isrce
            go to 182
          endif

        endif

c....   Test for extra characters after second bracketing ' or ".

 8185   format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Extra characters after second bracketing ',a1,'.' )

        if ((ipat2 .ne. 0)   .and.
     &      (ipat2 .lt. 80)) then

          do 185 nc = ipat2 + 1, 80
            if (achar(nc) .ne. ' ') then
              write (   6, 8185) ainput, ninput, adel
              write (iout, 8185) ainput, ninput, adel
              nerr = 1
            endif
  185     continue

        endif

        if (nerr .ne. 0) go to 200

c....   Test for removal of the alias.

        do 190 nc = ipat1 + 1, ipat2 - 1
          if (achar(nc) .ne. ' ') go to 200
  190   continue

 8190   format ('  Deleted alias:  ',a)

        if (nrep .eq. 1) then
          write (   6, 8190) alias1(n)
          write (iout, 8190) alias1(n)
          alias1(n) = ' '
        else
          write (   6, 8130) ainput, ninput, aword(2)
          write (iout, 8130) ainput, ninput, aword(2)
          nerr = 1
        endif
        go to 999

c....   Make sure alias name is not the same as a symbol name.

 8192   format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Name same as a symbol name:  ',a)

        do 555 ns = 1, nsymbs
          if (aword(2) .eq. asymbl(n)) then
            write (   6, 8192) ainput, ninput, aword(2)
            write (iout, 8192) ainput, ninput, aword(2)
            nerr = 1
          endif
  555   continue

c....   Test for errors.

  200   if (nerr .ne. 0) then
          if (nrep .eq. 0) then
            if (n .eq. nalias) nalias = nalias - 1
          endif
          go to 999
        endif

c....   Store the alias.

        alias1(n) = awordx
        alias1s   = awordx
        lalias1s  = lwordx

        nchar2     = ipat2 - ipat1 - 1
        lalias2(n) = nchar2
        ipat1      = ipat1 + 1

        alias2(n) = ' '
        call aptchmv (achar, ipat1, nchar2, alias2(n), 1, nerra)

c....   Print the alias specifications.

        call alout (n, n)

c....   See if a synonym already exists with this alias name.

 8210   format ('  alias WARNING.  Reading ',a40,' line ',i5,'.' /
     &    '  A preset synonym has the same name.' )

          do 210 ns = 1, nsyns
            if ((alias1(n) .eq. asyn1(ns))  .or.
     &          (alias1(n) .eq. asyn2(ns))) then
              write (   6, 8210) ainput, ninput
              write (iout, 8210) ainput, ninput
              call synout (ns, ns)
            endif
  210     continue

c....   See if a symbol already exists with this alias name.

 8220   format ('  alias WARNING.  Reading ',a40,' line ',i5,'.' /
     &    '  A symbol or its replacement has the same name.' )

          do 220 ns = 1, nsymbs
            if ((alias1(n) .eq. asymbl(ns))  .or.
     &          (alias1(n) .eq. asymbr(ns))) then
              write (   6, 8220) ainput, ninput
              write (iout, 8220) ainput, ninput
              call symbout (ns, ns)
            endif
  220     continue

        go to 999

      endif                           ! Command "alias ANAME = 'STRING'.

c=======================================================================********

 8200   format ('  alias ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Input line is not recognized.')

        write (   6, 8200) ainput, ninput
        write (iout, 8200) ainput, ninput

c=======================================================================********

  999 return

c.... End of subroutine alias.        (+1 line)
      end
