      subroutine aliasget (awordx, kalias)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  aliasget Updated     2004 November 23 13:30.
c               aliasget Originated  1994 May 11 16:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find an alias and substitute the expanded form.
c
c     Logic:    Entry points:  aliasget.
c aliasget      Called by:  main.
c
c aliasget      Calls:  aptchap, aptchmv.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*24  awordx            ! Word for which to search for alias.
      character*24  awordxx           ! Initial awordx.
      character*240 aliasx            ! Alias + rest of input line.
      dimension     acharx(160)       ! Characters in aliasx.
      character*1   acharx            ! Characters in aliasx.
      equivalence  (acharx, aliasx)   ! Characters in aliasx.
cbugc***DEBUG begins.
cbug 9700 format (/ 'ALIASGET input:')
cbug 9701 format ('ALIASGET DEBUG.  achar (80 char on next line):' / 80a1)
cbug 9702 format ('ALIASGET DEBUG.  NWORD = ',i5 )
cbug 9703 format (
cbug     &  '  I     = ',i5,' LWORD = ',i5,' MTYPE = ',i5,' IWORD = ',i5 /
cbug     &  '  AWORD = ',a70 )
cbug      write (   6, 9700)
cbug      write (iout, 9700)
cbug      write (   6, 9701) (achar(i), i = 1, 80)
cbug      write (iout, 9701) (achar(i), i = 1, 80)
cbug      write (   6, 9702) nword
cbug      write (iout, 9702) nword
cbug      do 9791 i = 1, nword
cbug      write (   6, 9703) i, lword(i), mtype(i), iword(i), aword(i)
cbug      write (iout, 9703) i, lword(i), mtype(i), iword(i), aword(i)
cbug 9791 continue
cbugc***DEBUG ends.

c.... Initialize.

      nsubst  = 0
      awordxx = awordx

 8150 format ('  aliasget ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  More than 10 consecutive alias replacements.')

  150 nsubst = nsubst + 1
      if (nsubst .gt. 10) then
        write (   6, 8150) ainput, ninput
        write (iout, 8150) ainput, ninput
        kalias = -1
        go to 999
      endif

      kalias = 0                      ! Have not found an alias.

c.... See if an alias exists.  If so, substitute it for the input line.
c.... Display the new input line.

 8155 format (/ 'aliasget reading     ',a40,' line ',i8,'.' )
 8160 format ('Before substituting alias:' / '<',80a1)

      do 180 n = 1, nalias            ! Loop over aliases.
        if (awordx .ne. alias1(n)) go to 180

c....   Find the last non-delimiter character in input line.

        do 105 nx = ncharm, 1, -1
          if ((achar(nx) .ne. ' ') .and.
     &        (achar(nx) .ne. afd))  then
            ilast = nx
            go to 108
          endif
  105   continue
  108   continue
cbugc____ DEBUG begins.
cbug 9801 format ('ALIASGET DEBUG.  Input line:' / 80a1)
cbug      write (   6, 9801) (achar(nn), nn = 1, ncharm)
cbug      write (iout, 9801) (achar(nn), nn = 1, ncharm)
cbug 9802 format ('ALIASGET DEBUG.  # of characters in input line = ',i3)
cbug      write (   6, 9802) ilast
cbug      write (iout, 9802) ilast
cbugc____ DEBUG ends.

        if (ainput .ne. 'tty') then
          if (nsubst .eq. 1) then
            write (   6, 8155) ainput, ninput
            write (iout, 8155) ainput, ninput
          endif
          write (   6, 8160) (achar(i), i = 1, ilast)
        endif

        write (iout, 8160) (achar(i), i = 1, ilast)

        aliasx = alias2(n)

cbugc____ DEBUG begins.
cbug      call alout (n, n)
cbugc____ DEBUG ends.

c....   Find the last non-delimiter character in alias2.

        do 160 nx = 80, 1, -1
          if ((acharx(nx) .ne. ' ')   .and.
     &        (acharx(nx) .ne. afd))  then
            ilastx = nx
            go to 170
          endif
  160   continue
  170   continue
cbugc____ DEBUG begins.
cbug 9803 format ('ALIASGET DEBUG.  aliasx:' / a)
cbug      write (   6, 9803) aliasx
cbug      write (iout, 9803) aliasx
cbug 9804 format ('ALIASGET DEBUG.  # of characters in alias2 = ',i3)
cbug      write (   6, 9804) ilastx
cbug      write (iout, 9804) ilastx
cbugc____ DEBUG ends.

c....   Find the first character of the first word in the input line.

        ifirst = 1
        if (afd .eq. ' ') then
          do 110 nx = 1, ncharm
            if (achar(nx) .eq. ' ') go to 110
            ifirst = nx
            go to 112
  110     continue
  112     continue
        endif
cbugc____ DEBUG begins.
cbug 9900 format ('ALIASGET DEBUG 0.  ifirst=',i3,' ilast=',i3)
cbug      write (   6, 9900) ifirst, ilast
cbug      write (iout, 9900) ifirst, ilast
cbugc____ DEBUG ends.

c....   Add the rest of input line to aliasx, up to total of ncharm characters.

        itake = ifirst + lword(1)
        ncharx = ilast - itake + 1    ! Number of characters in rest of line.
cbugc____ DEBUG begins.
cbug 9901 format ('ALIASGET DEBUG 1.  aliasx = "',a,'"')
cbug      write (   6, 9901) aliasx
cbug      write (iout, 9901) aliasx
cbugc____ DEBUG ends.

 8170   format ('  aliasget ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of characters in aliased input line > ',i3)

        ncharnew = ilastx + ncharx    ! Number of characters in new line.

        if ((ilastx + ncharx) .gt. ncharm) then
          write (   6, 8170) ainput, ninput, ncharm
          write (iout, 8170) ainput, ninput, ncharm
          kalias = -1
          go to 999
        endif

        iput = ilastx + 1

        call aptchmv (achar, itake, ncharx, aliasx, iput, nerra)
cbugc____ DEBUG begins.
cbug 9902 format ('ALIASGET DEBUG 2.  aliasx = "',a,'"')
cbug      write (   6, 9902) aliasx
cbug      write (iout, 9902) aliasx
cbugc____ DEBUG ends.

        call aptchap (aliasx, 1, ncharm, nwordm, afd,
     &                iamax, idmax, iemax, aword, iword, fword,
     &                mtype, lword, nword, nerra)

 8180   format ('After  substituting alias:' / '<',80a1)

cold        if (nerra .eq. 0) then

          kalias = 1                  ! Found a match, substituted alias.

          call aptchmv (aliasx, 1, ncharm, achar, 1, nerra)

          write (   6, 8180) (acharx(i), i = 1, ncharnew)
          write (iout, 8180) (acharx(i), i = 1, ncharnew)

cold        else                          ! Error cracking input line.
cold
cold 8190     format ('  aliasget ERROR.  Reading ',a40,' line ',i5,'.' /
cold     &      '  Error in aptchap cracking input line.  nerra = ',i2)
cold
cold          write (   6, 8190) ainput, ninput, nerra
cold          write (iout, 8190) ainput, ninput, nerra
cold          kalias = -1
cold          go to 999
cold
cold        endif

        go to 190

  180 continue                        ! End of loop over aliases.

  190 if (awordx .eq. awordxx) go to 999
      if (kalias .eq. 1) go to 150

  999 continue
cbugc***DEBUG begins.
cbug 9795 format (/ 'ALIASGET results:')
cbug      write (   6, 9795)
cbug      write (iout, 9795)
cbug      write (   6, 9701) (achar(i), i = 1, 80)
cbug      write (iout, 9701) (achar(i), i = 1, 80)
cbug      write (   6, 9702) nword
cbug      write (iout, 9702) nword
cbug      do 9792 i = 1, nword
cbug      write (   6, 9703) i, lword(i), mtype(i), iword(i), aword(i)
cbug      write (iout, 9703) i, lword(i), mtype(i), iword(i), aword(i)
cbug 9792 continue
cbugc***DEBUG ends.

      return

c.... End of subroutine aliasget.     (+1 line)
      end
