      subroutine bigcopy (nb1, nb2, nerrcopy)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  bigcopy  Updated      2006 April 11 17:00.
c               bigcopy  Originated   2005 July 29 18:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To copy big integer abig(nb1), stored as an array of base
c               10 single decimal digits, over another big integer abig(nb2),
c               which may or may not initially be zero.
c               The length ndig(nb1) of abig(nb1) must be at least 1.
c               If big integer abig(nb1) is zero, then ndig(nb1) must be 1 and
c               idig(1,nbig1) must be zero.
c
c     Logic:    Entry points:  bigcopy.
c bigcopy       Called by:  bigint.
c
c bigcopy       Calls:  bigout.
c               Called by:  bigint.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*8 amount

c.... Test for errors.

      nerrcopy = 0

      if (nb1 .lt. 1) then
        nerrcopy = 1
        go to 999
      endif

      if (nb2 .gt. nbigm) then
        nerrcopy = 2
        go to 999
      endif

      if (ndig(nb1) .le. 0) then
        nerrcopy = 3
        go to 999
      endif

c.... See if big integer to be written over already exists.

 8210   format ('  big WARNING.  Reading ',a40,' line ',i5,'.' /
     &    '  Copying over existing big number:  ',a )
 8220   format ('  big WARNING.  Reading ',a40,' line ',i5,'.' /
     &    '  Copying over itself does NOTHING:  ',a )

      if ((ndig(nb2) .gt. 1) .or.
     &    ((ndig(nb2) .eq. 1) .and. (idig(1,nb2) .ne. 0))) then

        write (   6, 8210) ainput, ninput, abig(nb2)
        write (iout, 8210) ainput, ninput, abig(nb2)

        amount = 'minimum'
        call bigout (nb2, nb2, amount)

      endif                           ! Copying over existing big number.

      if (nb1 .eq. nb2) then

        write (   6, 8220) ainput, ninput, abig(nb2)
        write (iout, 8210) ainput, ninput, abig(nb2)

        go to 999
      endif

      abigtag(nb2) = abigtag(nb1)
      asign(nb2)   = asign(nb1)
      ndig(nb2)    = ndig(nb1)

      do n = 1, ndig(nb1)
        idig(n,nb2) = idig(n,nb1)
      enddo

  999 return

c.... End of subroutine bigcopy.      (+1 line)
      end
