      subroutine brstore (nrep, n)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  brstore  Updated     1994 August 5 16:40.
c               brstore  Originated  1994 August 5 16:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find the index in the brick array in which to store the
c               brick being created.
c
c     Logic:    Entry point:  brstore.
c brstore       Called by:  brick.
c
c brstore       Calls:  brout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     n         Output   0 if brick array is full.  No room for a new brick.
c                          Positive if the index where the new brick is to
c                          be stored.
c
c     nrep      Output   0 if brick name is new, 1 if an old brick with the
c                          same name is being replaced.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*8 amount              ! Amount of output data.

      n = 0

c.... See if the brick name already exists.

 8110 format ('  WARNING:  replacing existing brick:  ',a)

      nrep = 0

      do 110 nb = 1, nbricks
        if (aword(2) .eq. abrick(nb)) then
          nrep = 1
          n = nb
          write (   6, 8110) abrick(nb)
          write (iout, 8110) abrick(nb)
          amount = 'minimum'
          call brout (nb, nb, amount)
          go to 999
        endif
  110 continue

c.... See if a null brick can be replaced.

      do 120 nb = 1, nbricks
        if (abrick(nb) .eq. ' ') then
          n = nb
          go to 999
        endif
  120 continue

c.... See if the maximum number of bricks has been exceeded.

 8130 format ('  brstore ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of bricks exceeds limit ',i5)

      if ((nbricks + 1) .gt. nbrickm) then
        write (   6, 8130) ainput, ninput, nbrickm
        write (iout, 8130) ainput, ninput, nbrickm
        n = 0
        go to 999
      endif

c.... Add a new brick at the end of the list.

      nbricks = nbricks + 1

      n = nbricks

c=======================================================================********

  999 return

c.... End of subroutine brstore.      (+1 line)
      end
