      subroutine define

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  define   Updated     2006 May 26 14:00.
c               define   Originated  1994 May 27 13:20.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the entry from geom_base specified by the user.
c
c     Logic:    Entry points:  define.
c define        Called by:  helpall, main.
c
c define        Calls:  aptchap, aptchfp, aptchfs, aptchmv, aptchrp, openx.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.

      common /lhelp/ aname(8)         ! The full path name of geom_base.
      character*80   aname            ! The full path name of geom_base.
      common /lhelp/ awordx(10)       ! Words in file geom_base.
      character*80   awordx           ! Words in file geom_base.
      common /lhelp/ aworda           ! ENTRY, in lower case.
      character*80   aworda           ! ENTRY, in lower case.
      common /lhelp/ awordb           ! Word in file geom_base, in lower case.
      character*80   awordb           ! Word in file geom_base, in lower case.
      common /lhelp/ achold           ! Characters to be replaced.
      character*32   achold           ! Characters to be replaced.
      common /lhelp/ achnew           ! Characters to replace old characters.
      character*32   achnew           ! Characters to replace old characters.
      Common /lhelp/ afirst           ! Character in column 7 of geom_base.
      character*1    afirst           ! Character in column 7 of geom_base.

      common /lhelp/ adel             ! Delimiter for ENTRY, ' or ".
      character*1    adel             ! Delimiter for ENTRY, ' or ".
      common /lhelp/ adel1            ! Delimiter for ENTRY, '.
      character*1    adel1            ! Delimiter for ENTRY, '.
      common /lhelp/ adel2            ! Delimiter for ENTRY, ".
      character*1    adel2            ! Delimiter for ENTRY, ".

      common /lhelp/ atype            ! File type, 'text".
      character*8    atype            ! File type, 'text".

      common /lhelp/ aword19          ! ENTRY, in lower case, 19 characters.
      character*19   aword19          ! ENTRY, in lower case, 19 characters.


      common /lhelp/ awordxx          ! Unused.  Fills last word.
      character*4    awordxx          ! Unused.  Fills last word.

c=======================================================================********

c.... Input line:  define [help]

 8110 format ('  Command "define":  acceptable input lines include:' /
     &  '  "define [help]"   Display this message.' //
     &  '  "define ''ENTRY''"  Display entry ENTRY in file geom_base.' /
     &  '     ENTRY may have up to 19 characters.  Case is ignored.' /
     &  '     Search in geom_base columns 7-25.' //
     &  '     Use to define a command, key word, input value, etc.' /
     &  '     If ENTRY is a single character, the first line of all',
     &  ' entries' /
     &  '     beginning with that character will be displayed.' //
     &  '  Synonyms:  [", '' (in pairs)], [define, def], [help, h].' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        go to 999
      endif

c=======================================================================********

c.... Input line:  define 'ENTRY'

c.... Find the first word in the input line (define or def).

      call aptchfs (achar, 80, 1, 80, aword(1), lword(1), isym, nerra)

c.... Find the first ' or " following word 1 in the input line.

      adel1 = ''''
      adel2 = '"'

      isrce  = isym + lword(1) + 1
      nchar2 = 81 - isrce

      call aptchfp (achar, isrce, nchar2, adel1, 1, ipat11, nerra)
      call aptchfp (achar, isrce, nchar2, adel2, 1, ipat12, nerra)

 8125 format ('  define ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  ENTRY missing first ',a1,' or ',a1,'.')

      if ((ipat11 .gt. 0)  .and.
     &    (ipat12 .gt. 0)) then
        if( ipat11 .lt. ipat12) then
          ipat1 = ipat11
          adel  = adel1
        else
          ipat1 = ipat12
          adel  = adel2
        endif
      elseif (ipat11 .gt. 0) then
        ipat1 = ipat11
        adel  = adel1
      elseif (ipat12 .gt. 0) then
        ipat1 = ipat12
        adel  = adel2
      else
        ipat1 = 0
        adel  = adel1
        write (   6, 8125) ainput, ninput, adel1, adel2
        write (iout, 8125) ainput, ninput, adel1, adel2
        go to 999
      endif

c.... Test for extra words or characters before first bracketing ' or ".

 8126 format ('  define ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Extra words or characters before first bracketing ',a1,'.')

      isrce = ipat1 - 1

      call aptchap (achar, 1, isrce, nwordm, afd,
     &              iamax, idmax, iemax, aword, iword, fword,
     &              mtype, lword, nword, nerra)

      if (nword .gt. 1) then
        write (   6, 8126) ainput, ninput, adel
        write (iout, 8126) ainput, ninput, adel
        go to 999
      endif

c.... Find the second unduplicated ' or " in the input line.

 8130 format ('  define ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Entry missing second ',a1,'.')

      ipat2 = 0                       ! Character position of second ' or ".
      if (ipat1 .ne. 0) then

        isrce  = ipat1 + 1
        nchar2 = 80 - ipat1

  130   call aptchfp (achar, isrce, nchar2, adel, 1, ipat2, nerra)

        if (ipat2 .eq. 0) then
          write (   6, 8130) ainput, ninput, adel
          write (iout, 8130) ainput, ninput, adel
          go to 999
        elseif (achar(ipat2+1) .eq. adel) then
          do 140 nc = ipat2, 79
            achar(nc) = achar(nc+1)
  140     continue
          achar(80) = ' '
          isrce = ipat2 + 1
          nchar2 = 81 - isrce
          go to 130
        endif

      endif

c.... Test for extra characters after second bracketing ' or ".

 8150 format ('  define ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Extra characters after second bracketing ',a1,'.' )

      if (ipat2 .ne. 0) then

        do 150 nc = ipat2 + 1, 80
          if (achar(nc) .ne. ' ') then
            write (   6, 8150) ainput, ninput, adel
            write (iout, 8150) ainput, ninput, adel
            go to 999
          endif
  150   continue

      endif

c.... Store the entry.

      nchar2 = ipat2 - ipat1 - 1
      ipat1  = ipat1 + 1

      lworda = nchar2
      aworda = ' '
      call aptchmv (achar, ipat1, nchar2, aworda, 1, nerra)
cbugc***DEBUG begins.
cbug 9101 format ('define DEBUG.  nbug=',i3,' lworda=',i3,' aworda =',a)
cbug      nbug = 1
cbug      write (iout, 9101) nbug, lworda, aworda
cbugc***DEBUG ends.

c.... Open file geom_base.                                   (User's copy)

      aname(1) = 'geom_base'
      aname(2) = '~/geom_base'
      aname(3) = '~/geom/geom_base'
      aname(4) = '~/geom/doc/geom_base'
      aname(5) = '~/work/geom/doc/geom_base'
      aname(6) = '~edwards/work/geom/doc/geom_base'
      aname(7) = '~edwards/work/geom/doc/geom.base'
      aname(8) = 'geom.base'

      do 155 nn = 1, 8                ! Try to open geom_base.

        close (4)

        atype = 'text'
        isize = 0
        call openx (4, aname(nn), atype, -1, isize)

 8200   format ('  define WARNING.  Reading ',a40,' line ',i5,'.' /
     &    '  Input file does not exist:  ',a)

        if (isize .eq. -1) then
          write (   6, 8200) ainput, ninput, aname(nn)
          write (iout, 8200) ainput, ninput, aname(nn)
          go to 155
        endif

        go to 160

  155 continue

      go to 999

c.... Found geom_base.

 8205 format ('Opened file:  ',a)

  160 write (   6, 8205) aname(nn)
      write (iout, 8205) aname(nn)

c.... Convert the search pattern to the first 19 characters, in lower case.

      achold = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
      achnew = 'abcdefghijklmnopqrstuvwxyz'

      call aptchrp (aworda, 1, 80, achold, achnew, 26, nerra)

      aword19 = aworda
      aworda  = aword19
cbugc***DEBUG begins.
cbug      nbug = 2
cbug      write (iout, 9101) nbug, lworda, aworda
cbugc***DEBUG ends.

      ifound = 0

c.... Return here te test the first line of each entry in geom_base.

 8210 format (a6,a19,a2,6a8,a5)

  210 read (unit=4, fmt=8210, err=220, end=220) (awordx(n), n = 1, 10)

      awordb = awordx(2)

c.... Test columns 7-25 of the first line of each entry.

      if (awordb .eq. ' ') go to 210  ! Not the first line of an entry.

c.... Convert the entry name to lower case.

      call aptchrp (awordb, 1, 80, achold, achnew, 26, nerra)
cbugc***DEBUG begins.
cbug 9102 format ('define DEBUG. nbug=',i3,' awordb=',a)
cbug      nbug = 3
cbug      write (iout, 9102) nbug, awordb
cbugc***DEBUG ends.

c.... Compare the search pattern to the entry name.

      if (awordb .ne. aworda) then

c....   Display all entries with first letter matching single input character.

        afirst = awordb
cbugc***DEBUG begins.
cbug 9103 format ('define DEBUG. nbug=',i3,' afirst=',a)
cbug      nbug = 4
cbug      write (iout, 9103) nbug, afirst
cbugc***DEBUG ends.
        if (afirst .eq. aworda) then
          write (   6, 8210) (awordx(n), n = 1, 10)
          write (iout, 8210) (awordx(n), n = 1, 10)
          if (lworda .eq. 1) ifound = 1
        endif

        go to 210
      endif

c.... Found an entry matching the search pattern. 

      ifound = 1

c.... Read and display the body of the entry.

  230 write (   6, 8210) (awordx(n), n = 1, 10)
      write (iout, 8210) (awordx(n), n = 1, 10)

      read (unit=4, fmt=8210, err=220, end=220) (awordx(n), n = 1, 10)

      awordb = awordx(2)
      call aptchrp (awordb, 1, 19, achold, achnew, 26, nerra)
cbugc***DEBUG begins.
cbug      nbug = 5
cbug      write (iout, 9102) nbug, awordb
cbugc***DEBUG ends.

c.... Quit looking if the first line of an entry is not a match.

      afirst = awordb
      if ((awordb .ne. ' ')       .and.
     &    (awordb .ne. aworda)) then
      afirst = awordb
cbugc***DEBUG begins.
cbug      nbug = 6
cbug      write (iout, 9103) nbug, afirst
cbugc***DEBUG ends.
        if (afirst .eq. aworda) then
          write (   6, 8210) (awordx(n), n = 1, 10)
          write (iout, 8210) (awordx(n), n = 1, 10)
          if (lworda .eq. 1) then
            ifound = 1
            go to 210
          endif
        endif
        go to 220
      endif                           ! Found non-matching entry.

c.... Keep looking if in the body of an entry.

      go to 230

 8220 format ('  define ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Entry does not exist:  ',a)

  220 if (ifound .eq. 0) then
        write (   6, 8220) ainput, ninput, aworda
        write (iout, 8220) ainput, ninput, aworda
      endif

      close (4)

c=======================================================================********

  999 return

c.... End of subroutine define.       (+1 line)
      end
