      subroutine helpall

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  helpall  Updated     2006 March 7 18:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the help messages for all commands.
c
c     Logic:    Entry points:  helpall.
c helpall       Called by:  main.
c
c helpall       Calls:  accel, alias, aloha, angles, arc, area, axisym, base,
c               bigint, bin, bisectx, brick, circle, cluster, cone, contfr,
c               coord, copy, cross, crt, cute, cuts, cylinder, debugx, define,
c               delete, delim, disk, distance, doenddo, dot, ellipsoid,
c               extrema, factor, ffeed, helpalph, helpenv, helperr, helpgen,
c               helpmath, helpmisc, helpobj, helpran, hex, hyperb, icalc,
c               ifendif, incr, indo, input, intcirc, iris, kiss, last, line,
c               list, marker, matrix, mcvol, mesh, movex, operator, output,
c               parse, pdf, plane, point, polygon, polyhed, project, prompt,
c               prox, quadric, ratio, redo, renamex, repack, root, rootf, roots,
c               sample, search, side, slice, solve, sort, sphere, spin, synonym,
c               tables, tetra, timex, title, tolset, track, triangle, trig,
c               triple, twist, undo, variable, vector, volume, walk, when,
c               where, zone.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.

      character*80 ainputx

c.... Input line:  help all

c.... Temporarily replace ainput with blank, to force full help message output
c....   in each command subroutine.

      ainputx = ainput
      ainput  = ' '

c.... Call the subroutines for the general help messages.

      call ffeed (iout)
      call helpgen

      call ffeed (iout)
      call helpalph

      call ffeed (iout)
      call helpenv

      call ffeed (iout)
      call helperr

      call ffeed (iout)
      call helpmath

      call ffeed (iout)
      call helpmisc

      call ffeed (iout)
      call helpobj

      call ffeed (iout)
      call helpran

c.... Call the command subroutines to get specific help messages.

      nword    = 2
      aword(1) = 'COMMAND'
      aword(2) = 'help'

      call ffeed (iout)
      call accel

      call ffeed (iout)
      call alias

      call ffeed (iout)
      call aloha

      call ffeed (iout)
      call angles

      call ffeed (iout)
      call arc

      call ffeed (iout)
      call area

      call ffeed (iout)
      call axisym

      call ffeed (iout)
      call base

      call ffeed (iout)
      call bigint

      call ffeed (iout)
      call bin

      call ffeed (iout)
      call bisectx

      aword(1) = 'COMMAND'

      call ffeed (iout)
      call brick

      call ffeed (iout)
      call circle

      call ffeed (iout)
      call cluster

      call ffeed (iout)
      call cone

      call ffeed (iout)
      call contfr

      call ffeed (iout)
      call coord

      call ffeed (iout)
      call copy

      call ffeed (iout)
      call cross

      call ffeed (iout)
      call crt

      call ffeed (iout)
      call cute

      call ffeed (iout)
      call cuts

      call ffeed (iout)
      call cylinder

      call ffeed (iout)
      call debugx

      call ffeed (iout)
      call define

      call ffeed (iout)
      call angles                     ! For command "degrees".

      call ffeed (iout)
      call delete

      call ffeed (iout)
      call delim

      call ffeed (iout)
      call disk

      call ffeed (iout)
      call distance

      call ffeed (iout)
      call doenddo

      call ffeed (iout)
      call dot

      call ffeed (iout)
      call ellipsoid

      call ffeed (iout)
      call extrema

      call ffeed (iout)
      call factor

      call ffeed (iout)
      call hex

      call ffeed (iout)
      call hyperb

      call ffeed (iout)
      call icalc

      call ffeed (iout)
      call ifendif

      call ffeed (iout)
      call incr

      call ffeed (iout)
      call indo
      nword = 2

      call ffeed (iout)
      call input

      call ffeed (iout)
      call intcirc

      call ffeed (iout)
      aword(1) = 'invert'
      call matrix                     ! For command "invert".
      aword(1) = 'COMMAND'

      call ffeed (iout)
      call iris

      call ffeed (iout)
      call kiss

      call ffeed (iout)
      call last

      call ffeed (iout)
      call line

      call ffeed (iout)
      call list

      call ffeed (iout)
      call marker

      call ffeed (iout)
      call mcvol

      call ffeed (iout)
      call mesh

      call ffeed (iout)
      call movex                      ! For command "move".

      aword(1) = 'COMMAND'

      call ffeed (iout)
      call operator

      call ffeed (iout)
      call output

      call ffeed (iout)
      call parse

      call ffeed (iout)
      call pdf

      call ffeed (iout)
      call plane

      call ffeed (iout)
      call point

      call ffeed (iout)
      call polygon

      call ffeed (iout)
      call polyhed

      call ffeed (iout)
      call project

      call ffeed (iout)
      call prompt

      call ffeed (iout)
      call prox

      call ffeed (iout)
      call quadric

      call ffeed (iout)
      call angles                     ! For command "radians".

      call ffeed (iout)
      call ratio

      call ffeed (iout)
      call redo
      nword = 2

      call ffeed (iout)
      aword(1) = 'reflect'
      call matrix                     ! For command "reflect".
      aword(1) = 'COMMAND'

      call ffeed (iout)
      call renamex                    ! For command "rename".

      call ffeed (iout)
      call repack

      call ffeed (iout)
      call root

      call ffeed (iout)
      call rootf

      call ffeed (iout)
      call roots

      call ffeed (iout)
      aword(1) = 'rotate'
      call matrix                     ! For command "rotate".
      aword(1) = 'COMMAND'

      call ffeed (iout)
      call sample

      call ffeed (iout)
      aword(1) = 'scale'
      call matrix                     ! For command "scale".
      aword(1) = 'COMMAND'

      call ffeed (iout)
      call search

      call ffeed (iout)
      call side

      call ffeed (iout)
      call slice

      call ffeed (iout)
      call solve

      call ffeed (iout)
      call sort

      call ffeed (iout)
      call sphere

      call ffeed (iout)
      call spin

      call ffeed (iout)
      call sudo

      call ffeed (iout)
      call synonym

      call ffeed (iout)
      call tables

      call ffeed (iout)
      call tetra

      nword    = 2
      aword(1) = 'COMMAND'
      aword(2) = 'help'

      call ffeed (iout)
      call timex

      call ffeed (iout)
      call title

      call ffeed (iout)
      call tolset                     ! For command "tol".

      call ffeed (iout)
      call track

      call ffeed (iout)
      call triangle

      call ffeed (iout)
      call trig

      call ffeed (iout)
      call triple

      call ffeed (iout)
      call twist

      call ffeed (iout)
      call undo

      call ffeed (iout)
      call variable

      call ffeed (iout)
      call vector

      call ffeed (iout)
      call volume

      call ffeed (iout)
      call walk

      call ffeed (iout)
      call when

      call ffeed (iout)
      call where

      call ffeed (iout)
      call zone

c.... Restore the name of the input medium.

  999 ainput = ainputx

      return

c.... End of subroutine helpall.      (+1 line)
      end
