      subroutine helpenv

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  helpenv  Updated     2004 June 4 14:00.
c               helpenv  Originated  1994 September 23 10:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display a help message for environment commands.
c
c     Logic:    Entry points:  helpenv.
c helpenv       Called by:  helpall, main.
c               Calls:  (none).
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Input line:  help environment
c.... Input line:  environment [help]

c.... Help message.

 8110 format (/ '  Environment commands include:' //
     &  '  status, stat              Display title, I/O files,'
     &  ' environmental parameters.' /
     &  '  title, id                 Display problem title.' /
     &  '  prompt                    Switch between long and short',
     &  ' prompts.' /
     &  '  when                      Display code date and run date.' /
     &  '  time, t                   Display time charged to problem.' /
     &  '  .                         Repeat previous command.' /
     &  '  input, in, i, read, rd, r Display/repeat previous',
     &  ' commands.' /
     &  '  input, in, i, read, rd, r Specify/display input medium.'/
     &  '  input conv.mac            Display or read metric conversion',
     &  ' factors.' /
     &  '  return, rtn               Return to last input medium.' /
     &  '  output, out, o, wr, w     Specify/display output file.' /
     &  '  trace                     Display input medium return',
     &  ' path.' /
     &  '  plot                      Specify plot parameters,',
     &  ' make plots.' /
     &  '  marker, mark, m           Specify/display markers and their',
     &  ' text.' /
     &  '  delimiter, delim          Specify/display field',
     &  ' delimiter.' /
     &  '  ; (unquoted)              Separates commands, comments, on',
     &  ' same input line.' /
     &  '                            Not after ".", "input", "read" or'
     &  ' "return".' /
     &  '                            Not after "indo", "redo" or'
     &  ' "undo".' /
     &  '  coordinate, coord, cs     Specify/display coordinate',
     &  ' system.' /
     &  '  angles, angle, ang        Specify/display/convert'
     &  ' angle units.' /
     &  '  tol                       Specify/display numerical',
     &  ' tolerance limit.' )

 8112 format (
     &  '  define                    Define a command, key word or',
     &  ' variable.' /
     &  '  tables, sizes             Display command name and max',
     &  ' number for objects.' /
     &  '  commands, comm, alph      Display all command words,'
     &  ' including synonyms.' /
     &  '  synonym, syn              Display synonyms of commands,',
     &  ' key words.' /
     &  '  symbol, symb, sym         Create/display a symbol with',
     &  ' a replacement.' /
     &  '  search, find              Search for an object with a',
     &  ' specified name or value.' /
     &  '  alias, al, a              Create/display aliases.' /
     &  '  variable, var, set, s     Create/display named',
     &  ' variables, do math.' /
     &  '  icalc                     Specify mode of integer input and'
     &  ' output in icalc.' /
     &  '  c or C (before blank)     Comment line.' /
     &  '  cc, CC (columns 1 and 2)  Comment line.' /
     &  '  cxxxx, Cxxxx (< blank)    Comment line (x = "+", "-" or',
     &  ' "_").' /
     &  '  #, *, / (column 1)        Comment line.' /
     &  '  ! (following command)     Begins appended comment.' /
     &  '  page                      Insert page restore symbol "^L"',
     &  ' into output file.' )

 8114 format (
     &  '  undo, u                   Undo the last command(s).' /
     &  '  indo                      Redo a command, with',
     &  ' increments.' /
     &  '  redo                      Redo a command, with',
     &  ' replacements.' /
     &  '  if/endif                  Specify/end a conditional block.' /
     &  '  do/enddo                  Specify/end a do loop.' /
     &  '  vi                        Open text editor vi to display',
     &  ' and/or edit a file.' /
     &  '  lock                      Lock and unlock GEOM.' /
     &  '  end, exit, quit, split    End the run.  Exit from GEOM.' )

        write (   6, 8110)
        write (iout, 8110)
        write (   6, 8112)
        write (iout, 8112)
        write (   6, 8114)
        write (iout, 8114)

      return

c.... End of subroutine helpenv.      (+1 line)
      end
