      subroutine incrsubs (incr, asrce, isrce, nchar, nerra)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  incrsubs Updated     2005 February 2 18:00.
c               incrsubs Originated  2003 July 11 17:15.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To increment ASCII string asrce, or the first numerical
c               subscript in ASCII string asrce, or integer asrce, by incr
c               characters or digits.
c
c     Logic:    Entry points:  incrsubs.
c incrsubs      Called by:  alias, axisym, bigint, bin, brick, cluster, cone,
c               copy, cylinder, disk, ellipsoid, hyperb, incr, indo, line,
c               marker, meshblk, operator, pdf, plane, point, polygon,
c               polyhed, ptoper, quadric, qumove, quoper, renamex, sphere,
c               symbol, tetra, triangle, variable, vector, voper, zone.
c
c incrsubs      Calls:  aptchia, aptchin, aptchmv, aptsubm.
c
c     Biblio:   ?
c
c     Glossary: See store.h.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.

c.... Subscript data.

      character*1  asrce(1)           ! Stem in ASCII format.
      character*80 astemx             ! Stem in ASCII format.
      character*1  aquote             ! Character '"'.
      character*80 asubx              ! Subscript in ASCII format.

      nerra  = 0
      nchars = nchar

      aquote = '"'
cbugc***DEBUG begins.
cbugC     subroutine incrsubs (incr, asrce, isrce, nchar, nerra)
cbug 9701 format ('incrsubs DEBUG 1.  isrce = ',i3,'  nchars = ',i3 /
cbug     &  'asrce = ',80a1)
cbug      ilast = isrce + nchars - 1
cbug      write (   6, 9701) isrce, nchars, aquote,
cbug     &   (asrce(n), n = isrce, ilast), aquote
cbug      write (iout, 9701) isrce, nchars, aquote,
cbug     &   (asrce(n), n = isrce, ilast), aquote
cbugc***DEBUG ends.

      call aptsubm (asrce, isrce, nchars, 24, idmax, iemax,
     &  '(', ',', ')', 16,
     &         astem, istem, fstem, mstem, lstem,
     &  nsub,  asub,  isub,  fsub,  msub,  lsub,  nerra)
cbugc***DEBUG begins.
cbug 9101 format (/ 'incrsubs DEBUG stem.' /
cbug     &  'asrce  = <',a,'>' /
cbug     &  'astem = <',a,'>' /
cbug     &  'istem = ',i12 /
cbug     &  'fstem = ',1pe20.12 /
cbug     &  'mstem = ',i2 /
cbug     &  'lstem = ',i2 )
cbug 9102 format (/ 'incrsubs DEBUG subs.' /
cbug     &  'asub  = <',a,'>' /
cbug     &  'isub  = ',i12 /
cbug     &  'fsub  = ',1pe20.12 /
cbug     &  'msub  = ',i2 /
cbug     &  'lsub  = ',i2 )
cbug      write (   6, 9101) asrce, astem, istem, fstem, mstem, lstem
cbug      write (iout, 9101) asrce, astem, istem, fstem, mstem, lstem
cbug      write (   6, 9102) (asub(n), isub(n), fsub(n), msub(n),
cbug     &   lsub(n), n = 1, nsub)
cbug      write (iout, 9102) (asub(n), isub(n), fsub(n), msub(n),
cbug     &   lsub(n), n = 1, nsub)
cbugc***DEBUG ends.

 8110 format ('  incrsubs ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Can not increment word:  ',80a1)

      if (nerra .ne. 0) then
cbugc***DEBUG begins.
cbug 8109 format ('incrsubs DEBUG.  nerra = ',i3)
cbug        write (   6, 8109) nerra
cbug        write (iout, 8109) nerra
cbugc***DEBUG ends.
        if (nchars .gt. 0) then
          ilast = isrce + nchars - 1
        else
          ilast = isrce
        endif
        write (   6, 8110) ainput, ninput, aquote,
     &    (asrce(n), n = isrce, ilast), aquote
        write (iout, 8110) ainput, ninput, aquote,
     &    (asrce(n), n = isrce, ilast), aquote
        go to 999
      endif

c===============================================================================

c.... Increment stem as integer if no subscript, integer stem.

      if ((nsub .eq. 0) .and. (mstem .eq. 2)) then
cbugc***DEBUG begins.
cbug 9903 format ('incrsubs DEBUG.  Word is integer.')
cbug       write (   6, 9903)
cbug       write (iout, 9903)
cbugc***DEBUG ends.

        istem1 = abs (istem)
        istem  = istem + incr
        istem2 = abs (istem)

        lstem1 = 1
        lstem2 = 1
        nmin   = 1
        nmax   = 9
        do n = 1, 12
          if ((istem1 .ge. nmin) .and. (istem1 .le. nmax)) lstem1 = n
          if ((istem2 .ge. nmin) .and. (istem2 .le. nmax)) lstem2 = n
          nmin = 10 * nmin
          nmax = 10 * nmin - 1
        enddo

        lstem = lstem + lstem2 - lstem1
cbugc***DEBUG begins.
cbug 9904 format ('incrsubs DEBUG.  istem1,2 and lstem1,2 = ',4i9)
cbug       write (   6, 9904) istem1, istem2, lstem1, lstem2
cbug       write (iout, 9904) istem1, istem2, lstem1, lstem2
cbugc***DEBUG ends.

        if (lstem .gt. iamax) then
          nerra = 1
          go to 999
        endif

c....   Find ASCII equivalent, astemx, of integer stem, istem.

        astemx = ' '

        call aptchia (istem, 10, astemx, 80, ibeg, lstem, nerra)
cbugc***DEBUG begins.
cbug 9905 format ('incrsubs DEBUG.  astemx = <',a,'>' )
cbug       write (   6, 9905) astemx
cbug       write (iout, 9905) astemx
cbugc***DEBUG ends.

c....   Left-adjust astemx into astem.

        call aptchmv (astemx, ibeg, lstem, astem, 1, nerra)
cbugc***DEBUG begins.
cbug 9906 format ('incrsubs DEBUG.  astem  = <',a,'>' )
cbug       write (   6, 9906) astem
cbug       write (iout, 9906) astem
cbugc***DEBUG ends.

c....   Put stem astem into asrce.

        asrce(isrce) = ' '

        nchars = lstem

        if (lstem .gt. 0) then
          call aptchmv (astem, 1, lstem, asrce(isrce), 1, nerra)
        endif
cbugc***DEBUG begins.
cbug 9726   format ('incrsubs DEBUG 2.  isrce = ',i3,'  nchars = ',i3 /
cbug     &    'asrce = ',80a1)
cbug        ilast = isrce + nchars - 1
cbug        write (   6, 9726) isrce, nchars, aquote,
cbug     &    (asrce(n), n = isrce, ilast), aquote
cbug        write (iout, 9726) isrce, nchars, aquote,
cbug     &    (asrce(n), n = isrce, ilast), aquote
cbugc***DEBUG ends.

c....   Right-fill with blanks if new length is less than original.

        if (nchars .lt. nchar) then
          do n = nchars + 1, nchar
            asrce(isrce + n - 1) = ' '
          enddo
        endif

c....   Test for overflow of word length.

        if (nchars .gt. 24) then
          nerra = 1
          go to 999
        endif

        nchar = nchars

        go to 999

      endif                           ! Word is integer.

c===============================================================================

c.... Increment first subscript if it is an integer.

      if ((nsub .gt. 0) .and. (msub(1) .eq. 2)) then

cbugc***DEBUG begins.
cbug 9777 format ('lstem = ',i3 /
cbug     &  'astem = <',a,'>' / 'asub(1) = <',a,'>')
cbug 9778 format ('msub(1) = ',i2,'  lsub(1) = ',i2 /
cbug     &  'isub(1) = ',i22 /
cbug     &  'fsub(1) = ',1pe22.14 )
cbug        write (   6, 9777) lstem, astem, asub(1)
cbug        write (iout, 9777) lstem, astem, asub(1)
cbug        write (   6, 9778) msub(1), lsub(1), isub(1), fsub(1)
cbug        write (iout, 9778) msub(1), lsub(1), isub(1), fsub(1)
cbugc***DEBUG ends.
cbugc***DEBUG begins.
cbug 9703 format ('incrsubs DEBUG 3.  isrce = ',i3,'  nchars = ',i3 /
cbug     &  'asrce = ',80a1)
cbug      ilast = isrce + nchars - 1
cbug      write (   6, 9703) isrce, nchars, aquote,
cbug     &  (asrce(n), n = isrce, ilast), aquote
cbug      write (iout, 9703) isrce, nchars, aquote,
cbug     &  (asrce(n), n = isrce, ilast), aquote
cbugc***DEBUG ends.

c....   Increment isub(1) and find new length.

        isub1    = abs (isub(1))
        isub(1)  = isub(1) + incr
        isub2    = abs (isub(1))

        lsub1 = 1
        lsub2 = 1
        nmin  = 1
        nmax  = 9
        do n = 1, 12
          if ((isub1 .ge. nmin) .and. (isub1 .le. nmax)) lsub1 = n
          if ((isub2 .ge. nmin) .and. (isub2 .le. nmax)) lsub2 = n
          nmin = 10 * nmin
          nmax = 10 * nmin - 1
        enddo

        lsub(1) = lsub(1) + lsub2 - lsub1

        if (lsub(1) .gt. iamax) then
          nerra = 1
          go to 999
        endif

c....   Find ASCII equivalent, asubx, of integer subscript, isub(1).

        do n = 1, nsub

          asubx = ' '

          call aptchia (isub(n), 10, asubx, 80, ibeg, lsub(n), nerra)

c....     Left-adjust asubx into asub(n).

          nchars = 1
          call aptchmv (asubx, ibeg, lsub(n), asub(n), nchars, nerra)

        enddo

c....   Put stem astem, "(", subscript asub(1) and ")" into asrce.

        asrce(isrce) = ' '

        nchars = 1
        if (lstem .gt. 0) then
          call aptchmv (astem, 1, lstem, asrce(isrce), nchars,
     &      nerra)
        endif
cbugc***DEBUG begins.
cbug 9706 format ('incrsubs DEBUG 6.  isrce = ',i3,'  nchars = ',i3 /
cbug     &  'asrce = ',80a1)
cbug      ilast = isrce + nchars - 1
cbug      write (   6, 9706) isrce, nchars, aquote,
cbug     &  (asrce(n), n = isrce, ilast), aquote
cbug      write (iout, 9706) isrce, nchars, aquote,
cbug     &  (asrce(n), n = isrce, ilast), aquote
cbugc***DEBUG ends.

        nchars = nchars + lstem
        call aptchmv ('(', 1, 1, asrce(isrce), nchars, nerra)
cbugc***DEBUG begins.
cbug 9707 format ('incrsubs DEBUG 7.  isrce = ',i3,'  nchars = ',i3 /
cbug     &  'asrce = ',80a1)
cbug      ilast = isrce + nchars - 1
cbug      write (   6, 9707) isrce, nchars, aquote,
cbug     &  (asrce(n), n = isrce, ilast), aquote
cbug      write (iout, 9707) isrce, nchars, aquote,
cbug     &  (asrce(n), n = isrce, ilast), aquote
cbugc***DEBUG ends.

        nchars = nchars + 1
        call aptchmv (asub(1), 1, lsub(1), asrce(isrce), nchars,
     &    nerra)
cbugc***DEBUG begins.
cbug 9708 format ('incrsubs DEBUG 8.  isrce = ',i3,'  nchars = ',i3 /
cbug     &  'asrce = ',80a1)
cbug      ilast = isrce + nchars - 1
cbug      write (   6, 9708) isrce, nchars, aquote,
cbug     &  (asrce(n), n = isrce, ilast), aquote
cbug      write (iout, 9708) isrce, nchars, aquote,
cbug     &  (asrce(n), n = isrce, ilast), aquote
cbugc***DEBUG ends.

        if (nsub .gt. 1) then
          do n = 2, nsub
            nchars = nchars + lsub(n-1)
            call aptchmv (',', 1, 1, asrce(isrce), nchars, nerra)

            nchars = nchars + 1
            call aptchmv (asub(n), 1, lsub(n), asrce(isrce), nchars,
     &        nerra)
          enddo
        endif

        nchars = nchars + lsub(nsub)
        call aptchmv (')', 1, 1, asrce(isrce), nchars, nerra)
cbugc***DEBUG begins.
cbug 9709 format ('incrsubs DEBUG 9.  isrce = ',i3,'  nchars = ',i3 /
cbug     &  'asrce = ',80a1)
cbug      ilast = isrce + nchars - 1
cbug      write (   6, 9709) isrce, nchars, aquote,
cbug     &  (asrce(n), n = isrce, ilast), aquote
cbug      write (iout, 9709) isrce, nchars, aquote,
cbug     &  (asrce(n), n = isrce, ilast), aquote
cbugc***DEBUG ends.

c....   Right-fill with blanks if new length is less than original.

        if (nchars .lt. nchar) then
          do n = nchars + 1, nchar
            asrce(isrce + n - 1) = ' '
          enddo
        endif

c....   Test for overflow of word length.

        if (nchars .gt. 24) then
          nerra = 1
          go to 999
        endif

        nchar = nchars

        go to 999

      endif                           ! Subscript is an integer.

c===============================================================================

c.... In all other cases, increment whole word as ASCII string.

      call aptchin (incr, asrce, 1, nchar, nerra)

  999 return

c.... End of subroutine incrsubs.     (+1 line)
      end
