      subroutine last

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  last     Updated     2006 January 9 16:00.
c               last     Originated  1994 July 6 14:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the last alias, marker, variable, vector, operator,
c               point, cluster, line, triangle, annular disk, regular polygon,
c               plane, sphere, cylinder, cone, hyperbolic paraboloid, ellipsoid,
c               axisymmetric quadric surface, general quadric surface, regular
c               polyhedron, tetrahedron, brick, zone, bin,, probability
c               distribution function (pdf) or symbol.
c
c     Logic:    Entry points:  last
c last          Called by:  helpall, main.
c
c last          Calls:  aptchrn.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Input line:  last [help]

 8110 format ('  Command "last":  acceptable input lines include:' /
     &  '  "last [help]"   Display this message.' /
     &  '  "last all"      Display the last named object of',
     &  ' every type.' /
     &  '  "last OBJTYPE"  Display the last named object of type',
     &  ' OBJTYPE, where' /
     &  '     OBJTYPE is alias, marker, variable, big, vector,',
     &  ' operator, point, cluster,' /
     &  '     line, triangle, polygon, plane, sphere, cylinder, cone,',
     &  ' hyperb, axisym,' /
     &  '     quadric, polyhedron, tetrahedron, brick, zone, bin,',
     &  ' pdf, symbol.' /
     &  '  "last OBJTYPE [=] OBJNAME"' /
     &  '     Change the last named object of',
     &  ' type OBJTYPE to OBJNAME.' /
     &  '  "last OBJTYPE [=] random"' /
     &  '     Change the last named object of type OBJTYPE to a',
     &  ' string of' /
     &  '     random lower case alphabetic characters,' /
     &  '     except upper case A-Z for big integers.' )

 8112 format (/
     &  '  Synonyms:  [alias, al, a], [brick, br], [cluster, cl],' /
     &  '    [cylinder, cyl], [disk, disc, dk],',
     &  ' [ellipsoid, ellipse, ell, el],' /
     &  '    [help, h], [hyperb, saddle], [line, ln, l],',
     &  ' [marker, mark, m],' /
     &  ' [operator, oper, op, o],' /
     &  '    [plane, pl], [point, pnt, pt, p], [polygon, polyg, pg],' /
     &  '    [polyhedron, polyh], [quadric, quad, q], [random, ?],' /
     &  '    [sphere, sph], [symbol, symb, sym],'
     &  ' [tetrahedron, tetra, tet],' /
     &  '    [triangle, tri], [variable, var, set, s],',
     &  ' [vector, vect, v],' /
     &  '    [zone, zn, z].' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        write (   6, 8112)
        write (iout, 8112)
        go to 999
      endif

c===============================================================================

c.... Test for input errors.

 8120 format ('  last ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Not 2 words on "last all" line:  ', i3)
 8125 format ('  last ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Too many words on "last" line:  ', i3)
 8128 format ('  last ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Not from 1 to ',i3,' characters in new object name:  ', i3)

      if ((nword .gt. 2)         .and.
     &    (aword(2) .eq. 'all')) then
        write (   6, 8120) ainput, ninput, nword
        write (iout, 8120) ainput, ninput, nword
        go to 999
      endif

      if ((nword .eq. 4)       .and.
     &    (aword(3) .eq. '=')) then
        nword = 3
        aword(3) = aword(4)
        lword(3) = lword(4)
      endif

      if (nword .gt. 3) then
        write (   6, 8125) ainput, ninput, nword
        write (iout, 8125) ainput, ninput, nword
        go to 999
      endif

      lenmax = 24

      if ((aword(2) .eq. 'a')         .or.
     &    (aword(2) .eq. 'al')        .or.
     &    (aword(2) .eq. 'alias')     .or.
     &    (aword(2) .eq. 'axisym')    .or.
     &    (aword(2) .eq. 'big')       .or.
     &    (aword(2) .eq. 'bin')       .or.
     &    (aword(2) .eq. 'cl')        .or.
     &    (aword(2) .eq. 'cluster')   .or.
     &    (aword(2) .eq. 'cone')      .or.
     &    (aword(2) .eq. 'cyl')       .or.
     &    (aword(2) .eq. 'cylinder')  .or.
     &    (aword(2) .eq. 'el')        .or.
     &    (aword(2) .eq. 'ell')       .or.
     &    (aword(2) .eq. 'ellipse')   .or.
     &    (aword(2) .eq. 'ellipsoid') .or.
     &    (aword(2) .eq. 'l')         .or.
     &    (aword(2) .eq. 'ln')        .or.
     &    (aword(2) .eq. 'line')      .or.
     &    (aword(2) .eq. 'p')         .or.
     &    (aword(2) .eq. 'pl')        .or.
     &    (aword(2) .eq. 'plane')     .or.
     &    (aword(2) .eq. 'point')     .or.
     &    (aword(2) .eq. 'pt')        .or.
     &    (aword(2) .eq. 'q')         .or.
     &    (aword(2) .eq. 'quad')      .or.
     &    (aword(2) .eq. 'quadric')   .or.
     &    (aword(2) .eq. 's')         .or.
     &    (aword(2) .eq. 'set')       .or.
     &    (aword(2) .eq. 'sph')       .or.
     &    (aword(2) .eq. 'sphere')    .or.
     &    (aword(2) .eq. 'sym')       .or.
     &    (aword(2) .eq. 'symb')      .or.
     &    (aword(2) .eq. 'symbol')    .or.
     &    (aword(2) .eq. 'z')         .or.
     &    (aword(2) .eq. 'zn')        .or.
     &    (aword(2) .eq. 'zone')      .or.
     &    (aword(2) .eq. 'v')         .or.
     &    (aword(2) .eq. 'vect')      .or.
     &    (aword(2) .eq. 'vector')    .or.
     &    (aword(2) .eq. 'var')       .or.
     &    (aword(2) .eq. 'variable')) then
        lenmax = 24
      endif

      if ((aword(2) .eq. 'marker') .or.
     &    (aword(2) .eq. 'mark')   .or.
     &    (aword(2) .eq. 'big')    .or.
     &    (aword(2) .eq. 'm'))     then
        lenmax = 1
      endif

      if ((aword(3) .eq. 'random') .or.
     &    (aword(3) .eq. '?'))     then

        if (aword(2) .eq. 'big') then
          call aptchrn (2, aword(3), 1, 1, nerra)
        else
          call aptchrn (1, aword(3), 1, lenmax, nerra)
        endif

      elseif ((nword .gt. 2) .and.
     &       ((lword(3) .lt. 1) .or. (lword(3) .gt. lenmax))) then
        write (   6, 8128) ainput, ninput, lenmax, lword(3)
        write (iout, 8128) ainput, ninput, lenmax, lword(3)
        go to 999
      endif

c===============================================================================

c.... Initialize.

      kgood = 0

c===============================================================================

c.... Input line:  last alias
c.... Input line:  last alias [=] ANAME
c.... Input line:  last all

c.... See if last alias is to be displayed.

      if ((aword(2) .eq. 'alias') .or.
     &    (aword(2) .eq. 'all')    .or.
     &    (aword(2) .eq. 'al')     .or.
     &    (aword(2) .eq. 'a'))     then

        kgood = 1

        if (nword .eq. 3) then
          alias1s  = aword(3)
          lalias1s = lword(3)
        endif

 8130   format ('last alias       = ',a)

        if (alias1s .ne. ' ') then
          write (   6, 8130) alias1s
          write (iout, 8130) alias1s
        endif

      endif                           ! Displayed last alias.

c===============================================================================

c.... Input line:  last marker
c.... Input line:  last marker [=] AMNAME
c.... Input line:  last all

c.... See if last marker is to be displayed.

      if ((aword(2) .eq. 'marker') .or.
     &    (aword(2) .eq. 'all')    .or.
     &    (aword(2) .eq. 'mark')   .or.
     &    (aword(2) .eq. 'm'))     then

        kgood = 1

        if (nword .eq. 3) then
          amarks  = aword(3)
        endif

 8135   format ('last marker      = ',a1)

        if (amarks .ne. ' ') then
          write (   6, 8135) amarks
          write (iout, 8135) amarks
        endif

      endif                           ! Displayed last marker.

c===============================================================================

c.... Input line:  last variable
c.... Input line:  last variable [=] VARNAME
c.... Input line:  last all

c.... See if last variable is to be displayed.

      if ((aword(2) .eq. 'variable') .or.
     &    (aword(2) .eq. 'all')      .or.
     &    (aword(2) .eq. 'var')      .or.
     &    (aword(2) .eq. 'set')      .or.
     &    (aword(2) .eq. 's'))       then

        kgood = 1

        if (nword .eq. 3) then
          avarbls  = aword(3)
          lavarbls = lword(3)
        endif

 8140   format ('last variable    = ',a)

        if (avarbls .ne. ' ') then
          write (   6, 8140) avarbls
          write (iout, 8140) avarbls
        endif

      endif                           ! Displayed last variable.

c===============================================================================

c.... Input line:  last vector
c.... Input line:  last vector [=] VNAME
c.... Input line:  last all

c.... See if last vector is to be displayed.

      if ((aword(2) .eq. 'vector') .or.
     &    (aword(2) .eq. 'all')    .or.
     &    (aword(2) .eq. 'vect')   .or.
     &    (aword(2) .eq. 'v'))     then

        kgood = 1

        if (nword .eq. 3) then
          avectors  = aword(3)
          lavectors = lword(3)
        endif

 8210   format ('last vector      = ',a)

        if (avectors .ne. ' ') then
          write (   6, 8210) avectors
          write (iout, 8210) avectors
        endif

      endif                           ! Displayed last vector.

c===============================================================================

c.... Input line:  last operator
c.... Input line:  last operator [=] OPNAME
c.... Input line:  last all

c.... See if last operator is to be displayed.

      if ((aword(2) .eq. 'operator') .or.
     &    (aword(2) .eq. 'all')      .or.
     &    (aword(2) .eq. 'oper')     .or.
     &    (aword(2) .eq. 'op')       .or.
     &    (aword(2) .eq. 'o'))       then

        kgood = 1

        if (nword .eq. 3) then
          aopers  = aword(3)
          laopers = lword(3)
        endif

 8220   format ('last operator    = ',a)

        if (aopers .ne. ' ') then
          write (   6, 8220) aopers
          write (iout, 8220) aopers
        endif

      endif                           ! Displayed last operator.

c===============================================================================

c.... Input line:  last point
c.... Input line:  last point [=] PNAME
c.... Input line:  last all

c.... See if last point is to be displayed.

      if ((aword(2) .eq. 'point') .or.
     &    (aword(2) .eq. 'all')   .or.
     &    (aword(2) .eq. 'pnt')   .or.
     &    (aword(2) .eq. 'pt')    .or.
     &    (aword(2) .eq. 'p'))     then

        kgood = 1

        if (nword .eq. 3) then
          apoints  = aword(3)
          lapoints = lword(3)
        endif

 8150   format ('last point       = ',a)

        if (apoints .ne. ' ') then
          write (   6, 8150) apoints
          write (iout, 8150) apoints
        endif

      endif                           ! Deleted one, a cluster of or all point.

c===============================================================================

c.... Input line:  last cluster
c.... Input line:  last cluster [=] CLNAME
c.... Input line:  last all

c.... See if last cluster is to be displayed.

      if ((aword(2) .eq. 'cluster') .or.
     &    (aword(2) .eq. 'all')     .or.
     &    (aword(2) .eq. 'cl'))     then

        kgood = 1

        if (nword .eq. 3) then
          aclusts  = aword(3)
          laclusts = lword(3)
        endif

 8160   format ('last cluster     = ',a)

        if (aclusts .ne. ' ') then
          write (   6, 8160) aclusts
          write (iout, 8160) aclusts
        endif

      endif                           ! Displayed last cluster.

c===============================================================================

c.... Input line:  last line
c.... Input line:  last line [=] ALNAME
c.... Input line:  last all

c.... See if last line is to be displayed.

      if ((aword(2) .eq. 'line') .or.
     &    (aword(2) .eq. 'all')  .or.
     &    (aword(2) .eq. 'ln')   .or.
     &    (aword(2) .eq. 'l'))   then

        kgood = 1

        if (nword .eq. 3) then
          alines  = aword(3)
          lalines = lword(3)
        endif

 8170   format ('last line        = ',a)

        if (alines .ne. ' ') then
          write (   6, 8170) alines
          write (iout, 8170) alines
        endif

      endif                           ! Displayed last line.

c===============================================================================

c.... Input line:  last triangle
c.... Input line:  last triangle [=] TRINAME
c.... Input line:  last all

c.... See if last triangle is to be displayed.

      if ((aword(2) .eq. 'triangle') .or.
     &    (aword(2) .eq. 'all')      .or.
     &    (aword(2) .eq. 'tri'))     then

        kgood = 1

        if (nword .eq. 3) then
          atrigs  = aword(3)
          latrigs = lword(3)
        endif

 8180   format ('last triangle    = ',a)

        if (atrigs .ne. ' ') then
          write (   6, 8180) atrigs
          write (iout, 8180) atrigs
        endif

      endif                           ! Displayed last triangle.

c===============================================================================

c.... Input line:  last polygon
c.... Input line:  last polygon [=] PGNAME
c.... Input line:  last all

c.... See if last polygon is to be displayed.

      if ((aword(2) .eq. 'polygon') .or.
     &    (aword(2) .eq. 'all')     .or.
     &    (aword(2) .eq. 'polyg')   .or.
     &    (aword(2) .eq. 'pg'))     then

        kgood = 1

        if (nword .eq. 3) then
          apolygs  = aword(3)
          lapolygs = lword(3)
        endif

 8190   format ('last polygon     = ',a,'  ! (regular)')

        if (apolygs .ne. ' ') then
          write (   6, 8190) apolygs
          write (iout, 8190) apolygs
        endif

      endif                           ! Displayed last polygon.

c===============================================================================

c.... Input line:  last disk
c.... Input line:  last disk [=] DKNAME
c.... Input line:  last all

c.... See if last annular disk is to be displayed.

      if ((aword(2) .eq. 'disk') .or.
     &    (aword(2) .eq. 'all')  .or.
     &    (aword(2) .eq. 'disc') .or.
     &    (aword(2) .eq. 'dk'))  then

        kgood = 1

        if (nword .eq. 3) then
          adisks  = aword(3)
          ladisks = lword(3)
        endif

 8200   format ('last disk        = ',a,'  ! (annular)')

        if (adisks .ne. ' ') then
          write (   6, 8200) adisks
          write (iout, 8200) adisks
        endif

      endif                           ! Displayed last disk.

c===============================================================================

c.... Input line:  last plane
c.... Input line:  last plane [=] PLNAME
c.... Input line:  last all

c.... See if last plane is to be displayed.

      if ((aword(2) .eq. 'plane')   .or.
     &    (aword(2) .eq. 'pl')      .or.
     &    (aword(2) .eq. 'quadric') .or.
     &    (aword(2) .eq. 'quad')    .or.
     &    (aword(2) .eq. 'q')       .or.
     &    (aword(2) .eq. 'axisym')  .or.
     &    (aword(2) .eq. 'all'))    then

        kgood = 1

        if (nword .eq. 3) then
          aplanes  = aword(3)
          laplanes = lword(3)
        endif

 8310   format ('last plane       = ',a)

        if (aplanes .ne. ' ') then
          write (   6, 8310) aplanes
          write (iout, 8310) aplanes
        endif

      endif                           ! Displayed last plane.

c===============================================================================

c.... Input line:  last sphere
c.... Input line:  last sphere [=] SPHNAME
c.... Input line:  last all

c.... See if last sphere is to be displayed.

      if ((aword(2) .eq. 'sphere')  .or.
     &    (aword(2) .eq. 'sph')     .or.
     &    (aword(2) .eq. 'quadric') .or.
     &    (aword(2) .eq. 'quad')    .or.
     &    (aword(2) .eq. 'q')       .or.
     &    (aword(2) .eq. 'axisym')  .or.
     &    (aword(2) .eq. 'all'))    then

        kgood = 1

        if (nword .eq. 3) then
          aspheres  = aword(3)
          laspheres = lword(3)
        endif

 8320   format ('last sphere      = ',a)

        if (aspheres .ne. ' ') then
          write (   6, 8320) aspheres
          write (iout, 8320) aspheres
        endif

      endif                           ! Displayed last sphere.

c===============================================================================

c.... Input line:  last cylinder
c.... Input line:  last cylinder [=] CYLNAME
c.... Input line:  last all

c.... See if last cylinder is to be displayed.

      if ((aword(2) .eq. 'cylinder')  .or.
     &    (aword(2) .eq. 'cyl')       .or.
     &    (aword(2) .eq. 'quadric')   .or.
     &    (aword(2) .eq. 'quad')      .or.
     &    (aword(2) .eq. 'q')         .or.
     &    (aword(2) .eq. 'axisym')    .or.
     &    (aword(2) .eq. 'all'))      then

        kgood = 1

        if (nword .eq. 3) then
          acyls  = aword(3)
          lacyls = lword(3)
        endif

 8330   format ('last cylinder    = ',a,'  ! (circular)')

        if (acyls .ne. ' ') then
          write (   6, 8330) acyls
          write (iout, 8330) acyls
        endif

      endif                           ! Displayed last cylinder.

c===============================================================================

c.... Input line:  last cone
c.... Input line:  last cone [=] CNNAME
c.... Input line:  last all

c.... See if last cone is to be displayed.

      if ((aword(2) .eq. 'cone')    .or.
     &    (aword(2) .eq. 'quadric') .or.
     &    (aword(2) .eq. 'quad')    .or.
     &    (aword(2) .eq. 'q')       .or.
     &    (aword(2) .eq. 'axisym')  .or.
     &    (aword(2) .eq. 'all'))    then

        kgood = 1

        if (nword .eq. 3) then
          acones  = aword(3)
          lacones = lword(3)
        endif

 8340   format ('last cone        = ',a,'  ! (circular)')

        if (acones .ne. ' ') then
          write (   6, 8340) acones
          write (iout, 8340) acones
        endif

      endif                           ! Displayed last cone.

c===============================================================================

c.... Input line:  last hyperb
c.... Input line:  last hyperb [=] HPNAME
c.... Input line:  last all

c.... See if last hyperbolic paraboloid is to be displayed.

      if ((aword(2) .eq. 'hyperb')  .or.
     &    (aword(2) .eq. 'saddle') .or.
     &    (aword(2) .eq. 'quadric') .or.
     &    (aword(2) .eq. 'quad')    .or.
     &    (aword(2) .eq. 'q')       .or.
     &    (aword(2) .eq. 'all'))    then

        kgood = 1

        if (nword .eq. 3) then
          ahyperbs  = aword(3)
          lahyperbs = lword(3)
        endif

 8342   format ('last hyperb      = ',a)

        if (ahyperbs .ne. ' ') then
          write (   6, 8342) ahyperbs
          write (iout, 8342) ahyperbs
        endif

      endif                           ! Displayed last hyperbolic paraboloid.

c===============================================================================

c.... Input line:  last ellipsoid
c.... Input line:  last ellipsoid [=] ELNAME
c.... Input line:  last all

c.... See if last ellipsoid is to be displayed.

      if ((aword(2) .eq. 'ellipsoid') .or.
     &    (aword(2) .eq. 'ellipse')   .or.
     &    (aword(2) .eq. 'ell')       .or.
     &    (aword(2) .eq. 'el')        .or.
     &    (aword(2) .eq. 'quadric')   .or.
     &    (aword(2) .eq. 'quad')      .or.
     &    (aword(2) .eq. 'q')         .or.
     &    (aword(2) .eq. 'axisym')    .or.
     &    (aword(2) .eq. 'all'))      then

        kgood = 1

        if (nword .eq. 3) then
          aellips  = aword(3)
          laellips = lword(3)
        endif

 8350   format ('last ellipsoid   = ',a)

        if (aellips .ne. ' ') then
          write (   6, 8350) aellips
          write (iout, 8350) aellips
        endif

      endif                           ! Displayed last ellipsoid.

c===============================================================================

c.... Input line:  last axisym
c.... Input line:  last axisym [=] AXNAME
c.... Input line:  last all

c.... See if last axisymmetric surface is to be displayed.

      if ((aword(2) .eq. 'axisym')    .or.
     &    (aword(2) .eq. 'quadric')   .or.
     &    (aword(2) .eq. 'quad')      .or.
     &    (aword(2) .eq. 'q')         .or.
     &    (aword(2) .eq. 'all'))      then

        kgood = 1

        if (nword .eq. 3) then
          axisyms  = aword(3)
          laxisyms = lword(3)
        endif

 8360   format ('last axisym      = ',a,'  ! (quadric surface)')

        if (axisyms .ne. ' ') then
          write (   6, 8360) axisyms
          write (iout, 8360) axisyms
        endif

      endif                           ! Displayed last axisymmetric surface.

c===============================================================================

c.... Input line:  last quadric
c.... Input line:  last quadric [=] QNAME
c.... Input line:  last all

c.... See if last quadric surface is to be displayed.

      if ((aword(2) .eq. 'quadric') .or.
     &    (aword(2) .eq. 'quad')    .or.
     &    (aword(2) .eq. 'q')       .or.
     &    (aword(2) .eq. 'all'))    then

        kgood = 1

        if (nword .eq. 3) then
          aquads   = aword(3)
          laquads  = lword(3)
        endif

 8230   format ('last quadric     = ',a,'  ! (surface)')

        if (aquads .ne. ' ') then
          write (   6, 8230) aquads
          write (iout, 8230) aquads
        endif

      endif                           ! Displayed last quadric surface.

c===============================================================================

c.... Input line:  last polyhedron
c.... Input line:  last polyhedron [=] PHNAME
c.... Input line:  last all

c.... See if last regular polyhedron is to be displayed.

      if ((aword(2) .eq. 'polyhedron') .or.
     &    (aword(2) .eq. 'all')        .or.
     &    (aword(2) .eq. 'polyh')      .or.
     &    (aword(2) .eq. 'ph'))        then

        kgood = 1

        if (nword .eq. 3) then
          apolyhs  = aword(3)
          lapolyhs = lword(3)
        endif

 8240   format ('last polyhedron  = ',a,'  ! (regular)')

        if (apolyhs .ne. ' ') then
          write (   6, 8240) apolyhs
          write (iout, 8240) apolyhs
        endif

      endif                           ! Displayed last polyhedron.

c===============================================================================

c.... Input line:  last tetrahedron
c.... Input line:  last tetrahedron [=] TETNAME
c.... Input line:  last all

c.... See if last tetrahedron is to be displayed.

      if ((aword(2) .eq. 'tetrahedron') .or.
     &    (aword(2) .eq. 'all')         .or.
     &    (aword(2) .eq. 'tetra')       .or.
     &    (aword(2) .eq. 'tet'))        then

        kgood = 1

        if (nword .eq. 3) then
          atetras  = aword(3)
          latetras = lword(3)
        endif

 8250   format ('last tetrahedron = ',a)

        if (atetras .ne. ' ') then
          write (   6, 8250) atetras
          write (iout, 8250) atetras
        endif

      endif                           ! Displayed last tetrahedron.

c===============================================================================

c.... Input line:  last brick
c.... Input line:  last brick [=] BRNAME
c.... Input line:  last all

c.... See if last brick is to be displayed.

      if ((aword(2) .eq. 'brick') .or.
     &    (aword(2) .eq. 'all')   .or.
     &    (aword(2) .eq. 'br'))   then

        kgood = 1

        if (nword .eq. 3) then
          abricks  = aword(3)
          labricks = lword(3)
        endif

 8260   format ('last brick       = ',a)

        if (abricks .ne. ' ') then
          write (   6, 8260) abricks
          write (iout, 8260) abricks
        endif

      endif                           ! Displayed last brick.

c===============================================================================

c.... Input line:  last zone
c.... Input line:  last zone [=] ZNAME
c.... Input line:  last all

c.... See if last zone is to be displayed.

      if ((aword(2) .eq. 'zone') .or.
     &    (aword(2) .eq. 'all')  .or.
     &    (aword(2) .eq. 'zn')   .or.
     &    (aword(2) .eq. 'z'))   then

        kgood = 1

        if (nword .eq. 3) then
          azones  = aword(3)
          lazones = lword(3)
        endif

 8270   format ('last zone        = ',a)

        if (azones .ne. ' ') then
          write (   6, 8270) azones
          write (iout, 8270) azones
        endif

      endif                           ! Displayed last zone.

c===============================================================================

c.... Input line:  last bin
c.... Input line:  last bin [=] BINNAME
c.... Input line:  last all

c.... See if last bin is to be displayed.

      if ((aword(2) .eq. 'bin')  .or.
     &    (aword(2) .eq. 'all')) then

        kgood = 1

        if (nword .eq. 3) then
          abins  = aword(3)
          labins = lword(3)
        endif

 8280   format ('last bin         = ',a,'  ! (probability)')

        if (abins .ne. ' ') then
          write (   6, 8280) abins
          write (iout, 8280) abins
        endif

      endif                           ! Displayed last bin.

c===============================================================================

c.... Input line:  last pdf
c.... Input line:  last pdf [=] PDFNAME
c.... Input line:  last all

c.... See if last pdf is to be displayed.

      if ((aword(2) .eq. 'pdf')  .or.
     &    (aword(2) .eq. 'all')) then

        kgood = 1

        if (nword .eq. 3) then
          apdfs  = aword(3)
          lapdfs = lword(3)
        endif

 8290   format ('last pdf         = ',a)

        if (apdfs .ne. ' ') then
          write (   6, 8290) apdfs
          write (iout, 8290) apdfs
        endif

      endif                           ! Displayed last pdf.

c===============================================================================

c.... Input line:  last symbol
c.... Input line:  last symbol [=] SYMBNAME
c.... Input line:  last all

c.... See if last symbol is to be displayed.

      if ((aword(2) .eq. 'symbol')     .or.
     &    (aword(2) .eq. 'all')        .or.
     &    (aword(2) .eq. 'symb')       .or.
     &    (aword(2) .eq. 'sym'))       then

        kgood = 1

        if (nword .eq. 3) then
          asymbls  = aword(3)
          lasymbls = lword(3)
        endif

 8300   format ('last symbol      = ',a)

        if (asymbls .ne. ' ') then
          write (   6, 8300) asymbls
          write (iout, 8300) asymbls
        endif

      endif                           ! Displayed last symbol.

c===============================================================================

c.... Input line:  last big
c.... Input line:  last big [=] BIGNAME
c.... Input line:  last all

c.... See if last big integer is to be displayed.

      if ((aword(2) .eq. 'big')  .or.
     &    (aword(2) .eq. 'all')) then

        kgood = 1

        if (nword .eq. 3) then
          abigs  = aword(3)
        endif

 8136   format ('last big integer = ',a1)

        if (abigs .ne. ' ') then
          write (   6, 8136) abigs
          write (iout, 8136) abigs
        endif

      endif                           ! Displayed last big integer.

c===============================================================================

 9990 format ('  last ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Object type does not exist:  ',a24)

      if (kgood .eq. 0) then
        write (   6, 9990) ainput, ninput, aword(2)
        write (iout, 9990) ainput, ninput, aword(2)
      endif

  999 return

c.... End of subroutine last.         (+1 line)
      end
