      subroutine linefind (nw, nl, np1, np2, nerrln)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  linefind Updated     1997 April 17 17:30.
c               linefind Originated  1997 April 17 17:30.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find a line with the same name as an ASCII argument,
c               or the value of an ASCII variable argument,
c               display the line, or display an error message,
c               and return the indices of the end points of the line.
c
c     Logic:    Entry point:  linefind.
c linefind      Called by:  accel.
c
c linefind      Calls:  lout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     nw        Input    Number of input line word with name of line to find.
c
c     nl        Output   Index of line.
c
c     np1       Output   Index of first end point of line.
c
c     np2       Output   Index of second end point of line.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

 8110 format ('  linefind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Argument number is bad:  ',i5)

      if ((nw .lt. 1)      .or.
     &    (nw .gt. nword)) then
        write (   6, 8110) ainput, ninput, nw
        write (iout, 8110) ainput, ninput, nw
        go to 999
      endif

      nl     = 0
      nerrln = 0
      np1    = 0
      np2    = 0

c.... Find the line.

 8210 format ('  linefind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Named line does not exist:  ',a)

      do 210 n = 1, nlines
        if (aword(nw) .eq. aline(n)) then
          nl  = n
          call lout (nl, nl)
          go to 212
        endif
  210 continue
      write (   6, 8210) ainput, ninput, aword(nw)
      write (iout, 8210) ainput, ninput, aword(nw)
      nerrln = 1
      go to 999

c.... Find the end points of the line.

 8220 format ('  linefind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Named point does not exist:  ',a)

  212 do 220 np = 1, npoints
        if (alipt1(nl) .eq. apoint(np)) then
          np1 = np
          go to 222
        endif
  220 continue
      write (   6, 8220) ainput, ninput, alipt1(nl)
      write (iout, 8220) ainput, ninput, alipt1(nl)
      nerrln = 1

  222 do 230 np = 1, npoints
        if (alipt2(nl) .eq. apoint(np)) then
          np2 = np
          go to 999
        endif
  230 continue
      write (   6, 8220) ainput, ninput, alipt2(nl)
      write (iout, 8220) ainput, ninput, alipt2(nl)
      nerrln = 1

  999 return

c.... End of subroutine linefind.     (+1 line)
      end
