      subroutine marker

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  marker   Updated     1994 September 16 11:30.
c               marker   Originated  1994 May 11 16:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display and create markers and their texts.
c
c     Logic:    Entry points:  marker.
c marker        Called by:  helpall, main.
c
c marker        Calls:  aptchap, aptchfp, aptchfs, aptchmv, incrsubs, markout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.

      character*1  adel               ! Character ' or ".
      character*1  adel1              ! Character '.
      character*1  adel2              ! Character ".

c=======================================================================********

c.... Input line:  marker [help]

 8110 format ('  Command "marker":  acceptable input lines include:' /
     &  '  "marker [help]" Display this message.' /
     &  '  "marker all"    Display all markers and their texts.' /
     &  '  "marker list [AMNAME1 AMNAME2 AMNAME3 ...]"' /
     &  '     Display the marker and text for all listed markers' /
     &  '     (the default is all markers).' /
     &  '  "marker AMNAME"' /
     &  '     Display the marker and text for marker AMNAME.' //
     &  '  "marker AMNAME = '' ''"' /
     &  '     Delete marker AMNAME.' //
     &  '  "marker AMNAME = ''TEXT''"' /
     &  '     Create marker AMNAME (one character) with text TEXT',
     &  ' (bracketed by '' or ").' )
 8112 format (/
     &  '  Note:  use +/- for AMNAME to incr/decr the last marker',
     &  ' name:  ',a1 //
     &  '  Synonyms:  [",'' (in pairs)], [marker, mark, m],',
     &  ' [help, h].' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        write (   6, 8112) amarks
        write (iout, 8112) amarks
        go to 999
      endif

c=======================================================================********

c.... Input line:  marker all
c.... Input line:  marker list

 8120 format (/ 'Number of markers = ',i5)

      if ((aword(2) .eq. 'all')  .or.
     &   ((aword(2) .eq. 'list') .and. (nword .eq. 2))) then
        nmarkx = 0
        call markout (1, nmarks)
        do 120 n = 1, nmarks
          if (amark(n) .eq. ' ') go to 120
          nmarkx = nmarkx + 1
  120   continue
        write (   6, 8120) nmarkx
        write (iout, 8120) nmarkx
        go to 999
      endif

c=======================================================================********

c.... Input line:  marker list AMNAME1 AMNAME2 AMNAME3 ...

 8130 format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Named marker does not exist:  ',a)

      if (aword(2) .eq. 'list') then
        do 140 nw = 3, nword
          do 130 n = 1, nmarks
            if (amark(n) .eq. aword(nw)) then
              call markout (n, n)
              go to 140
            endif
  130     continue
          write (   6, 8130) ainput, ninput, aword(nw)
          write (iout, 8130) ainput, ninput, aword(nw)
  140   continue
        go to 999
      endif

c=======================================================================********

c.... Input line:  marker AMNAME

      if (nword .eq. 2) then
        do 150 n = 1, nmarks
          if (aword(2) .eq. amark(n)) then
            call markout (n, n)
            go to 999
          endif
  150   continue
        write (   6, 8130) ainput, ninput, aword(2)
        write (iout, 8130) ainput, ninput, aword(2)
        go to 999
      endif

c=======================================================================********

c.... Test input for validity.

 8150 format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of marker not 1 character:  ',a)

      if (lword(2) .ne. 1) then
        write (   6, 8150) ainput, ninput, aword(2)
        write (iout, 8150) ainput, ninput, aword(2)
        go to 999
      endif

c=======================================================================********

c.... See if last marker name should be incremented and used.

 8128 format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of last marker can not be incremented:  ',a)

      if (aword(2) .eq. '+') then
        aword(2) = amarks
        lword(2) = lamarks
        call incrsubs (1, aword(2), 1, lword(2), nerra)
        if (nerra .ne. 0) then
          write (   6, 8128) ainput, ninput, amarks
          write (iout, 8128) ainput, ninput, amarks
          go to 999
        endif
      endif

 8129 format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of last marker can not be decremented:  ',a)

      if (aword(2) .eq. '-') then
        aword(2) = amarks
        lword(2) = lamarks
        call incrsubs (-1, aword(2), 1, lword(2), nerra)
        if (nerra .ne. 0) then
          write (   6, 8129) ainput, ninput, amarks
          write (iout, 8129) ainput, ninput, amarks
          go to 999
        endif
      endif

c===============================================================================

c.... See if marker exists.

 8160 format ('  WARNING:  replacing existing marker:  ',a1)

      nrep = 0                        ! Flag, 1 if replacing existing marker.

      do 160 n = 1, nmarks
        if (aword(2) .eq. amark(n)) then
          nrep = 1
          write (   6, 8160) amark(n)
          write (iout, 8160) amark(n)
          call markout (n, n)
          go to 180
        endif
  160 continue

      do 170 n = 1, nmarks
        if (amark(n) .eq. ' ') go to 180
  170 continue

      nmarks = nmarks + 1

 8170 format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of markers exceeds limit ',i5)

      if (nmarks .gt. nmarkm) then
        nmarks = nmarkm
        write (   6, 8170) ainput, ninput, nmarkm
        write (iout, 8170) ainput, ninput, nmarkm
        go to 999
      endif

      n = nmarks

c=======================================================================********

c.... Input line:  marker AMNAME = ''
c.... Input line:  marker AMNAME = 'TEXT'

c.... Find the marker of this text.

  180 if (aword(3) .eq. '=') then

        nerr  = 0

c....   Find the first word in the input line ("marker").

        call aptchfs (achar, 80, 1, 80, aword(1), lword(1), isym, nerra)

c....   Find the second word in the input line (the marker).

        isrce  = isym + lword(1) + 1
        nchar2 = 81 - isrce

        call aptchfs (achar, 80, isrce, nchar2, aword(2), 1,
     &                isym, nerra)

        if (aword(2) .eq. '+') then
          aword(2) = amarks
          lword(2) = lamarks
          call incrsubs (1, aword(2), 1, lword(2), nerra)
        endif

        if (aword(2) .eq. '-') then
          aword(2) = amarks
          lword(2) = lamarks
          call incrsubs (-1, aword(2), 1, lword(2), nerra)
        endif

c....   Find the third word in the input line (the character "=").

        isrce  = isym + 2
        nchar3 = 81 - isrce

        call aptchfs (achar, 80, isrce, nchar3, aword(3), lword(3),
     &                isym, nerra)

c....   Find the first ' or " following word 3 in the input line.

        adel1  = ''''
        adel2  = '"'

        isrce  = isym + lword(3) + 1
        nchar3 = 81 - isrce

        call aptchfp (achar, isrce, nchar3, adel1, 1, ipat11, nerra)
        call aptchfp (achar, isrce, nchar3, adel2, 1, ipat12, nerra)

 8180   format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Right side of marker missing first ',a1,' or ',a1,'.')

        if ((ipat11 .gt. 0)  .and.
     &      (ipat12 .gt. 0)) then
          if( ipat11 .lt. ipat12) then
            ipat1 = ipat11
            adel  = adel1
          else
            ipat1 = ipat12
            adel  = adel2
          endif
        elseif (ipat11 .gt. 0) then
          ipat1 = ipat11
          adel  = adel1
        elseif (ipat12 .gt. 0) then
          ipat1 = ipat12
          adel  = adel2
        else
          ipat1 = 0
          adel  = adel1
          write (   6, 8180) ainput, ninput, adel1, adel2
          write (iout, 8180) ainput, ninput, adel1, adel2
          nerr = 1
        endif

c....   Test for extra words or characters before first bracketing ' or ".

 8182   format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Extra words or characters before first bracketing ',a1,'.')

        isrce = ipat1 - 1

        call aptchap (achar, 1, isrce, nwordm, afd,
     &                iamax, idmax, iemax, aword, iword, fword,
     &                mtype, lword, nword, nerra)

        if (aword(2) .eq. '+') then
          aword(2) = amarks
          lword(2) = lamarks
          call incrsubs (1, aword(2), 1, lword(2), nerra)
        endif

        if (aword(2) .eq. '-') then
          aword(2) = amarks
          lword(2) = lamarks
          call incrsubs (-1, aword(2), 1, lword(2), nerra)
        endif

        if (nword .gt. 3) then
          write (   6, 8182) ainput, ninput, adel
          write (iout, 8182) ainput, ninput, adel
          nerr = 1
        endif

c....   Find the second unduplicated ' or " in the input line.

 8184   format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Right side of marker missing second ',a1,'.')

        ipat2 = 0                     ! Character position of second ' or ".
        if (ipat1 .ne. 0) then

          isrce  = ipat1 + 1
          nchar2 = 80 - ipat1

  182     call aptchfp (achar, isrce, nchar2, adel, 1, ipat2, nerra)

          if (ipat2 .eq. 0) then
            write (   6, 8184) ainput, ninput, adel
            write (iout, 8184) ainput, ninput, adel
            nerr = 1
          elseif ((ipat2 .lt. 80)             .and.
     &            (achar(ipat2+1) .eq. adel)) then
            do 184 nc = ipat2, 79
              achar(nc) = achar(nc+1)
  184       continue
            achar(80) = ' '
            isrce = ipat2 + 1
            nchar2 = 81 - isrce
            go to 182
          endif

        endif

c....   Test for extra characters after second bracketing ' or ".

 8185   format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Extra characters after second bracketing ',a1,'.' )

        if ((ipat2 .ne. 0)   .and.
     &      (ipat2 .lt. 80)) then

          do 185 nc = ipat2 + 1, 80
            if (achar(nc) .ne. ' ') then
              write (   6, 8185) ainput, ninput, adel
              write (iout, 8185) ainput, ninput, adel
              nerr = 1
            endif
  185     continue

        endif

        if (nerr .ne. 0) go to 200

c....   Test for removal of the marker.

        do 190 nc = ipat1 + 1, ipat2 -  1
          if (achar(nc) .ne. ' ') go to 200
  190   continue

 8188   format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Can not delete an undefined marker.')

 8190   format ('mark ',a1,'  DELETED.')

        if (amark(n) .eq. ' ') then
          write (   6, 8188) ainput, ninput
          write (iout, 8188) ainput, ninput
          nerr = 1
        else
          write (   6, 8190) amark(n)
          write (iout, 8190) amark(n)
          amark(n) = ' '
          go to 999
        endif

c....   Test for errors.

  200   if (nerr .ne. 0) then
          if (nrep .eq. 0) then
            if (n .eq. nmarks) nmarks = nmarks - 1
          endif
          go to 999
        endif

c....   Store the marker.

        amark(n) = aword(2)
        amarks   = aword(2)
        lamarks  = lword(2)
cbugc***DEBUG begins.
cbug 8701 format ('aword=',a24,'  lword = ',i5)
cbug      write (   6, 8701) aword(2), lword(2)
cbug      write (iout, 8701) aword(2), lword(2)
cbugc***DEBUG ends.

        nchar2 = ipat2 - ipat1 - 1
        ipat1  = ipat1 + 1

        amarkt(n) = ' '
        call aptchmv (achar, ipat1, nchar2, amarkt(n), 1, nerra)

c....   Print the marker specifications.

        call markout (n, n)

        go to 999

      endif                           ! Command "marker AMNAME = 'TEXT'.

c=======================================================================********

 8200   format ('  marker ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Input line is not recognized.')

        write (   6, 8200) ainput, ninput
        write (iout, 8200) ainput, ninput

c=======================================================================********

  999 return

c.... End of subroutine marker.       (+1 line)
      end
