      subroutine operator

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  operator Updated     2005 April 5 17:45.
c               operator Originated  1993 November 11 17:00
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display and create operators for inversion, reflection,
c               rotation and scaling of points, vectors and quadric surfaces.
c
c     Logic:    Entry points:  operator.
c operator      Called by:  helpall, main.
c
c operator      Calls:  aptrefs, aptrota, aptrots, aptrott, aptrotv, aptscll,
c               aptsclr, aptsubr, aptvusz, incrsubs, namechk, opout, plout,
c               quout, qutype, varfind, vectfind.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*8  amount

c.... Input line:  operator [help]

 8110 format ('  Command "operator":  acceptable input lines include:' /
     &  '  "operator [help]"  Display this message.' /
     &  '  "operator all"     Display all operators.' /
     &  '  "operator list [OPNAME1 OPNAME2 OPNAME3 ...]"' /
     &  '     Display all listed operators (default is all',
     &  ' operators).' /
     &  '  "operator OPNAME"  Display operator OPNAME.' //
     &  '  To find and display operator OPNAME:' //
     &  '  "operator OPNAME axial  VAXIS  ANGLE"' /
     &  '     to rotate around axis vector VAXIS by angle ANGLE.' /
     &  '  "operator OPNAME vector VNAME1 VNAME2"' /
     &  '     to rotate VNAME1 onto vector VNAME2 around an axis',
     &  ' perpendicular to both.' /
     &  '  "operator OPNAME serial U UANGLE  V VANGLE',
     &  '  W WANGLE"' /
     &  '     to rotate around U by angle UANGLE, then' /
     &  '     to rotate around V by angle VANGLE, then' /
     &  '     to rotate around W by angle WANGLE, where' )
 8111 format (
     &  '     U, V and W are x, y or z, and 5, 7 or 9 words may',
     &  ' be used.' /
     &  '  "operator OPNAME planar PLNAME1 PLNAME2"' /
     &  '     to rotate plane PLNAME1 onto plane PLNAME2 around an',
     &  ' axis parallel to both.' /
     &  '  "operator OPNAME triple VNAME1 VNAME2 VNAME3 VNAME4"' /
     &  '     to rotate vector VNAME1 onto vector VNAME3, and the' /
     &  '     plane containing vectors VNAME1 and VNAME2 onto the' /
     &  '     plane containing vectors VNAME3 and VNAME4.' //
     &  '  "operator OPNAME invert" to invert through origin.' /
     &  '     Replace x, y, z with -x, -y, -z, respectively.' //
     &  '  "operator OPNAME scale RATIO" to scale uniformly by RATIO.' /
     &  '  "operator OPNAME uniform RATIO" to scale uniformly',
     &  ' by RATIO.' /
     &  '  "operator OPNAME radial VAXIS RATIO"' /
     &  '     to scale radially from axis vector VAXIS by RATIO.' /
     &  '  "operator OPNAME linear VAXIS RATIO"' /
     &  '     to scale linearly in the direction of vector VAXIS',
     &  ' by RATIO.' )
 8112 format (/
     &  '  "operator OPNAME reflect PLNAME"' /
     &  '     to reflect in a plane parallel to plane PLNAME.' //
     &  '  Type <return> for more help.' )

 8113 format (a)

 8114 format (/
     &  '  To rotate a quadric surface to the principle axes:' /
     &  '  "operator OPNAME plane     PLNAME":   plane PLNAME.' /
     &  '  "operator OPNAME sphere    SPHNAME":  sphere SPHNAME.' /
     &  '  "operator OPNAME cylinder  CYLNAME":  circular cylinder',
     &  ' CYLNAME.' /
     &  '  "operator OPNAME cone      CNNAME":   circular cone CNNAME.'/
     &  '  "operator OPNAME hyperb    HPNAME":   hyperbolic',
     &  ' paraboloid HPNAME.'/
     &  '  "operator OPNAME ellipsoid ELNAME":   ellipsoid ELNAME.' /
     &  '  "operator OPNAME axisym    AXNAME":   axisymmetric quadric',
     &  ' AXNAME.' /
     &  '  "operator OPNAME quadric   QNAME":    quadric QNAME.' )
 8115 format (/
     &  '  Note:  OPNAME may not be "-".' //
     &  '  Note:  use +/- for OPNAME to incr/decr the last operator',
     &  ' name:  ',a //
     &  '  Synonyms:  [cylinder, cyl], [ellipsoid, ellipse, ell, el],',
     &  ' [help, h],' /
     &  '    [hyperb, saddle], [invert, inv],',
     &  ' [operator, oper, op, o],' /
     &  '    [plane, pl], [quadric, quad, q],' /
     &  '    [reflect, refl], [scale, sc, uniform], [sphere, sph]',
     &  ' [vector, vect, v].' )

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        write (   6, 8111)
        write (iout, 8111)
        write (   6, 8112)
        write (iout, 8112)
        if (ainput .eq. 'tty') then
          read  (   5, 8113) ans
        endif
        write (   6, 8114)
        write (iout, 8114)
        write (   6, 8115) aopers
        write (iout, 8115) aopers
        go to 999
      endif

c===============================================================================

c.... Input line:  operator all
c.... Input line:  operator list

 8120 format (/ 'Number of operators = ',i5)

      if ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'all')    .or.
     &    (aword(2) .eq. 'list'))) then

        noperx = 0
        call opout (1, nopers, 'min')
        do 120 n = 1, nopers
          if (aoper(n) .eq. ' ') go to 120
          noperx = noperx + 1
  120   continue
        write (   6, 8120) noperx
        write (iout, 8120) noperx
        go to 999
      endif

c===============================================================================

c.... Input line:  operator list OPNAME1 OPNAME2 OPNAME3 ...

 8130 format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Named operator does not exist:  ',a)

      if (aword(2) .eq. 'list') then
        do 128 nw = 3, nword
          nfind = 0
          do 125 n = 1, nopers
            call aptsubr (aoper(n), 1, 24, 80, astem, lstem,
     &                    asub, lsub, nerra)
            if ((aword(nw) .eq. aoper(n)) .or.
     &          (aword(nw) .eq. astem))   then
              nfind = nfind + 1
              call opout (n, n, 'min')
            endif
  125     continue
          if (nfind .eq. 0) then
            write (   6, 8130) ainput, ninput, aword(nw)
            write (iout, 8130) ainput, ninput, aword(nw)
          endif
  128   continue
        go to 999
      endif

c===============================================================================

c.... Test for acceptable operator name.

c??? 8122 format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
c???     &  '  Unacceptable name.  Too dangerous:  ',a)
c???      if (mtype(2) .ne. 1) then
c???        write (   6, 8122) ainput, ninput, aword(2)
c???        write (iout, 8122) ainput, ninput, aword(2)
c???        go to 999
c???      endif

c===============================================================================

c.... Test input for validity.

 8124 format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of operator not from 1 to 24 characters:  ',a)

      if ((lword(2) .lt. 1) .or. (lword(2) .gt. 24)) then
        write (   6, 8124) ainput, ninput, aword(2)
        write (iout, 8124) ainput, ninput, aword(2)
        go to 999
      endif

c===============================================================================

c.... See if last operator name should be incremented and used.

 8128 format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of last operator can not be incremented:  ',a)

      if (aword(2) .eq. '+') then
        aword(2) = aopers
        lword(2) = laopers
        call incrsubs (1, aword(2), 1, lword(2), nerra)
        if (nerra .ne. 0) then
          write (   6, 8128) ainput, ninput, aopers
          write (iout, 8128) ainput, ninput, aopers
          go to 999
        endif
      endif

 8129 format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of last operator can not be decremented:  ',a)

      if (aword(2) .eq. '-') then
        aword(2) = aopers
        lword(2) = laopers
        call incrsubs (-1, aword(2), 1, lword(2), nerra)
        if (nerra .ne. 0) then
          write (   6, 8129) ainput, ninput, aopers
          write (iout, 8129) ainput, ninput, aopers
          go to 999
        endif
      endif

 8905 format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Name of operator too dangerous to use:  ',a)

      call namechk (aword(2), lword(2), nerrchk)

      if (nerrchk .ne. 0) then
        write (   6, 8905) ainput, ninput, aword(2)
        write (iout, 8905) ainput, ninput, aword(2)
        go to 999
      endif

c===============================================================================

c.... Input line:  operator OPNAME

      if (nword .eq. 2) then

        do 130 n = 1, nopers
          if (aword(2) .eq. aoper(n)) then
            amount = 'maximum'
            call opout (n, n, amount)
            go to 999
          endif
  130   continue
        write (   6, 8130) ainput, ninput, aword(2)
        write (iout, 8130) ainput, ninput, aword(2)
        go to 999

      endif

c===============================================================================

c.... See if operator exists.

 8150 format ('  WARNING:  replacing existing operator:  ',a)

      nrep = 0
      do 150 n = 1, nopers
        if (aword(2) .eq. aoper(n)) then
          nrep = 1
          write (   6, 8150) aoper(n)
          write (iout, 8150) aoper(n)
          call opout (n, n, 'min')
          go to 160
        endif
  150 continue

      do 155 n = 1, nopers
        if (aoper(n) .eq. ' ') go to 160
  155 continue

      nopers = nopers + 1

 8160 format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of operators exceeds limit ',i5)

      if (nopers .gt. noperm) then
        nopers = noperm
        write (   6, 8160) ainput, ninput, noperm
        write (iout, 8160) ainput, ninput, noperm
        go to 999
      endif

      n = nopers

  160 nop = n

c===============================================================================

c.... Find the operator type and subtype.

 8170 format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Operator type is not recognized:  ',a)

c===============================================================================

c.... Input line:  operator OPNAME axial  VAXIS  ANGLE

c.... Rotate around a specified axis by a specified angle.

      if     (aword(3) .eq. 'axial')     then

 8200   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 5:  ',i3)

        if (nword .ne. 5) then
          write (   6, 8200) ainput, ninput, nword
          write (iout, 8200) ainput, ninput, nword
          go to 800
        endif

c....   Find the axis of rotation.

        call vectfind (4, nv)

        if (nv .eq. 0) go to 800

c....   See if the axis vector has zero length.

 8210   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Vector has zero length:  ',a)

        if (vlen(nv) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(4)
          write (iout, 8210) ainput, ninput, aword(4)
          go to 800
        endif

c....   Find the angle of rotation.

 8220   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Word 5 not integer or floating point value or',
     &    ' variable:  ',a)

        call varfind (5, 5)

        if ((mtype(5) .ne. 2) .and. (mtype(5) .ne. 3)) then
          write (   6, 8220) ainput, ninput, aword(5)
          write (iout, 8220) ainput, ninput, aword(5)
          go to 800
        endif

c....   Find the angle units.

        iunit = 0
        if (angunit .eq. 'radians') iunit = 1

c....   Find the axis of rotation.
        
        dx = xcom(nv)
        dy = ycom(nv)
        dz = zcom(nv)

        if (vlen(nv) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(4)
          write (iout, 8210) ainput, ninput, aword(4)
          go to 800
        endif

c....   Find the rotation operator.

        angle = fword(5)

        call aptrota (angle, iunit, dx, dy, dz, tol,
     &                toper(1,1,nop), nerr)

        angle = -angle

        call aptrota (angle, iunit, dx, dy, dz, tol,
     &                topin(1,1,nop), nerr)
c???
c???c....   Check operator.
c???
c???        call aptrotq (toper(1,1,nop), iunit, tol, theta, ux, uy, uz,
c???     &                thx, thy, thz, nerr)
c???
c??? 8235   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
c???     &    '  Error flag from aptrotq:  ',i3 /
c???     &    '  trace',11x,1pe20.12 /
c???     &    '  theta',11x,1pe20.12 /
c???     &    '  axis',12x,1p3e20.12)
c???
c???        if (nerr .ne. 0) then
c???          trace = toper(1,1,nop) + toper(2,2,nop) + toper(3,3,nop)
c???          write (   6, 8235) ainput, ninput, nerr, trace, theta,
c???     &      ux, uy, uz
c???          write (iout, 8235) ainput, ninput, nerr, trace, theta,
c???     &      ux, uy, uz
c???          go to 800
c???        endif

        aoptype(nop) = 'rotate'
        aoptyps(nop) = 'axial'

        go to 810

c===============================================================================

c.... Input line:  operator OPNAME vector VNAME1 VNAME2

c.... Rotate one vector to be parallel to another vector, around an axis
c....   perpendicular to both.

      elseif ((aword(3) .eq. 'vector') .or.
     &        (aword(3) .eq. 'vect')   .or.
     &        (aword(3) .eq. 'v'))     then

 8250   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 5:  ',i3)
        if (nword .ne. 5) then
          write (   6, 8250) ainput, ninput, nword
          write (iout, 8250) ainput, ninput, nword
          go to 800
        endif

c....   Find the first vector.

        call vectfind (4, n1)

        if (n1 .eq. 0) go to 800

c....   Find the second vector.

        call vectfind (5, n2)

        if (n2 .eq. 0) go to 800

c....   See if either of the vectors has zero length.

        if (vlen(n1) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(4)
          write (iout, 8210) ainput, ninput, aword(4)
          go to 800
        endif

        if (vlen(n2) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(5)
          write (iout, 8210) ainput, ninput, aword(5)
          go to 800
        endif

c....   Find the components of the vectors.
        
        dx1 = xcom(n1)
        dy1 = ycom(n1)
        dz1 = zcom(n1)
        dx2 = xcom(n2)
        dy2 = ycom(n2)
        dz2 = zcom(n2)

c....   Find the rotation operator.

        call aptrotv (dx1, dy1, dz1, dx2, dy2, dz2, tol,
     &                toper(1,1,nop), nerr)

        call aptrotv (dx2, dy2, dz2, dx1, dy1, dz1, tol,
     &                topin(1,1,nop), nerr)

c???
c???c....   Check operator.
c???
c???        iunit = 0
c???        if (angunit .eq. 'radians') iunit = 1
c???
c???        call aptrotq (toper(1,1,nop), iunit, tol, theta, ux, uy, uz,
c???     &                thx, thy, thz, nerr)
c???
c???        if (nerr .ne. 0) then
c???          go to 800
c???        endif

        aoptype(nop) = 'rotate'
        aoptyps(nop) = 'vector'

        go to 810

c===============================================================================

c.... Input line:  operator OPNAME serial U UANGLE V VANGLE W WANGLE

c.... Rotate sequentially around 3 specified major axes by three specified
c....   angles.

      elseif (aword(3) .eq. 'serial')    then

 8300   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 5, 7 or 9:  ',i3)
        if ((nword .ne. 5)  .and.
     &      (nword .ne. 7)  .and.
     &      (nword .ne. 9)) then
          write (   6, 8300) ainput, ninput, nword
          write (iout, 8300) ainput, ninput, nword
          go to 800
        endif

c....   Find the major axes and angles of rotation.

 8310   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Word 4, 6 or 8 is not x, y or z:  ',a)
 8320   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Word 5, 7 or 9 not integer or floating point value',
     &    ' or variable:  ',a)

        if (nword .ge. 5) then

          if    ((aword(4) .eq. 'x')  .or.
     &           (aword(4) .eq. 'X')) then
            n1 = 1
            n2 = 2
            n3 = 3
          elseif((aword(4) .eq. 'y')  .or.
     &           (aword(4) .eq. 'Y')) then
            n1 = 2
            n2 = 3
            n3 = 1
          elseif((aword(4) .eq. 'z')  .or.
     &           (aword(4) .eq. 'Z')) then
            n1 = 3
            n2 = 1
            n3 = 2
          else
            write (   6, 8310) ainput, ninput, aword(4)
            write (iout, 8310) ainput, ninput, aword(4)
            go to 800
          endif

          call varfind (5, 5)

          if ((mtype(5) .ne. 2) .and. (mtype(5) .ne. 3)) then
            write (   6, 8320) ainput, ninput, aword(5)
            write (iout, 8320) ainput, ninput, aword(5)
            go to 800
          endif

        endif                         ! nword .ge. 5

        if (nword .ge. 7) then

          if    ((aword(6) .eq. 'x')  .or.
     &           (aword(6) .eq. 'X')) then
            n2 = 1
            n3 = 6 - n1 - n2
          elseif((aword(6) .eq. 'y')  .or.
     &           (aword(6) .eq. 'Y')) then
            n2 = 2
            n3 = 6 - n1 - n2
          elseif((aword(6) .eq. 'z')  .or.
     &           (aword(6) .eq. 'Z')) then
            n2 = 3
            n3 = 6 - n1 - n2
          else
            write (   6, 8310) ainput, ninput, aword(6)
            write (iout, 8310) ainput, ninput, aword(6)
            go to 800
          endif

          call varfind (7, 7)

          if ((mtype(7) .ne. 2) .and. (mtype(7) .ne. 3)) then
            write (   6, 8320) ainput, ninput, aword(7)
            write (iout, 8320) ainput, ninput, aword(7)
            go to 800
          endif

        endif                         ! nword .ge. 7

        if (nword .eq. 9) then

          if    ((aword(8) .eq. 'x')  .or.
     &           (aword(8) .eq. 'X')) then
            n3 = 1
          elseif((aword(8) .eq. 'y')  .or.
     &           (aword(8) .eq. 'Y')) then
            n3 = 2
          elseif((aword(8) .eq. 'z')  .or.
     &           (aword(8) .eq. 'Z')) then
            n3 = 3
          else
            write (   6, 8310) ainput, ninput, aword(8)
            write (iout, 8310) ainput, ninput, aword(8)
            go to 800
          endif

          call varfind (9, 9)

          if ((mtype(9) .ne. 2) .and. (mtype(9) .ne. 3)) then
            write (   6, 8320) ainput, ninput, aword(9)
            write (iout, 8320) ainput, ninput, aword(9)
            go to 800
          endif

        endif                         ! nword .eq. 9

 8355   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Can not use same axis more than once:  ' / a / a / a)

        if ((n1 .eq. n2)            .or.
     &      (n2 .eq. n3)            .or.
     &      (n3 .eq. n1))           then
          write (   6, 8355) ainput, ninput, aword(4), aword(6),
     &      aword(8)
          write (iout, 8355) ainput, ninput, aword(4), aword(6),
     &      aword(8)
          go to 800
        endif

c....   Find the angle units.

        iunit = 0
        if (angunit .eq. 'radians') iunit = 1

c....   Find the rotation operator.

        ang1 = fword(5)
        ang2 = fword(7)
        ang3 = fword(9)

        call aptrots (n1, ang1, n2, ang2, n3, ang3, iunit, tol,
     &                toper(1,1,nop), nerr)

        ang1 = -fword(5)
        ang2 = -fword(7)
        ang3 = -fword(9)

        call aptrots (n3, ang3, n2, ang2, n1, ang1, iunit, tol,
     &                topin(1,1,nop), nerr)
c???
c???c....   Check operator.
c???
c???        call aptrotq (toper(1,1,nop), iunit, tol, theta, ux, uy, uz,
c???     &                thx, thy, thz, nerr)
c???
c???        if (nerr .ne. 0) then
c???          go to 800
c???        endif

        aoptype(nop) = 'rotate'
        aoptyps(nop) = 'serial'

        go to 810

c===============================================================================

c.... Input line:  operator OPNAME invert

c.... Invert through the origin.  Same as scale with RATIO = -1.

      elseif ((aword(3) .eq. 'invert') .or.
     &        (aword(3) .eq. 'inv'))   then

 8370   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 3:  ',i3)
        if (nword .ne. 3) then
          write (   6, 8370) ainput, ninput, nword
          write (iout, 8370) ainput, ninput, nword
          go to 800
        endif

        toper(1,1,nop) = -1.0
        toper(1,2,nop) =  0.0
        toper(1,3,nop) =  0.0
        toper(2,1,nop) =  0.0
        toper(2,2,nop) = -1.0
        toper(2,3,nop) =  0.0
        toper(3,1,nop) =  0.0
        toper(3,2,nop) =  0.0
        toper(3,3,nop) = -1.0

        topin(1,1,nop) = -1.0
        topin(1,2,nop) =  0.0
        topin(1,3,nop) =  0.0
        topin(2,1,nop) =  0.0
        topin(2,2,nop) = -1.0
        topin(2,3,nop) =  0.0
        topin(3,1,nop) =  0.0
        topin(3,2,nop) =  0.0
        topin(3,3,nop) = -1.0

        aoptype(nop) = 'invert'
        aoptyps(nop) = ' '

        go to 810

c===============================================================================

c.... Input line:  operator OPNAME [scale,uniform] RATIO

c.... Scale uniformly, with the invariant point at the origin.

      elseif ((aword(3) .eq. 'uniform') .or.
     &        (aword(3) .eq. 'scale')   .or.
     &        (aword(3) .eq. 'sc'))     then

 8380   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 4:  ',i3)
        if (nword .ne. 4) then
          write (   6, 8380) ainput, ninput, nword
          write (iout, 8380) ainput, ninput, nword
          go to 800
        endif

 8390   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Word 4 not integer or floating point value or',
     &  ' variable:  ',a)

        call varfind (4, 4)

        if ((mtype(4) .ne. 2) .and. (mtype(4) .ne. 3)) then
          write (   6, 8390) ainput, ninput, aword(4)
          write (iout, 8390) ainput, ninput, aword(4)
          go to 800
        endif

 8395   format ('  operator WARNING.  Reading ',a38,' line ',i5,'.' /
     &    '  Scale factor is zero.  Not reversible.')
 8396   format ('  operator WARNING.  Reading ',a38,' line ',i5,'.' /
     &    '  SCALE FACTOR MAY BE TOO SMALL OR LARGE:  ',1pe22.14 /
     &    '  NOT REVERSIBLE IF APPLIED TO A QUADRIC SURFACE.' )

        ratio = fword(4)

        if (ratio .eq. 0.0) then
          write (   6, 8395) ainput, ninput
          write (iout, 8395) ainput, ninput
        endif

        if (tol .ne. 0.0) then
          if ((ratio**2 .le. tol)        .or.
     &        (ratio**2 * tol .ge. 1.0)) then
            write (   6, 8396) ainput, ninput, ratio
            write (iout, 8396) ainput, ninput, ratio
          endif
        endif

        ratio = fword(4)

        toper(1,1,nop) =  ratio
        toper(1,2,nop) =  0.0
        toper(1,3,nop) =  0.0
        toper(2,1,nop) =  0.0
        toper(2,2,nop) =  ratio
        toper(2,3,nop) =  0.0
        toper(3,1,nop) =  0.0
        toper(3,2,nop) =  0.0
        toper(3,3,nop) =  ratio

        ratio = 1.0 / (ratio + small)

        topin(1,1,nop) =  ratio
        topin(1,2,nop) =  0.0
        topin(1,3,nop) =  0.0
        topin(2,1,nop) =  0.0
        topin(2,2,nop) =  ratio
        topin(2,3,nop) =  0.0
        topin(3,1,nop) =  0.0
        topin(3,2,nop) =  0.0
        topin(3,3,nop) =  ratio

        aoptype(nop) = 'scale'
        aoptyps(nop) = 'uniform'

        go to 810

c===============================================================================

c.... Input line:  operator OPNAME planar  PLNAME1 PLNAME2

c.... Rotate one plane to be parallel with another plane, around an axis
c....   parallel to both planes.

      elseif (aword(3) .eq. 'planar')    then

 8410   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 5:  ',i3)
        if (nword .ne. 5) then
          write (   6, 8410) ainput, ninput, nword
          write (iout, 8410) ainput, ninput, nword
          go to 800
        endif

c....   Find the first plane.

 8420   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  First plane does not exist:  ',a)
        do 420 n = 1, nquads
          if (aqtype(n) .ne. aqtypes(0)) go to 420
          if (aword(4) .eq. aquad(n)) then
            n1 = n
            call plout (n, n)
            go to 430
          endif
  420   continue
        write (   6, 8420) ainput, ninput, aword(4)
        write (iout, 8420) ainput, ninput, aword(4)
        go to 800

c....   Find the second plane.

 8430   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Second plane does not exist:  ',a)
  430   do 440 n = 1, nquads
          if (aqtype(n) .ne. aqtypes(0)) go to 440
          if (aword(5) .eq. aquad(n)) then
            n2 = n
            call plout (n, n)
            go to 450
          endif
  440   continue
        write (   6, 8430) ainput, ninput, aword(5)
        write (iout, 8430) ainput, ninput, aword(5)
        go to 800

  450   continue

c....   Check the lengths of the normal vectors.

        call aptvusz (qx(n1), qy(n1), qz(n1), tol,
     &                dx1, dy1, dz1, vlen1)

        call aptvusz (qx(n2), qy(n2), qz(n2), tol,
     &                dx2, dy2, dz2, vlen2)

 8450   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Plane has zero normal vector:  ',a)

        if (vlen1 .eq. 0.0) then
          write (   6, 8450) ainput, ninput, aword(4)
          write (iout, 8450) ainput, ninput, aword(4)
          go to 800
        endif

        if (vlen2 .eq. 0.0) then
          write (   6, 8450) ainput, ninput, aword(5)
          write (iout, 8450) ainput, ninput, aword(5)
          go to 800
        endif

c....   Find the rotation operator.

        call aptrotv (dx1, dy1, dz1, dx2, dy2, dz2, tol,
     &                toper(1,1,nop), nerr)

        call aptrotv (dx2, dy2, dz2, dx1, dy1, dz1, tol,
     &                topin(1,1,nop), nerr)
c???
c???c....   Check operator.
c???
c???        iunit = 0
c???        if (angunit .eq. 'radians') iunit = 1
c???
c???        call aptrotq (toper(1,1,nop), iunit, tol, theta, ux, uy, uz,
c???     &                thx, thy, thz, nerr)
c???
c???        if (nerr .ne. 0) then
c???          go to 800
c???        endif

        aoptype(nop) = 'rotate'
        aoptyps(nop) = 'planar'

        go to 810

c===============================================================================

c.... Input line:  operator OPNAME triple  VNAME1 VNAME2 VNAME3 VNAME4

c.... Rotate vector VNAME1 to be parallel to vector VNAME3, and the plane
c....    containing vectors VNAME1 and VNAME2 to be parallel to the plane
c....    containing vectors VNAME3 and VNAME4.

      elseif (aword(3) .eq. 'triple')    then

 8500   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 7:  ',i3)
        if (nword .ne. 7) then
          write (   6, 8500) ainput, ninput, nword
          write (iout, 8500) ainput, ninput, nword
          go to 800
        endif

c....   Find the first vector.

        call vectfind (4, n1)

        if (n1 .eq. 0) go to 800

c....   Find the second vector.

        call vectfind (5, n2)

        if (n2 .eq. 0) go to 800

c....   Find the third vector.

        call vectfind (6, n3)

        if (n3 .eq. 0) go to 800

c....   Find the fourth vector.

        call vectfind (7, n4)

        if (n4 .eq. 0) go to 800

c....   See if any of the vectors has zero length.

        if (vlen(n1) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(4)
          write (iout, 8210) ainput, ninput, aword(4)
          go to 800
        endif

        if (vlen(n2) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(5)
          write (iout, 8210) ainput, ninput, aword(5)
          go to 800
        endif

        if (vlen(n3) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(6)
          write (iout, 8210) ainput, ninput, aword(6)
          go to 800
        endif

        if (vlen(n4) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(7)
          write (iout, 8210) ainput, ninput, aword(7)
          go to 800
        endif

c....   Find the components of the vectors.
        
        dx1 = xcom(n1)
        dy1 = ycom(n1)
        dz1 = zcom(n1)
        dx2 = xcom(n2)
        dy2 = ycom(n2)
        dz2 = zcom(n2)
        dx3 = xcom(n3)
        dy3 = ycom(n3)
        dz3 = zcom(n3)
        dx4 = xcom(n4)
        dy4 = ycom(n4)
        dz4 = zcom(n4)

c....   Find the rotation operator.

        call aptrott (dx1, dy1, dz1, dx2, dy2, dz2,
     &                dx3, dy3, dz3, dx4, dy4, dz4, tol,
     &                toper(1,1,nop), nerr)

        call aptrott (dx3, dy3, dz3, dx4, dy4, dz4,
     &                dx1, dy1, dz1, dx2, dy2, dz2, tol,
     &                topin(1,1,nop), nerr)

 8590   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Null vector, or parallel vector pair:  ' / a / a / a / a)

        if (nerr .ne. 0) then
          write (   6, 8590) ainput, ninput, (aword(n), n = 4,7)
          write (iout, 8590) ainput, ninput, (aword(n), n = 4,7)
          go to 800
        endif
c???
c???c....   Check operator.
c???
c???        iunit = 0
c???        if (angunit .eq. 'radians') iunit = 1
c???
c???        call aptrotq (toper(1,1,nop), iunit, tol, theta, ux, uy, uz,
c???     &                thx, thy, thz, nerr)
c???
c???        if (nerr .ne. 0) then
c???          go to 800
c???        endif

        aoptype(nop) = 'rotate'
        aoptyps(nop) = 'triple'

        go to 810

c===============================================================================

c.... Input line:  operator OPNAME linear  VAXIS RATIO

c.... Scale in the direction parallel to a specified vector, by a specified
c....   scale factor.

      elseif (aword(3) .eq. 'linear')    then

 8610   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 5:  ',i3)
        if (nword .ne. 5) then
          write (   6, 8610) ainput, ninput, nword
          write (iout, 8610) ainput, ninput, nword
          go to 800
        endif

c....   Find the vector.

        call vectfind (4, n1)

        if (n1 .eq. 0) go to 800

c....   See if the vector has zero length.

        if (vlen(n1) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(4)
          write (iout, 8210) ainput, ninput, aword(4)
          go to 800
        endif

c....   Find the scale factor.

 8640   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Word 5 not integer or floating point value or',
     &    ' variable:  ',a)

        call varfind (5, 5)

        if ((mtype(5) .ne. 2) .and. (mtype(5) .ne. 3)) then
          write (   6, 8640) ainput, ninput, aword(5)
          write (iout, 8640) ainput, ninput, aword(5)
          go to 800
        endif

        if (vlen(n1) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(4)
          write (iout, 8210) ainput, ninput, aword(4)
          go to 800
        endif

        ratio = fword(5)

        if (ratio .eq. 0.0) then
          write (   6, 8395) ainput, ninput
          write (iout, 8395) ainput, ninput
        endif

        if (tol .ne. 0.0) then
          if ((ratio**2 .le. tol)        .or.
     &        (ratio**2 * tol .ge. 1.0)) then
            write (   6, 8396) ainput, ninput, ratio
            write (iout, 8396) ainput, ninput, ratio
          endif
        endif

c....   Find the scaling operator.

        call aptscll (ratio, xcom(n1), ycom(n1), zcom(n1),
     &                0., 0., 0., px, py, pz, 0, tol,
     &                toper(1,1,nop), nerr)

        ratio = 1.0 / (ratio + small)

        call aptscll (ratio, xcom(n1), ycom(n1), zcom(n1),
     &                0., 0., 0., px, py, pz, 0, tol,
     &                topin(1,1,nop), nerr)

        if (nerr .ne. 0) then
          write (   6, 8210) ainput, ninput, aword(4)
          write (iout, 8210) ainput, ninput, aword(4)
          go to 800
        endif

        aoptype(nop) = 'scale'
        aoptyps(nop) = 'linear'

        go to 810

c===============================================================================

c.... Input line:  operator OPNAME radial  VAXIS RATIO

c.... Scale in the direction perpendicular to a specified axis, by a specified
c....   scale factor.

      elseif (aword(3) .eq. 'radial')    then

 8740   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 5:  ',i3)
        if (nword .ne. 5) then
          write (   6, 8740) ainput, ninput, nword
          write (iout, 8740) ainput, ninput, nword
          go to 800
        endif

c....   Find the vector.

        call vectfind (4, n1)

        if (n1 .eq. 0) go to 800

c....   See if the vector has zero length.

        if (vlen(n1) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(4)
          write (iout, 8210) ainput, ninput, aword(4)
          go to 800
        endif

c....   Find the scale factor.

 8770   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Word 5 not integer or floating point value or',
     &    ' variable:  ',a)

        call varfind (5, 5)

        if ((mtype(5) .ne. 2) .and. (mtype(5) .ne. 3)) then
          write (   6, 8770) ainput, ninput, aword(5)
          write (iout, 8770) ainput, ninput, aword(5)
          go to 800
        endif

        if (vlen(n1) .eq. 0.0) then
          write (   6, 8210) ainput, ninput, aword(4)
          write (iout, 8210) ainput, ninput, aword(4)
          go to 800
        endif

        ratio = fword(5)

        if (ratio .eq. 0.0) then
          write (   6, 8395) ainput, ninput
          write (iout, 8395) ainput, ninput
        endif

        if (tol .ne. 0.0) then
          if ((ratio**2 .le. tol)        .or.
     &        (ratio**2 * tol .ge. 1.0)) then
            write (   6, 8396) ainput, ninput, ratio
            write (iout, 8396) ainput, ninput, ratio
          endif
        endif

c....   Find the scaling operator.

        call aptsclr (ratio, xcom(n1), ycom(n1), zcom(n1),
     &                0., 0., 0., px, py, pz, 0, tol,
     &                toper(1,1,nop), nerr)

        ratio = 1.0 / (ratio + small)

        call aptsclr (ratio, xcom(n1), ycom(n1), zcom(n1),
     &                0., 0., 0., px, py, pz, 0, tol,
     &                topin(1,1,nop), nerr)

        if (nerr .ne. 0) then
          write (   6, 8210) ainput, ninput, aword(4)
          write (iout, 8210) ainput, ninput, aword(4)
          go to 800
        endif

        aoptype(nop) = 'scale'
        aoptyps(nop) = 'radial'

        go to 810

c===============================================================================

c.... Input line:  operator OPNAME reflect PLNAME

c.... Reflect in the plane through the origin, parallel to a specified plane.

      elseif ((aword(3) .eq. 'reflect') .or.
     &        (aword(3) .eq. 'refl'))   then

 8660   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 4:  ',i3)
        if (nword .ne. 4) then
          write (   6, 8660) ainput, ninput, nword
          write (iout, 8660) ainput, ninput, nword
          go to 800
        endif

c....   Find the plane, and the three points defining it.

 8670   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Named plane does not exist:  ',a)
        do 670 n = 1, nquads
          if (aqtype(n) .ne. aqtypes(0)) go to 670
          if (aword(4) .eq. aquad(n)) then
            n1 = n
            call plout (n, n)
            go to 680
          endif
  670   continue
        write (   6, 8670) ainput, ninput, aword(4)
        write (iout, 8670) ainput, ninput, aword(4)
        go to 800

c....   Find the reflection operator.

 8680   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Plane is not well defined:  ',a)

  680   call aptrefs (0, xcen(n1), ycen(n1), zcen(n1),
     &                   qx(n1), qy(n1), qz(n1),
     &                   cx, cy, cz, px, py, pz, 0, tol,
     &                   toper(1,1,nop), nerr)

        call aptrefs (0, xcen(n1), ycen(n1), zcen(n1),
     &                   qx(n1), qy(n1), qz(n1),
     &                   cx, cy, cz, px, py, pz, 0, tol,
     &                   topin(1,1,nop), nerr)

        if (nerr .ne. 0) then
          write (   6, 8680) ainput, ninput, aword(4)
          write (iout, 8680) ainput, ninput, aword(4)
          go to 800
        endif

        aoptype(nop) = 'reflect'
        aoptyps(nop) = ' '

        go to 810

c===============================================================================

c.... Input line:  operator OPNAME plane     PLNAME
c.... Input line:  operator OPNAME sphere    SPHNAME
c.... Input line:  operator OPNAME cylinder  CYLNAME
c.... Input line:  operator OPNAME cone      CNNAME
c.... Input line:  operator OPNAME hyperb    HPNAME
c.... Input line:  operator OPNAME ellipsoid ELNAME
c.... Input line:  operator OPNAME axisym    AXNAME
c.... Input line:  operator OPNAME quadric   QNAME

c.... Rotate quadric QNAME onto the principle axes.

      elseif ((aword(3) .eq. 'quadric')   .or.
     &        (aword(3) .eq. 'quad')      .or.
     &        (aword(3) .eq. 'q')         .or.
     &        (aword(3) .eq. 'plane')     .or.
     &        (aword(3) .eq. 'pl')        .or.
     &        (aword(3) .eq. 'sphere')    .or.
     &        (aword(3) .eq. 'sph')       .or.
     &        (aword(3) .eq. 'cylinder')  .or.
     &        (aword(3) .eq. 'cyl')       .or.
     &        (aword(3) .eq. 'cone')      .or.
     &        (aword(3) .eq. 'hyperb')    .or.
     &        (aword(3) .eq. 'saddle')    .or.
     &        (aword(3) .eq. 'ellipsoid') .or.
     &        (aword(3) .eq. 'ellipse')   .or.
     &        (aword(3) .eq. 'ell')       .or.
     &        (aword(3) .eq. 'el')        .or.
     &        (aword(3) .eq. 'axisym'))   then

 8710   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Number of words is not 4:  ',i3)

        if (nword .ne. 4) then
          write (   6, 8710) ainput, ninput, nword
          write (iout, 8710) ainput, ninput, nword
          go to 800
        endif

c....   Find the quadric.

 8720   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Named quadric surface does not exist:  ',a)
 8730   format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Quadric has bad coefficients:  ',a)

        do 720 n = 1, nquads
          if (aword(4) .eq. aquad(n)) then

            call qutype (aword(3), n, 1, nerrq)

            if (nerrq .ne. 0) go to 999

            nq = n
            call quout (n, n, 'min', nerrq)
            go to 730

          endif
  720   continue
        write (   6, 8720) ainput, ninput, aword(4)
        write (iout, 8720) ainput, ninput, aword(4)
        go to 800

  730   toper(1,1,nop) = rotq(1,1)
        toper(1,2,nop) = rotq(1,2)
        toper(1,3,nop) = rotq(1,3)
        toper(2,1,nop) = rotq(2,1)
        toper(2,2,nop) = rotq(2,2)
        toper(2,3,nop) = rotq(2,3)
        toper(3,1,nop) = rotq(3,1)
        toper(3,2,nop) = rotq(3,2)
        toper(3,3,nop) = rotq(3,3)

        topin(1,1,nop) = toper(1,1,nop)
        topin(1,2,nop) = toper(2,1,nop)
        topin(1,3,nop) = toper(3,1,nop)
        topin(2,1,nop) = toper(1,2,nop)
        topin(2,2,nop) = toper(2,2,nop)
        topin(2,3,nop) = toper(3,2,nop)
        topin(3,1,nop) = toper(1,3,nop)
        topin(3,2,nop) = toper(2,3,nop)
        topin(3,3,nop) = toper(3,3,nop)

        aoptype(nop) = 'rotate'
        aoptyps(nop) = 'quadric'

        go to 810

c===============================================================================

c.... Input line:  unrecognized

      else
        write (   6, 8170) ainput, ninput, aword(3)
        write (iout, 8170) ainput, ninput, aword(3)
        go to 800
      endif

c===============================================================================

c.... An error was found.

 8800 format ('  operator ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Bad arguments.')

  800 if (nrep .eq. 0) then
        if (nop .eq. nopers) nopers = nopers - 1
      endif
      write (   6, 8800) ainput, ninput
      write (iout, 8800) ainput, ninput
      go to 999

  810 aoper(nop) = aword(2)
      aopers     = aword(2)
      laopers    = lword(2)

c.... Print the value of the operator.

      amount = 'maximum'
      call opout (nop, nop, amount)

  999 return

c.... End of subroutine operator.     (+1 line)
      end
