      subroutine ptdep (np, ndep, aclustx)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  ptdep    Updated     2004 November 23 13:30.
c               ptdep    Originated  1994 March 16 16:20.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To test points to see if any other objects depend on them.
c
c     Logic:    Entry points:  ptdep
c ptdep         Called by:  delete.
c
c               Calls:  (none).
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*24 aclustx            ! Name of cluster deleting points in.

 8230 format ('  WARNING:  point ',a,' is in cluster ',a)
 8240 format ('  ptdep ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Can not delete point ',a,' defining line ',a)
 8250 format ('  ptdep ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Can not delete point ',a,' defining triangle ',a)
 8260 format ('  ptdep ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Can not delete point ',a,' defining reg polygon ',a)
 8270 format ('  ptdep ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Can not delete point ',a,' defining disk:  ',a)
 8280 format ('  ptdep ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Can not delete point ',a,' defining tetrahedron ',a)
 8290 format ('  ptdep ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Can not delete point ',a,' defining reg polyhed ',a)

      ndep = 0

      do 230 npr = 1, npairs
        if (apairpt(npr) .eq. apoint(np)) then
          if (apaircl(npr) .ne. aclustx) then
            write (   6, 8230) apoint(np), apaircl(npr)
            write (iout, 8230) apoint(np), apaircl(npr)
          endif
        endif
  230 continue

      do 240 nn = 1, nlines
        if (aline(nn) .eq. ' ') go to 240
        if ((alipt1(nn) .eq. apoint(np)) .or.
     &      (alipt2(nn) .eq. apoint(np))) then
          write (   6, 8240) ainput, ninput, apoint(np), aline(nn)
          write (iout, 8240) ainput, ninput, apoint(np), aline(nn)
          ndep = 1
        endif
  240 continue

      do 250 nn = 1, ntrigs
        if (atrig(nn) .eq. ' ') go to 250
        if ((atript1(nn) .eq. apoint(np))  .or.
     &      (atript2(nn) .eq. apoint(np))  .or.
     &      (atript3(nn) .eq. apoint(np))) then
          write (   6, 8250) ainput, ninput, apoint(np), atrig(nn)
          write (iout, 8250) ainput, ninput, apoint(np), atrig(nn)
          ndep = 1
        endif
  250 continue

      do 260 nn = 1, npolygs
        if (apolyg(nn) .eq. ' ') go to 260
        if ((acenpg(nn) .eq. apoint(np))  .or.
     &      (averpg(nn) .eq. apoint(np))  .or.
     &      (acoppg(nn) .eq. apoint(np))) then
          write (   6, 8260) ainput, ninput, apoint(np), apolyg(nn)
          write (iout, 8260) ainput, ninput, apoint(np), apolyg(nn)
          ndep = 1
        endif
  260 continue

      do 270 nn = 1, ndisks
        if (adisk(nn) .eq. ' ') go to 270
        if (acendk(nn) .eq. apoint(np)) then
          write (   6, 8270) ainput, ninput, apoint(np), adisk(nn)
          write (iout, 8270) ainput, ninput, apoint(np), adisk(nn)
          ndep = 1
        endif
  270 continue

      do 280 nn = 1, ntets
        if (atetra(nn) .eq. ' ') go to 280
        if ((atetpt(1,nn) .eq. apoint(np))  .or.
     &      (atetpt(2,nn) .eq. apoint(np))  .or.
     &      (atetpt(3,nn) .eq. apoint(np))  .or.
     &      (atetpt(4,nn) .eq. apoint(np))) then
          write (   6, 8280) ainput, ninput, apoint(np), atetra(nn)
          write (iout, 8280) ainput, ninput, apoint(np), atetra(nn)
          ndep = 1
        endif
  280 continue

      do 290 nn = 1, npolyhs
        if (apolyh(nn) .eq. ' ') go to 290
        if ((acenph(nn) .eq. apoint(np))  .or.
     &      (averph(nn) .eq. apoint(np))  .or.
     &      (acopph(nn) .eq. apoint(np))) then
          write (   6, 8290) ainput, ninput, apoint(np), apolyh(nn)
          write (iout, 8290) ainput, ninput, apoint(np), apolyh(nn)
          ndep = 1
        endif
  290 continue

      return

c.... End of subroutine ptdep.        (+1 line)
      end
