      subroutine quadfind (nw, nq)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  quadfind Updated     1997 October 29 12:00.
c               quadfind Originated  1997 October 29 12:00.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find a quadric surface with the same name as an ASCII
c               argument, or the value of an ASCII variable argument,
c               display the quadric surface, or display an error message.
c
c     Logic:    Entry points:  quadfind.
c quadfind      Called by:  arc, quadric, triple.
c
c quadfind      Calls:  quout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     aword(nw) Input    Name of quadric surface to find.
c
c     nq        Output   Index of quadric surface.
c
c     nw        Input    Index of argument to test.     
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

 8110 format ('  quadfind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Argument number is bad:  ',i5)

      if ((nw .lt. 1)      .or.
     &    (nw .gt. nword)) then
        write (   6, 8110) ainput, ninput, nw
        write (iout, 8110) ainput, ninput, nw
        go to 999
      endif

      nq = 0

      do 120 n = 1, nquads            ! Loop over quadric surfaces.
        if (aword(nw) .eq. aquad(n)) then
          nq = n
          call quout (nq, nq, 'min', nerrq)
          go to 999
        endif
  120 continue                        ! End of loop over vectors.

 8120 format ('  quadfind ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Named quadric surface does not exist:  ',a)

      write (   6, 8120) ainput, ninput, aword(nw)
      write (iout, 8120) ainput, ninput, aword(nw)

  999 return

c.... End of subroutine quadfind.     (+1 line)
      end
