      subroutine savecmd

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  savecmd  Updated     2006 March 21 16:30.
c               savecmd  Originated  2006 March 21 16:30.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  to save the input line in the list of saved commands and in
c               file geom.cmd.
c
c     Logic:    Entry points:  savecmd.
c savecmd       Called by:  variable, main.
c
c savecmd       Calls:  (none)
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c=======================================================================********

 8325 format ('>',79a1)
 8330 format ('>',80a1)
 8341 format (/ '>',79a1)
 8342 format (/ '>',80a1)
 8343 format (      80a1)

c.... Find the last non-blank character.

      nchars = ncharm
      do i = ncharm,1,-1
        if (achar(i) .ne. ' ') then
          nchars = i
          go to 110
        endif
      enddo

c.... Display the input line on the user's terminal and the output file,
c....   preceded by ">".

  110 if (ainput .ne. 'tty') then
        if (nchars .le. 79) then
          write (   6, 8325) (achar(i), i = 1, nchars)
        else
          write (   6, 8330) (achar(i), i = 1, nchars)
        endif
      endif

      if (nchars .le. 79) then
        write (iout, 8341) (achar(i), i = 1, nchars)
      else
        write (iout, 8342) (achar(i), i = 1, nchars)
      endif

      if ((nloop .eq. 0) .or. (ainput .ne. "geom.cmd")) then

c....   Add the input line, as a command, to the list of saved input lines,
c....     and to the command file geom.cmd.

        ncmds = ncmds + 1

        nn = 1 + mod (ncmds - 1, ncmdm)

        do 280 n = 1, ncharm
          acmd(n,nn) = achar(n)
  280   continue

        write (icmd, 8343) (achar(i), i = 1, nchars)
cbugc***DEBUG begins.
cbug 9111 format ('DEBUG.  ncmds=',i5 /
cbug     &  120a1)
cbug      write (   6, 9111) ncmds, (achar(i), i = 1, nchars)
cbug      write (iout, 9111) ncmds, (achar(i), i = 1, nchars)
cbugc***DEBUG ends.

      endif                         ! Not repeating a loop.

c=======================================================================********

      return

c.... End of subroutine savecmd.      (+1 line)
      end
