      subroutine spin

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  spin     Updated     2007 January 18 14:00.
c               spin     Originated  1995 April 3 13:50.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To spin the random number sequence.
c
c     Logic:    Entry points:  spin.
c spin          Called by:  helpall, main.
c
c spin          Calls:  varfind.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Local variables.

c.... Input line:  spin [help]

 8110 format (
     &  '  Command "spin":  acceptable input lines include:' /
     &  '  "spin [help]"  Display this message.' /
     &  '  "spin random"  Randomize the random number seed.' /
     &  '  "spin N"       Use up N random numbers.' /
     &  '  Synonyms:  [help, h], [random, ?].' )

c=======================================================================********

c.... Initialize random number sequence.  Use first 10.

      if (nword .eq. 0) then
        do n = 1, 10
          xran = ranf ()
        enddo
        go to 999
      endif

c=======================================================================********

      if ((nword .eq. 1) .or.
     &   ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))) then
        write (   6, 8110)
        write (iout, 8110)
        go to 999
      endif

c=======================================================================********

c.... Test input for validity.

 8115 format ('  spin ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Wrong number of words on input line:  ',i3)

      if (nword .ne. 2) then
        write (   6, 8115) ainput, ninput
        write (iout, 8115) ainput, ninput
        go to 999
      endif

c=======================================================================********

c.... Input line:  spin random

 8122 format ('  Randomized the random number seed.')

      if ((aword(2) .eq. 'random') .or.
     &    (aword(2) .eq. '?'))     then
        call random_seed ()

        write (   6, 8122)
        write (iout, 8122)

        go to 999
      endif

c=======================================================================********

 8120 format ('  spin ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Second argument is not an integer:  ',a)

      call varfind (2, 2)

      if (mtype(2) .ne. 2) then
        write (   6, 8120) ainput, ninput, aword(2)
        write (iout, 8120) ainput, ninput, aword(2)
        go to 999
      endif

 8125 format ('  spin ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Second argument is not a positive integer:  ',a)

      if (iword(2) .le. 0) then
        write (   6, 8125) ainput, ninput, aword(2)
        write (iout, 8125) ainput, ninput, aword(2)
        go to 999
      endif

c=======================================================================********

c.... Input line:  spin N

      do 110 n = 1, iword(2)
        xran = ranf ()
  110 continue

 8130 format ('  Used up',i9,' random numbers.')

      write (   6, 8130) iword(2)
      write (iout, 8130) iword(2)

c=======================================================================********

  999 return

c.... End of subroutine spin.         (+1 line)
      end
