      subroutine status

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  status   Updated     2004 Sepember 13 16:30.
c               status   Originated  1995 December 18 14:30.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the current status of:  problem title, input file,
c               output file, command summary file, coordinate system, angle
c               units, tolerance limit, word delimiter, integer mode for command
c               "icalc", binary display for "icalc", parsing flag.
c
c     Logic:    Entry points:  status.
c status        Called by:  main.
c
c status        System calls:  tbank.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Input line:  status

c.... Write problem title into output file.

 8110 format (/ '  Problem title:  ',9a8)

      if ((atitle(1) .ne. 'NOT SPEC') .and.
     &    (atitle(2) .ne. 'IFIED'))   then
        write (   6, 8110) (atitle(i), i = 1, 9)
        write (iout, 8110) (atitle(i), i = 1, 9)
      endif

 8120 format ('  Input file (line',i8,'):  ',a)

      write (   6, 8120) ninput, ainput
      write (iout, 8120) ninput, ainput

 8130 format ('  Output file:   ',a)

      write (   6, 8130) afilout
      write (iout, 8130) afilout

 8132 format ('  Command file:  ',a)

      write (   6, 8132) afilcmd
      write (iout, 8132) afilcmd

 8195 format ('  Long prompt:        ',a3)

      write (   6, 8195) aprompt

 8196 format ('  Short prompt:       ',a8)

      write (   6, 8196) aprompts
      write (iout, 8196) aprompts

 8197 format ('  Parsing flag:       ',a7)

      write (   6, 8197) aparse
      write (iout, 8197) aparse

 8134 format ('  Field delimiter:    (blank)')
 8135 format ('  Field delimiter:    ',a1)

      if (afd .eq. ' ') then
        write (   6, 8134)
        write (iout, 8134)
      else
        write (   6, 8135) afd
        write (iout, 8135) afd
      endif


 8136 format ('  Command separator:  ;' )

      write (   6, 8136)
      write (iout, 8136)

 8140 format ('  Coordinate system:  ',a,5x,a9,a16,a9)

      write (   6, 8140) asys, acoordu, acoordv, acoordw
      write (iout, 8140) asys, acoordu, acoordv, acoordw

 8150 format ('  Angle unit:         ',a)

      write (   6, 8150) angunit
      write (iout, 8150) angunit

 8160 format ('  Tolerance limit tol:  ',1pe20.12)

      write (   6, 8160) tol
      write (iout, 8160) tol

 8170 format ('  Integer input mode for command "icalc":  ',a3)

      write (   6, 8170) amode
      write (iout, 8170) amode

 8180 format ('  Binary display for command "icalc":      on')
 8190 format ('  Binary display for command "icalc":      off')

      if (abind .eq. 'bin') then
        write (   6, 8180)
        write (iout, 8180)
      else
        write (   6, 8190)
        write (iout, 8190)
      endif

 8200 format ('  Machine time used (milliseconds):  ',i9,'.' //
     &  '  Use command "status" to repeat this display.' /
     &  '  See commands "title", "input", "output", "prompt", "delim",',
     &  ' "coordinate",' /
     &  '  "angles", "tol", "icalc".' )

      call tbank (ksecr)

      write (   6, 8200) ksecr
      write (iout, 8200) ksecr

      return

c.... End of subroutine status.       (+1 line)
      end
