c     include 'store.h'

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  store.h  Updated     2006 July 14 13:45.
c               store.h  Originated  1993 November 2 10:40.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To define all geom parameters and common blocks.
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

c.... Parameters needed for use of aptffip, aptchap and aptchtp.

c---- Max # of characters in an ASCII string.
      parameter (iamax  =  80)

c---- Max # of digits in an integer machine word.
c----   18 for 64-bit (DEC double), 13 for 46-bit (Crays).  9 for 32-bit.
cdec      parameter (idmax  =   9)
cray      parameter (idmax  =  13)
      parameter (idmax  =  18)        ! Actually 18.964

c.... Maximum number of big integers.

      parameter (nbigm  = 26)

c.... Maximum number of digits in a big integer (one digit per machine word).

      parameter (ndigm = 1001)

c---- Max + or - exponent in a floating-point machine word. 2465 for Cray.
c----   308 for DEC (double-precision real).
cdec      parameter (iemax  = 308)
cray      parameter (iemax  =2465)
      parameter (iemax  = 308)

c---- Maximum number of characters in an input line.
      parameter (ncharm =  80)

c---- Maximum number of words in an input line.
      parameter (nwordm =  40)

c____ Number of bits in a machine word.  32 for single precision, 64 for double.
cdec      parameter (nbitm  = 32)
cray      parameter (nbitm  = 64)
      parameter (nbitm  = 64)

c____ Numerical tolerence.
      parameter (tolz   = 1.e-11)     ! The default value of tol
      parameter (tolmin = 1.e-15)     ! The minimum value of tol, if not zero.

c____ A big number.
      parameter (bignum = 1.e+99)

c____ A small number.
      parameter (small  = 1.e-99)

c.... Array size limits.

c____ Maximum number of input files.
      parameter (nfilem =   100)

c____ Maximum number of aliases.
      parameter (naliasm =  512)

c____ Maximum number of markers.
      parameter (nmarkm  =  256)

c____ Maximum number of saved input lines.
      parameter (ncmdm   = 2000)

c____ Maximum number of variables.
      parameter (nvarm   = 1000)

c____ Maximum number of symbols.
      parameter (nsymbm  = 1000)

c____ Maximum number of points.
      parameter (npointm = 1000)

c____ Maximum number of clusters of points.
      parameter (nclustm =  100)

c____ Maximum number of cluster list pairs.
      parameter (npairm  = 1000)

c____ Maximum number of plot array columns.
      parameter (nplcolm =  168)

c____ Maximum number of plot array lines.
      parameter (nplinem =  104)

c____ Maximum number of plot points.
      parameter (nplptm  = 1000)

c____ Maximum number of plot point markers.
      parameter (nptmarkm = 256)

c____ Maximum number of lines.
      parameter (nlinem  = 1000)

c____ Maximum number of triangles.
      parameter (ntrigm  = 1000)

c____ Maximum number of tetrahedrons.
      parameter (ntetm   = 1000)

c____ Maximum number of regular polygons.
      parameter (npolygm = 1000)

c____ Maximum number of vertices on a regular polygon.
      parameter (nverpgm = 1000)

c____ Maximum number of annular disks.
      parameter (ndiskm  = 1000)

c____ Maximum number of regular polyhedrons.
      parameter (npolyhm = 1000)

c____ Maximum number of bricks.
      parameter (nbrickm = 1000)

c____ Maximum number of quadric surfaces, including planes.
      parameter (nquadm  = 1000)

c____ Maximum number of zones.
      parameter (nzonem  = 1000)

c____ Maximum number of quadric surfaces per zone.
      parameter (nzquadm =   16)

c____ Maximum number of vectors.
      parameter (nvectm  = 1000)

c____ Maximum number of operators.
      parameter (noperm  =  100)

c____ Maximum number of probability bins.
      parameter (nbinm   = 1000)

c____ Maximum number of probability distribution functions.
      parameter (npdfm   =  100)

c____ Maximum number of pdf/bin pairs.
      parameter (npdfxm  = 1000)

c____ Maximum number of synonym pairs.
      parameter (nsynm   =  400)

c____ Maximum number of temporary tables.
      parameter (ntempm  = 1000)

c____ Maximum number of nested do loops.
      parameter (nloopm  = 16)

c.... Physical constants.

c____ Mathematical constant pi.  Dimensionless.

      parameter (pi     = 3.14159265358979324)

c____ Base of natural logarithms e.  Dimensionless.
      parameter (ebase  = 2.71828182845904523)

c____ Euler's constant gamma.  Dimensionless.
      parameter (euler  = 0.577215664901533861)

c____ Golden ratio rgold.
      parameter (rgold  = 1.61803398874989485)

c.... Execution line data.

      common /aexec/  ainputex        ! Name of input file on execution line.
      character*80    ainputex        ! Name of input file on execution line.
      common /aexec/  aoutputex       ! Name of output file on execution line.
      character*80    aoutputex       ! Name of output file on execution line.

c.... Input/output file data.

      common /acome/  iin             ! I/O unit (2 or 5) for input.
      common /acome/  iout            ! I/O unit (3) for hsp output file.
      common /acome/  ainput          ! Input medium:  'tty' or filename.
      character*80    ainput          ! Input medium:  'tty' or filename.
      common /acome/  ainputs         ! NOT USED.
      character*80    ainputs         ! NOT USED.
      common /acome/  ninput          ! Number of lines read from ainput.
      common /acome/  ninputs         ! NOT USED.
      common /acome/  ainbeg          ! NOT USED.
      character*80    ainbeg          ! NOT USED.
      common /acome/  ainend          ! NOT USED.
      character*80    ainend          ! NOT USED.
      common /acome/  ainends         ! NOT USED.
      character*80    ainends         ! NOT USED.
      common /acome/  inbeg           ! NOT USED.
      common /acome/  inend           ! NOT USED.
      common /acome/  inends          ! NOT USED.

c.... Other type character variables.

      common /acome/  abox(4)         ! Box number and ID.  NOT USED.
      character*8     abox            ! Box number and ID.  NOT USED.
      common /acome/  afilin          ! NOT USED.
      character*80    afilin          ! NOT USED.
      common /acome/  afilout         ! Name of a hsp output file.
      character*80    afilout         ! Name of a hsp output file.
      common /acome/  asubxx          ! NOT USED.
      character*8     asubxx          ! NOT USED.
      common /acome/  aversion        ! Version year, month, day, machine.
      character*24    aversion        ! Version year, month, day, machine.
      common /acome/  aloddate        ! Load date.
      character*24    aloddate        ! Load date.
      common /acome/  alodmach        ! Machine letter.
      character*8     alodmach        ! Machine letter.
      common /acome/  alodtime        ! Load time.
      character*8     alodtime        ! Load time.

      common /acome/  atitle(20)      ! Problem title.
      character*8     atitle          ! Problem title.
      common /acomm/  adate           ! Run date.  NOTE:  should be acome.
      character*12    adate           ! Run date.
      common /acomm/  atime           ! Run time.  NOTE:  should be acome.
      character*12    atime           ! Run time.
      common /acomm/  amach           ! Run machine.  NOTE:  should be acome.
      character*8     amach           ! Run machine.

      common /acome/  icmd            ! I/O unit (24) for command file.
      common /acome/  afilcmd         ! Name of a command file, geom.cmd.
      character*80    afilcmd         ! Name of a command file.

      common/acome/   aprompt         ! Prompt flag, "on" or "off".
      character*8     aprompt         ! Prompt flag, "on" or "off".
      common/acome/   aprompts        ! Prompt string.
      character*8     aprompts        ! Prompt string.
      common/acome/   lprompts        ! Number of characters in prompt string.

c.... Variables needed for use of aptffip, aptchap and aptchtp.

      common /laptfg/ aword(nwordm)   ! User message fields.  ASCII (1).
      character*80    aword           ! User message fields.  ASCII (1).
      common /laptfg/ iword(nwordm)   ! User message fields.  Integer (2).
      common /laptfg/ fword(nwordm)   ! User message fields.  Real (3).
      common /laptfg/ lword(nwordm)   ! Post-subscript input field lengths.
      common /laptfg/ mtype(nwordm)   ! Input line field types.
                                      !   1 for ASCII, 2 for integer,
                                      !   3 for floating point.
      common /laptfg/ nword           ! Number of input line fields.
      common /laptfg/ achar(ncharm)   ! User message uncracked ASCII characters.
      character*1     achar           ! User message uncracked ASCII characters.
      common /laptfg/ nerr            ! Error return from apt subroutines.
      common /laptfg/ afd             ! Field delimiter.  A blank character.
      character*1     afd             ! Field delimiter.  A blank character.
      common /laptfg/ aparse          ! Flag to display parsing data, if "on".
      character*7     aparse          ! Flag to display parsing data, if "on".
      common /laptfg/ lwords(nwordm)  ! Pre-subscript input field lengths.

c.... Data for subscripted names.

      common /lsubss/ nsub            ! Number of subscripts in name.
      common /lsubss/ astem           ! ASCII stem of name.
      character*80    astem           ! ASCII stem of name.
      common /lsubss/ asub(16)        ! ASCII subscript of name.
      character*80    asub            ! ASCII subscript of name.
      common /lsubss/ fstem           ! Floating point stem of name.
      common /lsubss/ fsub(16)        ! Floating point subscript of name.
      common /lsubss/ istem           ! Integer stem of name.
      common /lsubss/ isub(16)        ! Integer subscript of name.
      common /lsubss/ lstem           ! Length of stem of name.
      common /lsubss/ lsub(16)        ! Length of subscript of name.
      common /lsubss/ mstem           ! Mode of stem of name.
      common /lsubss/ msub(16)        ! Mode of subscript of name.

c.... Problem sizes and data.

c.... Data for input files.

      common /lfile/  nfiles          ! Index of current input file.
      common /lfile/  ainfile(nfilem) ! Input medium:  'tty' or filename.
      character*80    ainfile         ! Input medium:  'tty' or filename.
      common /lfile/  ainfbeg(nfilem) ! Word to begin reading input file.
      character*80    ainfbeg         ! Word to begin reading input file.
      common /lfile/  ainfend(nfilem) ! Word to end   reading input file.
      character*80    ainfend         ! Word to end   reading input file.
      common /lfile/  infbeg(nfilem)  ! Line to begin reading input file.
      common /lfile/  infend(nfilem)  ! Line to end   reading input file.
      common /lfile/  inline(nfilem)  ! Number of lines read in input file.
      common /lfile/  incycle(nfilem) ! Input file cycle length.
      common /lfile/  nflast          ! Index of last input file.

c.... Data for plots.

      common /lplots/ nplcen          ! Indicates plot center specified, if 1.
      common /lplots/ nplcols         ! Number of plot array columns <= 168.
      common /lplots/ nplimh          ! Indicates h axis limits specified, if 1.
      common /lplots/ nplimv          ! Indicates v axis limits specified, if 1.
      common /lplots/ nplines         ! Number of plot array lines <= 104.
      common /lplots/ nplpts          ! Number of plot points <= 1000.
      common /lplots/ nptmarks        ! Number of point markers in use <= 256.
      common /lplots/ splhcen         ! Horizontal axis center on plot.
      common /lplots/ splhmax         ! Horizontal axis maximum on plot.
      common /lplots/ splhmin         ! Horizontal axis minimum on plot.
      common /lplots/ splvcen         ! Vertical axis center on plot.
      common /lplots/ splvmax         ! Vertical axis maximum on plot.
      common /lplots/ splvmin         ! Vertical axis minimum on plot.
      common /lplots/ spthmax         ! Horizontal axis maximum of plot points.
      common /lplots/ spthmin         ! Horizontal axis minimum of plot points.
      common /lplots/ sptvmax         ! Vertical axis maximum of plot points.
      common /lplots/ sptvmin         ! Vertical axis minimum of plot points.
      common /lplots/ xplot(nplptm)   ! X coordinate of a plot point.
      common /lplots/ yplot(nplptm)   ! Y coordinate of a plot point.
      common /lplots/ zplot(nplptm)   ! Z coordinate of a plot point.
      common /lplots/ zoomplh         ! Zoom factor for plot horizontal axis.
      common /lplots/ zoomplv         ! Zoom factor for plot vertical axis.
      common /lplots/ aplbuf(nplcolm,nplinem)
                                      ! Plot array.
      character*1     aplbuf          ! Plot array.
      common /lplots/ aplotm(nplptm)  ! Marker for a plot point.
      character*1     aplotm          ! Marker for a plot point.
      common /lplots/ aplmarkh        ! Marker with label of horizontal axis.
      character*1     aplmarkh        ! Marker with label of horizontal axis.
      common /lplots/ aplmarkt        ! Marker with name or title of plot.
      character*1     aplmarkt        ! Marker with name or title of plot.
      common /lplots/ aplmarkv        ! Marker with label of vertical axis.
      character*1     aplmarkv        ! Marker with label of vertical axis.
      common /lplots/ aplstat         ! Plotting status, "on" or "off".
      character*8     aplstat         ! Plotting status, "on" or "off".
      common /lplots/ aptmark(256)    ! Markers used for points in current plot.
      character*1     aptmark         ! Markers used for points in current plot.
      common /lplots/ aptmarks        ! Marker currently used for points.
      character*1     aptmarks        ! Marker currently used for points.
      common /lplots/ axish           ! Name of the coordinate of horiz. axis.
      character*8     axish           ! Name of the coordinate of horiz. axis.
      common /lplots/ axisv           ! Name of the coordinate of vertical axis.
      character*8     axisv           ! Name of the coordinate of vertical axis.

c.... Data for "if-endif" block commands.

      common /liftst/ nifnest         ! Number of unex nested "if-endif" blocks.
      common /liftst/ niftots         ! Number of nested "if-endif" blocks.

c.... Data for aliases.

      common /lalias/ nalias          ! Number of aliases.
      common /lalias/ alias1(naliasm) ! Name of an alias.
      character*24    alias1          ! Name of an alias.
      common /lalias/ alias2(naliasm) ! Replacement string of alias.
      character*72    alias2          ! Replacement string of alias.
      common /lalias/ alias1s         ! Base name for aliases.
      character*24    alias1s         ! Base name for aliases.
      common /lalias/ lalias2(naliasm)! Number of characters in alias2.
      common /lalias/ lalias1s        ! Number of characters in alias1s.


c.... Data for markers.

      common /lmark/  nmarks          ! Number of markers.
      common /lmark/  amark(nmarkm)   ! Marker.
      character*1     amark           ! Marker.
      common /lmark/  amarkt(nmarkm)  ! Text corresponding to marker.
      character*72    amarkt          ! Text corresponding to marker.
      common /lmark/  amarks          ! Base name for markers.
      character*1     amarks          ! Base name for markers.
      common /lmark/  amarkdum        ! Dummy to align memory.
      character*7     amarkdum        ! Dummy to align memory.
      common /lmark/  lamarks         ! Number of characters in amarks (1).

c.... Data for saved input lines.

      common /lcmd/   ncmds           ! Number of command lines in geom.cmd.
      common /lcmd/   acmd(ncharm,ncmdm)
                                      ! A command line in geom.cmd.
      character*1     acmd            ! A command line in geom.cmd.
      common /lcmd/   ncmdsums        ! NOT USED.

c.... Data for multiple statement lines.

      common /lstatm/ nstat           ! Number of current statement (with ";").
      common /lstatm/ nstats          ! Number of statements on input line.
      common /lstatm/ istat(ncharm)   ! Character positions of ";" characters.
      common /lstatm/ astat(ncharm)   ! Characters in separated statement.

      character*1     astat           ! Characters in separated statement.

c.... Data for truncation and round-off control.

      common /ltol/   tol             ! Truncation and round-off control.

c.... Data for coordinate system and angle units.

      common /lunits/ angunit         ! Angle units:  'degrees' or 'radians'.
      character*8     angunit         ! Angle units:  'degrees' or 'radians'.

      common /lunits/ asys            ! Coordinate system:
      character*8     asys            ! Coordinate system:  'rect', 'cyl' or
                                      !   'sph'.
      common /lunits/ acoordu         ! Name of the first coordinate.
      character*16    acoordu         ! Name of the first coordinate.
      common /lunits/ acoordv         ! Name of the second coordinate.
      character*16    acoordv         ! Name of the second coordinate.
      common /lunits/ acoordw         ! Name of the third coordinate.
      character*16    acoordw         ! Name of the third coordinate.

c.... Data for integer arithmetic.

      common /lint/   amode           ! Mode of integer arithmetic.
      character*8     amode           ! Mode of integer arithmetic.
      common /lint/   abind           ! Option, 'bin' to display binary values.
      character*8     abind           ! Option, 'bin' to display binary values.

c.... Data for named variables.

      common /lvar/   nvars           ! Number of named variables (<= nvarm).
      common /lvar/   avarbl(nvarm)   ! Name of a variable.
      character*24    avarbl          ! Name of a variable.
      common /lvar/   avar(nvarm)     ! Same as avarbl, but NOT USED.
      character*80    avar            ! Same as avarbl, but NOT USED.
      common /lvar/   fvar(nvarm)     ! Floating point value of avarbl.
      common /lvar/   ivar(nvarm)     ! Integer value of avarbl.
      common /lvar/   lvar(nvarm)     ! Number of characters in avarbl.
      common /lvar/   mvar(nvarm)     ! Mode of avarbl (2 or 3).
      common /lvar/   avarbls         ! Base name for variables.
      character*24    avarbls         ! Base name for variables.
      common /lvar/   lavarbls        ! Number of characters in avarbls.
      common /lvar/   avartag(nvarm)  ! Info about a variable, e.g, units.
      character*48    avartag         ! Info about a variable, e.g, units.
      common /lvar/   fvarmean        ! Mean value of a group of variables.
      common /lvar/   fvarstdd        ! Standard deviation from fvarmean.
      common /lvar/   fvarmin         ! Minimum value of a group of variables
      common /lvar/   fvarmax         ! Maximum value of a group of variables

c.... Data for named symbols.

      common /lsym/   nsymbs          ! Number of named symbols (<= nsymbm).
      common /lsym/   asymbl(nsymbm)  ! Name of a symbol.
      character*24    asymbl          ! Name of a symbol.
      common /lsym/   asymbr(nsymbm)  ! Replacement string of a symbol.
      character*80    asymbr          ! Replacement string of a symbol.
      common /lsym/   fsymb(nsymbm)   ! Floating point value of asymbr.
      common /lsym/   isymb(nsymbm)   ! Integer value of asymbr.
      common /lsym/   lsymb(nsymbm)   ! Number of characters in asymbr.
      common /lsym/   msymb(nsymbm)   ! Mode of asymbr (1, 2 or 3).
      common /lsym/   asymbls         ! Base name for symbols.
      character*24    asymbls         ! Base name for symbols.
      common /lsym/   lasymbls        ! Number of characters in asymbls.

c.... Data for points.

      common /lpoint/ npoints         ! Number of points (<= npointm).
      common /lpoint/ apoint(npointm) ! Name of a point.
      character*24    apoint          ! Name of a point.
      common /lpoint/ x(npointm)      ! X coordinate of a point.
      common /lpoint/ y(npointm)      ! Y coordinate of a point.
      common /lpoint/ z(npointm)      ! Z coordinate of a point.
      common /lpoint/ apoints         ! Base name for points.
      character*24    apoints         ! Base name for points.
      common /lpoint/ lapoint(npointm)! Number of characters in apoint.
      common /lpoint/ lapoints        ! Number of characters in apoints.

c.... Data for mesh size, block indices, and indices of mesh points.

      common /lmesh/  kmax            ! Maximum value of k index in mesh.
      common /lmesh/  lmax            ! Maximum value of l index in mesh.
      common /lmesh/  mmax            ! Maximum value of m index in mesh.
      common /lmesh/  kbl1            ! Minimum value of k index in mesh block.
      common /lmesh/  kbl2            ! Maximum value of k index in mesh block.
      common /lmesh/  lbl1            ! Minimum value of l index in mesh block.
      common /lmesh/  lbl2            ! Maximum value of l index in mesh block.
      common /lmesh/  mbl1            ! Minimum value of m index in mesh block.
      common /lmesh/  mbl2            ! Maximum value of m index in mesh block.
      common /lmesh/  kpoint(npointm) ! Mesh index k of a mesh point.
      common /lmesh/  lpoint(npointm) ! Mesh index l of a mesh point.
      common /lmesh/  mpoint(npointm) ! Mesh index m of a mesh point.

c.... Data for clusters of points.

      common /lclust/ nclusts         ! Number of point clusters (<= nclustm).
      common /lclust/ aclust(nclustm) ! Name of a cluster of points.
      character*24    aclust          ! Name of a cluster of points.
      common /lclust/ aclusts         ! Base name for clusters of points.
      character*24    aclusts         ! Base name for clusters of points.
      common /lclust/ laclusts        ! Number of characters in aclusts.

      common /lpairc/ npairs          ! Number of cluster pairs (<= npairm).
      common /lpairc/ apaircl(npairm) ! Name of the cluster for point apairpt.
      character*24    apaircl         ! Name of the cluster for point apairpt.
      common /lpairc/ apairpt(npairm) ! Name of a point for cluster apaircl.
      character*24    apairpt         ! Name of a point for cluster apaircl.
      common /lpairc/ laclust(nclustm)! Number of characters in aclust.

c.... Data for lines.

      common /lline/  nlines          ! Number of lines (<= nlinem).
      common /lline/  aline(nlinem)   ! Name of a line.
      character*24    aline           ! Name of a line.
      common /lline/  alipt1(nlinem)  ! Name of the point at beginning of line.
      character*24    alipt1          ! Name of the point at beginning of line.
      common /lline/  alipt2(nlinem)  ! Name of the point at end of line.
      character*24    alipt2          ! Name of the point at end of line.
      common /lline/  alines          ! Base name for lines.
      character*24    alines          ! Base name for lines.
      common /lline/  lalines         ! Number of characters in alines.
      common /lline/  lalipt1(nlinem) ! Number of characters in alipt1.
      common /lline/  lalipt2(nlinem) ! Number of characters in alipt2.

c.... Data for triangles.

      common /ltrig/  ntrigs          ! Number of triangles (<= ntrigm).
      common /ltrig/  atrig(ntrigm)   ! Name of a triangle.
      character*24    atrig           ! Name of a triangle.
      common /ltrig/  atript1(ntrigm) ! Name of a vertex point of the triangle.
      character*24    atript1         ! Name of a vertex point of the triangle.
      common /ltrig/  atript2(ntrigm) ! Name of a vertex point of the triangle.
      character*24    atript2         ! Name of a vertex point of the triangle.
      common /ltrig/  atript3(ntrigm) ! Name of a vertex point of the triangle.
      character*24    atript3         ! Name of a vertex point of the triangle.
      common /ltrig/  atrigs          ! Base name for triangles.
      character*24    atrigs          ! Base name for triangles.
      common /ltrig/  latrigs         ! Number of characters in atrigs.
      common /ltrig/  latript1(ntrigm) ! Number of characters in atript1.
      common /ltrig/  latript2(ntrigm) ! Number of characters in atript2.
      common /ltrig/  latript3(ntrigm) ! Number of characters in atript3.

c.... Data for regular polygons.

      common /lpolyg/ npolygs         ! Number of regular polygons (<= npolygm).
      common /lpolyg/ apolyg(npolygm) ! Name of a regular polygon.
      character*24    apolyg          ! Name of a regular polygon.
      common /lpolyg/ nverpg(npolygm) ! Number of regular polygon vertices.
      common /lpolyg/ acenpg(npolygm) ! Name of a regular polygon center point.
      character*24    acenpg          ! Name of a regular polygon center point.
      common /lpolyg/ averpg(npolygm) ! Name of a regular polygon vertex point.
      character*24    averpg          ! Name of a regular polygon vertex point.
      common /lpolyg/ acoppg(npolygm) ! Name of a regular polygon coplanar pt.
      character*24    acoppg          ! Name of a regular polygon coplanar pt.
      common /lpolyg/ apolygs         ! Base name for regular polygons.
      character*24    apolygs         ! Base name for regular polygons.
      common /lpolyg/ lapolygs        ! Number of characters in apolygs.

c.... Data for one regular polygon (last one processed in pgout).

      common /lpolyg/ xver(nverpgm)   ! X coord of vertices of regular polygon.
      common /lpolyg/ yver(nverpgm)   ! Y coord of vertices of regular polygon.
      common /lpolyg/ zver(nverpgm)   ! Z coord of vertices of regular polygon.
      common /lpolyg/ nverpgs         ! Number of vertices of last reg polygon.

c.... Data for annular disks.

      common /ldisk/  ndisks          ! Number of annular disks (<= ndiskm).
      common /ldisk/  adisk(ndiskm)   ! Name of an annular disk.
      character*24    adisk           ! Name of an annular disk.
      common /ldisk/  radkin(ndiskm)  ! Inner radius of annular disk.
      common /ldisk/  radkout(ndiskm) ! Outer radius of annular disk.
      common /ldisk/  acendk(ndiskm)  ! Name of an annular disk center point.
      character*24    acendk          ! Name of an annular disk center point.
      common /ldisk/  xnormdk(ndiskm) ! X component of normal vector to disk.
      common /ldisk/  ynormdk(ndiskm) ! Y component of normal vector to disk.
      common /ldisk/  znormdk(ndiskm) ! Z component of normal vector to disk.
      common /ldisk/  adisks          ! Base name for annular disks.
      character*24    adisks          ! Base name for annular disks.
      common /ldisk/  ladisks         ! Number of characters in adisks.

c.... Data for tetrahedrons.

      common /ltetr/  ntets           ! Number of tetrahedrons (<= ntetm).
      common /ltetr/  atetra(ntetm)   ! Name of a tetrahedron.
      character*24    atetra          ! Name of a tetrahedron.
      common /ltetr/  atetpt(4,ntetm) ! Name of a vertex point of tetrahedron.
      character*24    atetpt          ! Name of a vertex point of tetrahedron.
      common /ltetr/  voltet(ntetm)   ! Volume of a tetrahedron.
      common /ltetr/  atetras         ! Base name for tetrahedrons.
      character*24    atetras         ! Base name for tetrahedrons.
      common /ltetr/  latetras        ! Number of characters in atetras.
      common /ltetr/  latetpt(4,ntetm) ! Number of characters in atetpt.

c.... Data for regular polyhedrons.

      common /lpolyh/ npolyhs         ! Number of regular polyhedrons
                                      ! (<= npolyhm).
      common /lpolyh/ apolyh(npolyhm) ! Name of a regular polyhedron.
      character*24    apolyh          ! Name of a regular polyhedron.
      common /lpolyh/ atypeh(npolyhm) ! Type of a regular polyhedron.
      character*24    atypeh          ! Type of a regular polyhedron.
      common /lpolyh/ nverph(npolyhm) ! Number of regular polyhedron vertices.
      common /lpolyh/ nedgph(npolyhm) ! Number of regular polyhedron edges.
      common /lpolyh/ acenph(npolyhm) ! Name of a regular polyhedron center pt.
      character*24    acenph          ! Name of a regular polyhedron center pt.
      common /lpolyh/ averph(npolyhm) ! Name of a regular polyhedron vertex pt.
      character*24    averph          ! Name of a regular polyhedron vertex pt.
      common /lpolyh/ acopph(npolyhm) ! Name of regular polyhedron coplanar pt.
      character*24    acopph          ! Name of regular polyhedron coplanar pt.
      common /lpolyh/ apolyhs         ! Base name for regular polyhedrons.
      character*24    apolyhs         ! Base name for regular polyhedrons.

c.... Data for one regular polyhedron (last one processed in phout).

      common /lpolyh/ xverh(20)       ! X coord of vertices of reg polyhedron.
      common /lpolyh/ yverh(20)       ! Y coord of vertices of reg polyhedron.
      common /lpolyh/ zverh(20)       ! Z coord of vertices of reg polyhedron.
      common /lpolyh/ nver1(30)       ! Index of first vertex of an edge.
      common /lpolyh/ nver2(30)       ! Index of first vertex of an edge.
      common /lpolyh/ lapolyhs        ! Number of characters in apolyhs.
      common /lpolyh/ nverphs         ! Number of vertices in last polyhedron.
      common /lpolyh/ nedgphs         ! Number of edges in last polyhedron.

c.... Data for bricks.

      common /lbrick/ nbricks         ! Number of bricks (<= nbrickm).
      common /lbrick/ abrick(nbrickm) ! Name of a brick.
      character*24    abrick          ! Name of a brick.
      common /lbrick/ asysbr(nbrickm) ! Coordinate system of brick.
      character*24    asysbr          ! Coordinate system of brick.
      common /lbrick/ angbr(nbrickm)  ! Angle units of brick.
      character*24    angbr           ! Angle units of brick.
      common /lbrick/ ubr(nbrickm)    ! Lesser U coordinate of brick surface.
      common /lbrick/ dubr(nbrickm)   ! U increment between brick surfaces.
      common /lbrick/ vbr(nbrickm)    ! Lesser V coordinate of brick.
      common /lbrick/ dvbr(nbrickm)   ! V increment between brick surfaces.
      common /lbrick/ wbr(nbrickm)    ! Lesser W coordinate of brick.
      common /lbrick/ dwbr(nbrickm)   ! W increment between brick surfaces.
      common /lbrick/ volbr(nbrickm)  ! Volume of a brick.
      common /lbrick/ abricks         ! Base name for bricks.
      character*24    abricks         ! Base name for bricks.
      common /lbrick/ labricks        ! Number of characters in abricks.

c.... Data for quadric surfaces, including planes, spheres, circular cylinders,
c....   circular cones, ellipsoids, axisymmetric quadric surfaces and general
c....   quadric surfaces.
c....   The equation of the quadric surface is:
c....   qc + qx*x + qy*y + qz*z + qxy*x*y + qyz*y*z + qzx*z*x +
c....   qxx*x**2 + qyy*y**2 + qzz*z**2 = 0

      common /lquad/  aqtypes(0:24)   ! Quadric surface types, standard form.
      character*64    aqtypes         ! Quadric surface types, standard form.

      common /lquad/  nquads          ! Number of quadric surfaces (<= nquadm).
      common /lquad/  aquad(nquadm)   ! Name of a quadric surface.
      character*24    aquad           ! Name of a quadric surface.
      common /lquad/  aqtype(nquadm)  ! Type of quadric surface.
      character*64    aqtype          ! Type of quadric surface.
      common /lquad/  aqform(nquadm)  ! Form of quadric surface.
      character*64    aqform          ! Form of quadric surface.
      common /lquad/  asym(nquadm)    ! Blank or "axisymmetric".
      character*24    asym            ! Blank or "axisymmetric".
      common /lquad/  xcen(nquadm)    ! X coordinate of center of quadric.
      common /lquad/  ycen(nquadm)    ! Y coordinate of center of quadric.
      common /lquad/  zcen(nquadm)    ! Z coordinate of center of quadric.
      common /lquad/  qc(nquadm)      ! Coefficient of constant term.
      common /lquad/  qx(nquadm)      ! Coefficient of x term.
      common /lquad/  qy(nquadm)      ! Coefficient of y term.
      common /lquad/  qz(nquadm)      ! Coefficient of z term.
      common /lquad/  qxy(nquadm)     ! Coefficient of x * y term.
      common /lquad/  qyz(nquadm)     ! Coefficient of y * z term.
      common /lquad/  qzx(nquadm)     ! Coefficient of z * x term.
      common /lquad/  qxx(nquadm)     ! Coefficient of x**2 term.
      common /lquad/  qyy(nquadm)     ! Coefficient of y**2 term.
      common /lquad/  qzz(nquadm)     ! Coefficient of z**2 term.
      common /lquad/  aquads          ! Base name for quadric surfaces.
      character*24    aquads          ! Base name for quadric surfaces.
      common /lquad/  aplanes         ! Base name for planes.
      character*24    aplanes         ! Base name for planes.
      common /lquad/  aspheres        ! Base name for spheres.
      character*24    aspheres        ! Base name for spheres.
      common /lquad/  acyls           ! Base name for cylinders.
      character*24    acyls           ! Base name for cylinders.
      common /lquad/  acones          ! Base name for cones.
      character*24    acones          ! Base name for cones.
      common /lquad/  aellips         ! Base name for ellipsoids.
      character*24    aellips         ! Base name for ellipsoids.
      common /lquad/  axisyms         ! Base name for axisymmetric surfaces.
      character*24    axisyms         ! Base name for axisymmetric surfaces.
      common /lquad/  ahyperbs        ! Base name for hyperbolic paraboloids.
      character*24    ahyperbs        ! Base name for hyperbolic paraboloids.
      common /lquad/  dcen(nquadm)    ! Distance, origin to center of quadric.

c.... Data for one quadric surface (last one processed in quout).

      common /lquad/  rotq(3,3)       ! Principle axis rotation matrix.

c.... Number of characters in names of quadric surfaces.

      common /lquad/  laquad(nquadm)  ! Number of characters in aquad.

c.... Number of characters in base names for quadric surface types.

      common /lquad/  laquads         ! Number of characters in aquads.
      common /lquad/  laplanes        ! Number of characters in aplanes.
      common /lquad/  laspheres       ! Number of characters in aspheres.
      common /lquad/  lacyls          ! Number of characters in acyls.
      common /lquad/  lacones         ! Number of characters in acones.
      common /lquad/  laellips        ! Number of characters in aellips.
      common /lquad/  laxisyms        ! Number of characters in axisyms.
      common /lquad/  lahyperbs       ! Number of characters in ahyperbs.

c.... Data for zones.

      common /lzone/  nzones          ! Number of zones (<= nzonem).
      common /lzone/  azone(nzonem)   ! Name of a zone.
      character*24    azone           ! Name of a zone.
      common /lzone/  nzquads(nzonem) ! Number of quadrics bounding zone.
      common /lzone/  azquad(nzquadm,nzonem)
                                      ! Name of a quadric bounding zone.
      character*24    azquad          ! Name of a quadric bounding zone.
      common /lzone/  azsign(nzquadm,nzonem)
                                      ! Side of quadric exit is toward (+ or -).
      character*1     azsign          ! Side of quadric exit is toward (+ or -).
      common /lzone/  volz(nzonem)    ! Estimated volume of zone.
      common /lzone/  volzerr(nzonem) ! Estimated error in volume of zone.
      common /lzone/  azones          ! Base name for zones.
      character*24    azones          ! Base name for zones.
      common /lzone/  lazones         ! Number of characters in azones.
      common /lzone/  lazquad(nzquadm,nzonem)
                                      ! Number of characters in azquad.

c.... Data for vectors.

      common /lvect/  nvectors        ! Number of vectors (<= nvectm).
      common /lvect/  avector(nvectm) ! Name of a vector.
      character*24    avector         ! Name of a vector.
      common /lvect/  xcom(nvectm)    ! X component of vector.
      common /lvect/  ycom(nvectm)    ! Y component of vector.
      common /lvect/  zcom(nvectm)    ! Z component of vector.
      common /lvect/  xbnd(nvectm)    ! X coordinate of bound point of vector.
      common /lvect/  ybnd(nvectm)    ! Y coordinate of bound point of vector.
      common /lvect/  zbnd(nvectm)    ! Z coordinate of bound point of vector.
      common /lvect/  vlen(nvectm)    ! Length of vector.
      common /lvect/  avectors        ! Base name for vectors.
      character*24    avectors        ! Base name for vectors.
      common /lvect/  lavector(nvectm)! Number of characters in avector.
      common /lvect/  lavectors       ! Number of characters in avectors.

c.... Data for operators.

      common /loper/  nopers          ! Number of operators (<= noperm).
      common /loper/  aoper(noperm)   ! Name of an operator.
      character*24    aoper           ! Name of an operator.
      common /loper/  aoptype(noperm) ! Type of an operator.
      character*16    aoptype         ! Type of an operator.
      common /loper/  aoptyps(noperm) ! Subtype of an operator.
      character*16    aoptyps         ! Subtype of an operator.
      common /loper/  toper(3,3,noperm) ! Tensor operator.
      common /loper/  topin(3,3,noperm) ! Tensor operator inverse.
      common /loper/  aopers          ! Base name for operators.
      character*24    aopers          ! Base name for operators.
      common /loper/  laopers         ! Number of characters in aopers.

c.... Data for probability bins.

      common /lbin/   nbins           ! Number of probability bins (<= nbinm).
      common /lbin/   abin(nbinm)     ! Name of a probability bin.
      character*24    abin            ! Name of a probability bin.
      common /lbin/   atypeb(nbinm)   ! Type of a probability bin.
      character*24    atypeb          ! Type of a probability bin.
      common /lbin/   probl(nbinm)    ! Differential rel prob of bin, at vranl.
      common /lbin/   probr(nbinm)    ! Differential rel prob of bin, at vranr.
      common /lbin/   vranl(nbinm)    ! Minimum value of random variable.
      common /lbin/   vranr(nbinm)    ! Maximum value of random variable.
      common /lbin/   prbin(nbinm)    ! Total relative probability of bin.
      common /lbin/   prbint(nbinm)   ! Temporary total rel prob of bin.
      common /lbin/   conbin(nbinm)   ! Constant in probability function.
      common /lbin/   cosbin(nbinm)   ! Constant in probability function.
      common /lbin/   vexbin(nbinm)   ! Expected value of random variable.
      common /lbin/   nsampb(nbinm)   ! Number of times bin sampled.
      common /lbin/   abins           ! Base name for probability bins.
      character*24    abins           ! Base name for probability bins.
      common /lbin/   labins          ! Number of characters in abins.

c.... Data for probability distribution functions.

      common /lpdf/   npdfs           ! Number of pdfs (<= npdfm).
      common /lpdf/   apdf(npdfm)     ! Name of a pdf.
      character*24    apdf            ! Name of a pdf.
      common /lpdf/   prpdf(npdfm)    ! Total relative probability of pdf.
      common /lpdf/   prpdft(npdfm)   ! Temporary total rel prob of pdf.
      common /lpdf/   vexpdf(npdfm)   ! Expected value of random variable.
      common /lpdf/   apdfs           ! Base name for pdfs.
      character*24    apdfs           ! Base name for pdfs.
      common /lpdf/   nbinpdf(npdfm)  ! Number of bins in pdf.
      common /lpdf/   lapdfs          ! Number of characters in apdfs.

      common /lpairp/ npdfxs          ! Number of pdf/bin pairs (<= npdfxm).
      common /lpairp/ apdfx(npdfxm)   ! Name of the pdf for bin abinx.
      character*24    apdfx           ! Name of the pdf for bin abinx.
      common /lpairp/ abinx(npdfxm)   ! Name of a bin for pdf apdfx.
      character*24    abinx           ! Name of a bin for pdf apdfx.

c.... Last distance found in subroutine accelerate, distance, ptdist, track
c....    or walk.

      common /ldist/  pdist           ! Distance between last two objects.

c.... Last proximal point and proximal vector found in subroutine distance,
c....   intspcy, prox, ptdist, track or triple.

      common /lproxl/ proxptx         ! Coordinate x of last proximal point.
      common /lproxl/ proxpty         ! Coordinate y of last proximal point.
      common /lproxl/ proxptz         ! Coordinate z of last proximal point.
      common /lproxl/ proxvx          ! Component x of last proximal vector.
      common /lproxl/ proxvy          ! Component y of last proximal vector.
      common /lproxl/ proxvz          ! Component z of last proximal vector.

c.... Synonyms for commands and key words.

      common /lsynp/  nsyns           ! Number of synonyms.
      common /lsynp/  asyn1(nsynm)    ! First  of a synonym pair.
      character*24    asyn1           ! First  of a synonym pair.
      common /lsynp/  asyn2(nsynm)    ! Second of a synonym pair.
      character*24    asyn2           ! Second of a synonym pair.
      common /lsynp/  asyncmd(nsynm)  ! Command name.
      character*24    asyncmd         ! Command name.

c.... Temporary tables.

      common /ltemp/  ntemps          ! Number of temporary data sets.
      common /ltemp/  atempa(ntempm)  ! Temporary character string.
      character*24    atempa          ! Temporary character string.
      common /ltemp/  atempb(ntempm)  ! Temporary character string.
      character*24    atempb          ! Temporary character string.
      common /ltemp/  ftempa(ntempm)  ! Temporary floating point number.
      common /ltemp/  ftempb(ntempm)  ! Temporary floating point number.
      common /ltemp/  itempa(ntempm)  ! Temporary integer.
      common /ltemp/  itempb(ntempm)  ! Temporary integer.

c.... Data for do loops.

      common /lloop/  nloop           ! Index of current do loop.  Max 16.
      common /lloop/  nlnest          ! Current number of nested do loops.
      common /lloop/  ilbeg(nloopm)   ! First line of loop in command file.
      common /lloop/  avarl(nloopm)   ! Loop variable name.
      character*24    avarl           ! Loop variable name.
      common /lloop/  nlbeg(nloopm)   ! Initial value of loop variable.
      common /lloop/  nlend(nloopm)   ! Final   value of loop variable.
      common /lloop/  nlinc(nloopm)   ! Increment in value of loop variable.
      common /lloop/  nlnow(nloopm)   ! Current value of loop variable.
      common /lloop/  lvarl(nloopm)   ! Length of name avarl.

c.... Data for big integers.

      common /lbig/   idig(ndigm,nbigm)
                                      ! Decimal digits of big integer nbig.
      common /lbig/   ndig(nbigm)     ! Number of digits in big integer nbig.
      common /lbig/   abigtag(nbigm)  ! Tag describing big integer nbig.
      character*32    abigtag         ! Tag describing big integer nbig.
      common /lbig/   abig(nbigm)     ! Name of big integer nbig = 1, nbigm.
      character*1     abig            ! Name of big integer nbig = 1, nbigm.
      common /lbig/   abigs           ! Base name for big integers.
      character*1     abigs           ! Base name for big integers.
      common /lbig/   asign(nbigm)    ! Sign of result of a subtraction.
      character*1     asign           ! Sign of result of a subtraction.

c.... Data for sudoku puzzle.

      common /lsudo/  ncells          ! Number of cells successfully filled.
      common /lsudo/  acell(9,9)      ! Characters put into cells.
      character*1     acell           ! Characters put into cells.
      common /lsudo/  achars(0:9)     ! Set of 10 characters to put in cells.
      character*1     achars          ! Set of 10 characters to put in cells.

c     endcliche                       ! store.
