      subroutine tolset

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  tolset   Updated     1997 September 22 17:40.
c               tolset   Originated  1993 November 23 13:00
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To specify a new value of tol, the truncation and round-off
c               control.
c
c     Logic:    Entry points:  tolset.
c tolset        Called by:  helpall, main.
c
c tolset        Calls:  varfind.
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Initialize.

      if (nword .eq. 0) then
        tol = tolz
        go to 999
      endif

c=======================================================================********

c.... Input line:  tol

c.... Display the value of tol.

      if (nword .eq. 1) then
        go to 140
      endif

c=======================================================================********

c.... Input line:  tol help

 8110 format ('  Command "tol":  acceptable input lines include:' /
     &  '  "tol help"      Display this message.' //
     &  '  "tol"           Display the value of tol.' //
     &  '  "tol [=] TOL"   Change the value of tol to TOL.' /
     &  '     Must be 0, or between',1pe7.0,' and 1.E-3.  Default is',
     &  1pe7.0,'.' )

      if ((nword .eq. 2) .and.
     &   ((aword(2) .eq. 'help') .or.
     &    (aword(2) .eq. 'h')))  then
        write (   6, 8110) tolmin, tolz
        write (iout, 8110) tolmin, tolz
        go to 999
      endif

c=======================================================================********

c.... Test input for validity.

 8120 format ('  tolset ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of words on "tol" line not 2:  ',i3)

      if ((nword .eq. 3) .and. (aword(2) .eq. '=')) then
        nword = nword - 1
        mtype(2) = mtype(3)
        aword(2) = aword(3)
        fword(2) = fword(3)
        iword(2) = iword(3)
      endif

      if (nword .ne. 2) then
        write (   6, 8120) ainput, ninput, nword
        write (iout, 8120) ainput, ninput, nword
        go to 999
      endif

c=======================================================================********

c.... Input line:  tol   TOL
c.... Input line:  tol = TOL

c.... Find the new value of tol.

 8130 format ('  tolset ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Word 2 not integer or floating point value or variable:  ',a)

      call varfind (2, 2)

      if ((mtype(2) .ne. 2) .and. (mtype(2) .ne. 3)) then
        write (   6, 8130) ainput, ninput, aword(2)
        write (iout, 8130) ainput, ninput, aword(2)
        go to 999
      endif

      tol = fword(2)

c.... Test for a reasonable value of tol.

 8140 format ('  tolset ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  TOL not between 0 and 1.e-3:  ',1pe20.12)

  140 if ((tol .lt. 0.0) .or. (tol .gt. 1.e-3)) then
        write (   6, 8140) ainput, ninput, tol
        write (iout, 8140) ainput, ninput, tol
        tol = tolz
      endif

 8145 format ('  tolset ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  TOL not zero, less than tolmin:  ',1pe20.12)

      if ((tol .gt. 0.0) .and. (tol .lt. 1.e-15)) then
        write (   6, 8145) ainput, ninput, tol
        write (iout, 8145) ainput, ninput, tol
        tol = tolmin
      endif

c.... Print the new value of tol.

 8150 format ('tol = ',12x,1pe20.12)

      write (   6, 8150) tol
      write (iout, 8150) tol

c=======================================================================********

  999 return

c.... End of subroutine tolset.       (+1 line)
      end
