      subroutine tristore (nrep, n)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  tristore Updated     1995 June 26 17:50.
c               tristore Originated  1995 June 26 17:50.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find the index in the triangle array in which to store the
c               triangle being created.
c
c     Logic:    Entry points:  tristore.
c tristore      Called by:  triangle.
c
c tristore      Calls:  lout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     n         Output   0 if triangle array is full.  No room for a new triangle.
c                          Positive if the index where the new triangle is to
c                          be stored.
c
c     nrep      Output   0 if triangle name is new, 1 if an old triangle with the
c                          same name is being replaced.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      n = 0

c.... See if the triangle name already exists.

 8110 format ('  WARNING:  replacing existing triangle:  ',a)

      nrep = 0

      do 110 nt = 1, ntrigs
        if (aword(2) .eq. atrig(nt)) then
          nrep = 1
          n    = nt
          write (   6, 8110) atrig(nt)
          write (iout, 8110) atrig(nt)
          call lout (nt, nt)
          go to 999
        endif
  110 continue

c.... See if a null triangle can be replaced.

      do 120 nt = 1, ntrigs
        if (atrig(n) .eq. ' ') then
          n = nt
          go to 999
        endif
  120 continue

c.... See if the maximum number of triangles has been exceeded.

 8130 format ('  tristore ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of triangles exceeds limit ',i5)

      if ((ntrigs + 1) .gt. ntrigm) then
        write (   6, 8130) ainput, ninput, ntrigm
        write (iout, 8130) ainput, ninput, ntrigm
        n = 0
        go to 999
      endif

c.... Add a new triangle at the end of the list.

      ntrigs = ntrigs + 1

      n = ntrigs

  999 return

c.... End of subroutine tristore.     (+1 line)
      end
