      subroutine varout (n1, n2)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  varout   Updated     2004 November 15 17:00.
c               varout   Originated  1994 July 29 15:10.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To display the value of variables n1 to n2.
c
c     Logic:    Entry points:  varout.
c varout        Called by:  angles, copy, delete, indo, renamea, renamex,
c               search, subsrepl, symbol, varfind, variable, varstore.
c               Calls:  (none).
c
c     Biblio:   ?
c
c     Glossary:
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

c.... Initialize.

      nn1 = n1
      nn2 = n2
      if (nn1 .lt. 1) nn1 = 1
      if (nn2 .gt. nvars) nn2 = nvars

 8101 format ('var    ',a,' = ',a,6x,'! (ASCII)')
 8102 format ('var    ',a,' = ',i20,'  ! (integer)')
 8112 format ('var    ',a,' = ',i23,'  ! (integer)')
 8103 format ('var    ',a,' = ',1pe20.12,'  ! (floating point)')
 8113 format ('var    ',a,' = ',1pe23.15,'  ! (floating point)')
 8115 format ('  varout ERROR.  Reading ',a40,' line ',i5,'.' /
     &    '  Variable is not integer or floating point:  ')
 8210 format ('var    ',a,' tag = ',a)

      do 110 n = nn1, nn2          ! Loop over variables to be displayed.
        if (avarbl(n) .eq. ' ') go to 110

        if (mvar(n) .eq. 1) then                       ! ASCII.  NOT ALLOWED.
          write (   6, 8115) ainput, ninput, avarbl(n)
          write (iout, 8115) ainput, ninput, avarbl(n)
          write (   6, 8101) avarbl(n), avar(n)
          write (iout, 8101) avarbl(n), avar(n)
          go to 110
        elseif (mvar(n) .eq. 2) then                   ! Integer.
          if (tol .le. 1.e-15) then
            write (   6, 8112) avarbl(n), ivar(n)
            write (iout, 8112) avarbl(n), ivar(n)
          else
            write (   6, 8102) avarbl(n), ivar(n)
            write (iout, 8102) avarbl(n), ivar(n)
          endif
          if (abs (fvar(n)) .gt. 1.e6) then
            if (tol .le. 1.e-15) then
              write (   6, 8113) avarbl(n), fvar(n)
              write (iout, 8113) avarbl(n), fvar(n)
            else
              write (   6, 8103) avarbl(n), fvar(n)
              write (iout, 8103) avarbl(n), fvar(n)
            endif
          endif
        else                                              ! Floating point.
          if (tol .le. 1.e-15) then
            write (   6, 8113) avarbl(n), fvar(n)
            write (iout, 8113) avarbl(n), fvar(n)
          else
            write (   6, 8103) avarbl(n), fvar(n)
            write (iout, 8103) avarbl(n), fvar(n)
          endif
        endif

        if (avartag(n) .ne. ' ') then
          write (   6, 8210) avarbl(n), avartag(n)
          write (iout, 8210) avarbl(n), avartag(n)
        endif

  110 continue                        ! End of loop over variables.

  999 return

c.... End of subroutine varout.       (+1 line)
      end
