      subroutine vstore (nrep, n)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  vstore   Updated     1995 February 16 13:10.
c               vstore   Originated  1994 August 2 16:10.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find the index in the vector array in which to store the
c               vector being created.
c
c     Logic:    Entry points:  vstore.
c vstore        Called by:  vector, voper.
c
c vstore        Calls:  vout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     n         Output   0 if vector array is full.  No room for a new vector.
c                          Positive if the index where the new vector is to
c                          be stored.
c
c     nrep      Output   0 if vector name is new, 1 if an old vector with the
c                          same name is being replaced.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      n = 0

c.... See if the vector name already exists.

 8110 format ('  WARNING:  replacing existing vector:  ',a)

      nrep = 0

      do 110 nv = 1, nvectors
        if (aword(2) .eq. avector(nv)) then
          nrep = 1
          n    = nv
          write (   6, 8110) avector(n)
          write (iout, 8110) avector(n)
          call vout (n, n)
          go to 999
        endif
  110 continue

c.... See if a null vector can be replaced.

      do 120 nv = 1, nvectors
        if (avector(nv) .eq. ' ') then
          n = nv
          go to 999
        endif
  120 continue

c.... See if the vector can be added at the end of the list.

c.... See if the maximum number of vectors has been exceeded.

 8130 format ('  vstore ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of vectors exceeds limit ',i5)

      if ((nvectors + 1) .gt. nvectm) then
        write (   6, 8130) ainput, ninput, nvectm
        write (iout, 8130) ainput, ninput, nvectm
        n = 0
        go to 999
      endif

c.... Add a new vector at the end of the list.

      nvectors = nvectors + 1

      n = nvectors

c=======================================================================********

  999 return

c.... End of subroutine vstore.       (+1 line)
      end
