      subroutine znstore (nrep, n)

c*s
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Version:  znstore  Updated     1996 December 20 17:20.
c               znstore  Originated  1994 August  1 13:10.
c
c     Author:   Arthur L. Edwards, L-298, x-24123.
c
c     Purpose:  To find the index in the zone array in which to store the
c               zone being created.
c
c     Logic:    Entry points:  znstore.
c znstore       Called by:  znmake, zone.
c
c znstore       Calls:  zout.
c
c     Biblio:   ?
c
c     Glossary:
c
c     n         Output   0 if zone array is full.  No room for a new zone.
c                          Positive if the index where the new zone is to
c                          be stored.
c
c     nrep      Output   0 if zone name is new, 1 if an old zone with the
c                          same name is being replaced.
c
c     History:
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c/c

      include 'store.h'

      character*8 amount              ! Amount of output data.

      n = 0

c.... See if the zone name already exists.

 8110 format ('  WARNING:  replacing existing zone:  ',a)

      nrep = 0

      do 110 nz = 1, nzones
        if (aword(2) .eq. azone(nz)) then
          nrep = 1
          n = nz
          write (   6, 8110) azone(nz)
          write (iout, 8110) azone(nz)
          amount = 'minimum'
          call zout (nz, nz, amount)
          go to 999
        endif
  110 continue

c.... See if a null zone can be replaced.

      do 120 nz = 1, nzones
        if (azone(nz) .eq. ' ') then
          n = nz
          go to 999
        endif
  120 continue

c.... See if the maximum number of zones has been exceeded.

 8130 format ('  znstore ERROR.  Reading ',a40,' line ',i5,'.' /
     &  '  Number of zones exceeds limit ',i5)

      if ((nzones + 1) .gt. nzonem) then
        write (   6, 8130) ainput, ninput, nzonem
        write (iout, 8130) ainput, ninput, nzonem
        n = 0
        go to 999
      endif

c.... Add a new zone at the end of the list.

      nzones = nzones + 1

      n = nzones

c=======================================================================********

  999 return

c.... End of subroutine znstore.      (+1 line)
      end
